pluginName=plugin:GetName()
importPath=string.gsub(getfenv(1)._.Name,"%.Main","").."."

-- to do
-- add the fixed string values (error messages) in Options Windows to Resource[] translations

-- change BDDLegend to a generic OverlayLegend, add ability to maintain the legend image, update default overlays with a new legend value

-- for RoR, add new craft node tiers (starting at line 447) for filtering, add Tier list to Annotation window, get coords for interior maps (for breadcrumb/position display), implement more interior maps

-- foreign language support, need french and german translations of String.lua, especially the EXACT map names from the client


import (importPath.."Class");
import (importPath.."VindarPatch");
-- This is the Load/Save patch which accounts for European formats, written by Vindar
-- load resource strings - this MUST occur before any windows that use strings get loaded or there will be no defaults
import (importPath.."Strings");
import (importPath.."Table");
--import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
cmds=Turbine.Shell.GetCommands()
import (importPath.."FontMetric");
import (importPath.."DropDownList");
import (importPath.."AnnotationsWindow");
import (importPath.."MinimizedWindow");
import (importPath.."PopUpDialog");
import (importPath.."RadioButtonGroup");
import (importPath.."DebugWindow");
import (importPath.."ColorPicker");
import (importPath.."Search");

language=1;
locale = "en";
if Turbine.Shell.IsCommand("hilfe") then
	locale = "de";
	language=3;
elseif Turbine.Shell.IsCommand("aide") then
	locale = "fr";
	language=2;
end
if (tonumber("1,000")==1) then
	function euroNormalize(value)
		return tonumber((string.gsub(value,"%.",",")));
	end
else
	function euroNormalize(value)
		return tonumber((string.gsub(value,",",".")));
	end
end

EnableWaypoint=false;
WaypointInstalled=false;
WaypointRunning=false;

trimColor=Turbine.UI.Color(.2,.5,.9);
fontColor=Turbine.UI.Color(1,.9,.5);
backColor=Turbine.UI.Color(.05,.05,.05);
headingsColor=Turbine.UI.Color(1,1,1);
listTextColor=Turbine.UI.Color(1,1,1);

debug=false;
debugSetting=PatchDataLoad( Turbine.DataScope.Account, "MM_Debug");
if debugSetting~=nil then
	debug=debugSetting;
end
NumCustomAnnot=0;
NumDefaultAnnot=0;
LoadedMapID=1;
defaultMap=-2;
HUDVisible=true;
PopUpVis=false
MapVis=false;
MinVis=false;
QuickVis=false;
OverlayVis=false;
BDDVis=false;
BreadcrumbVis=false;
SearchVis=false;
displayWidth=Turbine.UI.Display:GetWidth()
displayHeight=Turbine.UI.Display:GetHeight()

saveOverlays=true;

colorGold=Turbine.UI.Color(.80,.60,.1);
colorSilver=Turbine.UI.Color(.75,.75,.75);
colorDarkGrey=Turbine.UI.Color(.1,.1,.1);
breadcrumbColor=Turbine.UI.Color(1,0,0);

fontFace=Turbine.UI.Lotro.Font.TrajanPro14;
dataLoadError=false;
saveSettings=true;
priorDataVersion=nil;
worldName="Landroval";
resolutionKey=tostring(displayWidth).."x"..tostring(displayHeight)

localPlayer=Turbine.Gameplay.LocalPlayer.GetInstance();
currentCharacterName=string.gsub(localPlayer:GetName(),"~","_");
undefinedCategoryIndex=1;
loadingDefaults=0;

annotations={};
mapStrings={};
-- all annotations have the form:{Map ID, X, Y, Z, H, V, Icon (either resourceID or path), Type, TextID, Description}
-- Annotation Type follows the Map Filter types plus the Creep specific "Map In"
-- TextID is only valid for the defaults and will allow using the appropriately translated text value from Resource
mapInfo={};
-- mapInfo is in the form {MapName,Height,Width,HFactor,HOffset,WFactor,WOffset}
-- HFactor and HOffset are used in the conversion from map coordinates to pixels: X=Height*HFactor+HOffset will convert coordinate "Height" to pixel "X"
overlays={};
-- overlays are in the format:{mapID,overlayName,path,width,height,left,top,shown,layer,opacity} where mapID is the id of one of the built-in maps, overlayName is the displayed name of the overlay and path is the path relative to the "GaranStuff/MoorMap/Overlays" folder

import "GaranStuff.MoorMap.OverlayWindow";

iconInfo={};

replaceStr={[128]="A",[129]="A",[130]="A",[131]="A",[132]="A",[133]="A",[134]="AE",[135]="C",[136]="E",[137]="E",[138]="E",[139]="E",[140]="I",[141]="I",[142]="I",[143]="I",[144]="",[145]="N",[146]="O",[147]="O",[148]="O",[149]="O",[150]="O",[151]="",[152]="O",[153]="U",[154]="U",[155]="U",[156]="U",[157]="Y",[158]="Y",[159]="sz",[160]="a",[161]="a",[162]="a",[163]="a",[164]="a",[165]="a",[166]="ae",[167]="c",[168]="e",[169]="e",[170]="e",[171]="e",[172]="i",[173]="i",[174]="i",[175]="i",[176]="o",[177]="n",[178]="o",[179]="o",[180]="o",[181]="o",[182]="o",[183]="",[184]="o",[185]="u",[186]="u",[187]="u",[188]="u",[189]="y",[190]="y",[191]="y"}
string.stripaccent=function(str)
	local ret = "";
	if str~=nil then
		ret=""
		local replace=false
		for i,v in ipairs({str:byte(1,-1)}) do
			if replace then
				replace=false
				if replaceStr[v]~=nil then
					ret=ret..replaceStr[v]
				end
			else
				if (v==195) then
					replace=true
				else
					ret = ret .. string.char(v);
				end
			end
		end
	end
	return ret;
end
string.split=function(str,separator)
	local tmpArray={};
	local tmpElem;
	str=tostring(str);
	if string.find("^$()%.[]*+-?",separator,1,true)~=nil then separator="%"..separator end
	for tmpElem in string.gmatch(str,"[^"..separator.."]*") do
		table.insert(tmpArray,tmpElem);
	end
	local tmpIndex=1;
	while tmpIndex<=#tmpArray do
		if tmpIndex==#tmpArray and tmpArray[tmpIndex]=="" then
			table.remove(tmpArray,tmpIndex);
		else
			if tmpArray[tmpIndex]=="" and tmpArray[tmpIndex+1]~="" then
				table.remove(tmpArray,tmpIndex);
			else
				tmpIndex=tmpIndex+1;
			end
		end
	end
	return tmpArray;
end
string.ltrim=function(str)
	return (string.gsub(str, "^%s*(.-)", "%1"))
end
string.rtrim=function(str)
	return (string.gsub(str, "^(.-)%s*$", "%1"))
end
string.trim=function(str)
	return (string.gsub(str, "^%s*(.-)%s*$", "%1"))
end

function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end
function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end


function UnloadPlugin()
	mapWindow:SetPluginUnloading(true);
	if saveSettings then -- if there were errors loading data, the user can choose to abort saving as it would destroy their prior data
		SaveData();
	end

	-- have to remove all shell commands before unloading or we get a crash to desktop :(
	mapWindow:RemoveShellCommands();
	mapWindow.MouseClick=nil;

	if not mapWindow.PreserveMapID then
		Turbine.Shell.WriteLine("MoorMap "..Plugins["MoorMap"]:GetVersion()..Resource[language][10]);
	end
	if mapWindow~=nil and mapWindow.chatListener~=nil then
		RemoveCallback(Turbine.Chat, "Received", mapWindow.chatListener);
	end
end

function SaveData()

	PatchDataSave( Turbine.DataScope.Account, "MM_Debug", debug );
	local settings={};
	local tmpIndex;
	local tmpCustAnnot={};
	local tmpMapID;
	local tmpCustAnnotID;
	local tmpSubIndex;
	local resolution=tostring(displayWidth).."x"..tostring(displayHeigh)

	-- update the display width and height incase user changed resolution while playing
	displayWidth=Turbine.UI.Display.GetWidth()
	displayHeight=Turbine.UI.Display.GetHeight()
	settings.MapTopPercent=mapWindow:GetTop()/displayHeight;
	settings.MapLeftPercent=mapWindow:GetLeft()/displayWidth;
	settings.MapHeightPercent=mapWindow:GetHeight()/displayHeight;
	settings.MapWidthPercent=mapWindow:GetWidth()/displayWidth;

	settings.SearchTopPercent=searchWindow:GetTop()/displayHeight;
	settings.SearchLeftPercent=searchWindow:GetLeft()/displayWidth;

	settings.MapOpacity=mapWindow.Map:GetOpacity();
	settings.DataVersion=tostring(Plugins["MoorMap"]:GetVersion());

	settings.IconTopPercent=minWindow:GetTop()/displayHeight;
	settings.IconLeftPercent=minWindow:GetLeft()/displayWidth;
	settings.UseMiniIcon=minWindow:GetUseMiniIcon();
	settings.MiniIconOpaque=minWindow:GetMiniIconOpaque();
	settings.EnableWaypoint=EnableWaypoint;

	settings.fontColor=fontColor;
	settings.trimColor=trimColor;
	settings.backColor=backColor;
	settings.headingsColor=headingsColor;
	settings.breadcrumbColor=breadcrumbColor;
	settings.listTextColor=listTextColor;
	settings.loadMinimized=mapWindow:GetLoadMinimized();
	settings.language=language;
	settings.showIconWhenMinimized=mapWindow:GetShowIconWhenMinimized();
	settings.worldName=worldName;
	settings.defaultMap=defaultMap;

	settings.filterMainDefault=mapWindow.FilterMainDefault;
	settings.filterSecondaryDefault=mapWindow.FilterSecondaryDefault;
	settings.filterBaseDefault=mapWindow.FilterBaseDefault;
	settings.filterOutpostDefault=mapWindow.FilterOutpostDefault;
	settings.filterFortDefault=mapWindow.FilterFortDefault;
	settings.filterPOIDefault=mapWindow.FilterPOIDefault;
	settings.filterRezDefault=mapWindow.FilterRezDefault;
	settings.filterMapDefault=mapWindow.FilterMapDefault;
	settings.filterNPCDefault=mapWindow.FilterNPCDefault;
	settings.filterCookDefault=mapWindow.FilterCookDefault;
	settings.filterScholarIngredientDefault=mapWindow.FilterScholarIngredientDefault;
	settings.filterAuctioneerDefault=mapWindow.FilterAuctioneerDefault;
	settings.filterBarberDefault=mapWindow.FilterBarberDefault;
	settings.filterBardDefault=mapWindow.FilterBardDefault;
	settings.filterCampSiteDefault=mapWindow.FilterCampSiteDefault;
	settings.filterCraftSiteDefault=mapWindow.FilterCraftSiteDefault;
	settings.filterCraftVendorDefault=mapWindow.FilterCraftVendorDefault;
	settings.filterFactionRepDefault=mapWindow.FilterFactionRepDefault;
	settings.filterItemMasterDefault=mapWindow.FilterItemMasterDefault;
	settings.filterMailboxDefault=mapWindow.FilterMailboxDefault;
	settings.filterMilestoneDefault=mapWindow.FilterMilestoneDefault;
	settings.filterMusteringHornDefault=mapWindow.FilterMusteringHornDefault;
	settings.filterReflectingPoolDefault=mapWindow.FilterReflectingPoolDefault;
	settings.filterSettlementDefault=mapWindow.FilterSettlementDefault;
	settings.filterStableMasterDefault=mapWindow.FilterStableMasterDefault;
	settings.filterTaskboardDefault=mapWindow.FilterTaskboardDefault;
	settings.filterTownCrierDefault=mapWindow.FilterTownCrierDefault;
	settings.filterTraderDefault=mapWindow.FilterTraderDefault;
	settings.filterTrainerDefault=mapWindow.FilterTrainerDefault;
	settings.filterVaultKeeperDefault=mapWindow.FilterVaultKeeperDefault;
	settings.filterVendorDefault=mapWindow.FilterVendorDefault;
	settings.filterSkirmishCampDefault=mapWindow.FilterSkirmishCampDefault;
	settings.filterOreNodeDefault=mapWindow.FilterOreNodeDefault;
	settings.filterWoodNodeDefault=mapWindow.FilterWoodNodeDefault;
	settings.filterScholarNodeDefault=mapWindow.FilterScholarNodeDefault;
	settings.filterDungeonDefault=mapWindow.FilterDungeonDefault;
	settings.filterStairDefault=mapWindow.FilterStairDefault;
	settings.filterQuestDefault=mapWindow.FilterQuestDefault;

	settings.quickWindowTopPercent=quickWindow:GetTop()/displayHeight;
	settings.quickWindowLeftPercent=quickWindow:GetLeft()/displayWidth;
	settings.quickWindowDisplayed=quickWindow.Displayed;
	settings.quickWindowOpacity=quickWindow.Opacity;
	if BDDLegend~=nil then
		settings.BDDLegendTopPercent=BDDLegend:GetTop()/displayHeight
		settings.BDDLegendLeftPercent=BDDLegend:GetLeft()/displayWidth
	else
		settings.BDDLegendTopPercent=mapWindow.BDDTop
		settings.BDDLegendLeftPercent=mapWindow.BDDLeft
	end

	settings.popUpPinned=mapWindow.PopUpPinned
	if mapWindow.PreserveMapID==true then
		-- we're changing maps, save the new mapID and the search/filter settings
		settings.refreshing=true;
		if mapWindow.showLocOnReload~=nil then
			settings.playerNS=mapWindow.playerNS
			settings.playerEW=mapWindow.playerEW
			settings.playerHeading=mapWindow.Heading
		end
		if mapWindow.CurrentMapID~=nil then
			settings.currentMapID= mapWindow.CurrentMapID;
		end
		if mapWindow.PopUp~=nil then
			settings.popUpTop= mapWindow.PopUp:GetTop();
			settings.popUpLeft= mapWindow.PopUp:GetLeft();
			settings.popUpPinned=mapWindow.PopUp:IsPinned();
		end
		settings.filterAllegianceCreep= mapWindow.FilterPanel.AllegianceCreep:IsChecked();
		settings.filterAllegianceFreep= mapWindow.FilterPanel.AllegianceFreep:IsChecked();
		settings.filterAllegianceDelving= mapWindow.FilterPanel.AllegianceDelving:IsChecked();
		settings.filterTypeMain= mapWindow.FilterPanel.TypeMain:IsChecked();
		settings.filterTypeSecondary= mapWindow.FilterPanel.TypeSecondary:IsChecked();
		settings.filterTypeBase= mapWindow.FilterPanel.TypeBase:IsChecked();
		settings.filterTypeOutpost= mapWindow.FilterPanel.TypeOutpost:IsChecked();
		settings.filterTypePOI= mapWindow.FilterPanel.TypePOI:IsChecked();
		settings.filterTypeFort= mapWindow.FilterPanel.TypeFort:IsChecked();
		settings.filterTypeRez= mapWindow.FilterPanel.TypeRez:IsChecked();
		settings.filterTypeMap= mapWindow.FilterPanel.TypeMap:IsChecked();
		settings.filterTypeNPC= mapWindow.FilterPanel.TypeNPC:IsChecked();
		settings.filterTypeCook= mapWindow.FilterPanel.TypeCook:IsChecked();
		settings.filterTypeScholarIngredient= mapWindow.FilterPanel.TypeScholarIngredient:IsChecked();
		settings.filterTypeAuctioneer= mapWindow.FilterPanel.TypeAuctioneer:IsChecked();
		settings.filterTypeBarber= mapWindow.FilterPanel.TypeBarber:IsChecked();
		settings.filterTypeBard= mapWindow.FilterPanel.TypeBard:IsChecked();
		settings.filterTypeCampSite= mapWindow.FilterPanel.TypeCampSite:IsChecked();
		settings.filterTypeCraftSite= mapWindow.FilterPanel.TypeCraftSite:IsChecked();
		settings.filterTypeCraftVendor= mapWindow.FilterPanel.TypeCraftVendor:IsChecked();
		settings.filterTypeFactionRep= mapWindow.FilterPanel.TypeFactionRep:IsChecked();
		settings.filterTypeItemMaster= mapWindow.FilterPanel.TypeItemMaster:IsChecked();
		settings.filterTypeMailbox= mapWindow.FilterPanel.TypeMailbox:IsChecked();
		settings.filterTypeMilestone= mapWindow.FilterPanel.TypeMilestone:IsChecked();
		settings.filterTypeMusteringHorn= mapWindow.FilterPanel.TypeMusteringHorn:IsChecked();
		settings.filterTypeReflectingPool= mapWindow.FilterPanel.TypeReflectingPool:IsChecked();
		settings.filterTypeSettlement= mapWindow.FilterPanel.TypeSettlement:IsChecked();
		settings.filterTypeStableMaster= mapWindow.FilterPanel.TypeStableMaster:IsChecked();
		settings.filterTypeTaskboard= mapWindow.FilterPanel.TypeTaskboard:IsChecked();
		settings.filterTypeTownCrier= mapWindow.FilterPanel.TypeTownCrier:IsChecked();
		settings.filterTypeTrader= mapWindow.FilterPanel.TypeTrader:IsChecked();
		settings.filterTypeTrainer= mapWindow.FilterPanel.TypeTrainer:IsChecked();
		settings.filterTypeVaultKeeper= mapWindow.FilterPanel.TypeVaultKeeper:IsChecked();
		settings.filterTypeVendor= mapWindow.FilterPanel.TypeVendor:IsChecked();
		settings.filterTypeSkirmishCamp= mapWindow.FilterPanel.TypeSkirmishCamp:IsChecked();
		settings.filterTypeOreNode= mapWindow.FilterPanel.TypeOreNode:IsChecked();
		settings.filterTypeWoodNode= mapWindow.FilterPanel.TypeWoodNode:IsChecked();
		settings.filterTypeScholarNode= mapWindow.FilterPanel.TypeScholarNode:IsChecked();
		settings.filterTypeDungeon= mapWindow.FilterPanel.TypeDungeon:IsChecked();
		settings.filterTypeStair= mapWindow.FilterPanel.TypeStair:IsChecked();
		settings.filterTypeQuest= mapWindow.FilterPanel.TypeQuest:IsChecked();

		settings.filterOreNodeTier= mapWindow.FilterPanel.TypeOreNodeTier:GetValue();
		settings.filterWoodNodeTier= mapWindow.FilterPanel.TypeWoodNodeTier:GetValue();
		settings.filterScholarNodeTier= mapWindow.FilterPanel.TypeScholarNodeTier:GetValue();
	elseif defaultMap==-2 then
		-- the user wants to redisplay the most recently viewed map on startup
		if mapWindow.CurrentMapID~=nil then
			settings.currentMapID= mapWindow.CurrentMapID;
		end

	end
	if mapWindow.ExternalPing then
		settings.pingNS= mapWindow.PingNS;
		settings.pingEW= mapWindow.PingEW;
		settings.pingName= mapWindow.PingName;
		settings.pingDesc= mapWindow.PingDesc;

		settings.searchText=searchText:GetText()
		settings.searchResult={}
		for tmpIndex=1,resultList:GetItemCount() do
			local tmpItem=resultList:GetItem(tmpIndex)
			table.insert(settings.searchResult,{["mapID"]=tmpItem.mapID,["ns"]=tmpItem.ns,["ew"]=tmpItem.ew,["name"]=tmpItem.name,["description"]=tmpItem.description})
		end
	end

	PatchDataSave( Turbine.DataScope.Account, "MoorMapSettings", settings);
	PatchDataSave( Turbine.DataScope.Character, "MoorMapSettings", settings);

	if LoadedMapID~=nil then
		-- remove any Default annotations
		tmpIndex=1;
		while tmpIndex<=#annotations do
			if annotations[tmpIndex][6]==nil then
				tmpMapID=annotations[tmpIndex][1];
				if tmpMapID==LoadedMapID then
					tmpCustAnnotID=#tmpCustAnnot+1;
					tmpCustAnnot[tmpCustAnnotID]={};
					for tmpSubIndex=1, #annotations[tmpIndex] do
						tmpCustAnnot[tmpCustAnnotID][tmpSubIndex]=annotations[tmpIndex][tmpSubIndex];
					end
					table.remove(annotations,tmpIndex);
				else
					tmpIndex=tmpIndex+1;
				end
			else
				table.remove(annotations,tmpIndex);
			end
		end
	
		if #tmpCustAnnot>0 then
			PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(LoadedMapID), tmpCustAnnot);
		else
			PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(LoadedMapID), nil);
		end
		PatchDataSave( Turbine.DataScope.Account, "MM_Breadcrumbs_"..tostring(LoadedMapID), mapWindow.Breadcrumbs);
	end
	PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnotations", annotations);

	if defAnnWindow~=nil then
		if defAnnWindow.AnnotationText~=nil then
			local tmpAnnotText=defAnnWindow.AnnotationText:GetText();
			local tmpResourceText=defAnnWindow.ResourceText:GetText();
			if tmpAnnotText~=nil and tmpAnnotText~="" then
				-- the admin window had unsaved text, preserve it incase this is an accidental shutdown
				PatchDataSave( Turbine.DataScope.Account, "MoorMapAnnotText", tmpAnnotText);
				PatchDataSave( Turbine.DataScope.Account, "MoorMapResourceText", tmpResourceText);
			end
		end
	end
	if saveOverlays then
		PatchDataSave( Turbine.DataScope.Account, "MM_Overlays", overlays);
	end
end

function LoadData()
	-- try to load saved annotations
	iconInfo=PatchDataLoad( Turbine.DataScope.Account, "MM_IconInfo");
	annotations=PatchDataLoad( Turbine.DataScope.Account, "MM_CustomAnotations");
	-- create a backup just incase anything goes awry during update
	if annotations~=nil and type(annotations)=="table" then
		PatchDataSave( Turbine.DataScope.Account, "MM_CustomAnotations_bak", annotations);
	end
	mapInfo=PatchDataLoad( Turbine.DataScope.Account, "MM_MapInfo");
	overlays=PatchDataLoad( Turbine.DataScope.Account, "MM_Overlays");
	if overlays==nil then overlays={} end
	for k,v in pairs(overlays) do
		if v[10]==nil then overlays[k][10]=1 end
	end

	if iconInfo==nil or mapInfo==nil then
		-- need to preload old defaults so that the constructor can run, I need to revisit this and fix it so that it can run without these defaults
		iconInfo={};
		iconInfo[1]={106,36,36,"GaranStuff/MoorMap/Resources/MainBase.tga","GaranStuff/MoorMap/Resources/MainBase_hover.tga"}; --placeholder
		iconInfo[2]={107,32,32,"GaranStuff/MoorMap/Resources/Base.tga","GaranStuff/MoorMap/Resources/Base_hover.tga"};
		iconInfo[3]={108,24,24,"GaranStuff/MoorMap/Resources/Fort.tga","GaranStuff/MoorMap/Resources/Fort_hover.tga"};
		iconInfo[4]={109,24,24,"GaranStuff/MoorMap/Resources/Outpost.tga","GaranStuff/MoorMap/Resources/Outpost_hover.tga"};
		iconInfo[5]={110,24,24,"GaranStuff/MoorMap/Resources/POI.tga","GaranStuff/MoorMap/Resources/POI_hover.tga"};
		iconInfo[6]={111,18,18,"GaranStuff/MoorMap/Resources/Stockade.tga","GaranStuff/MoorMap/Resources/Stockade_hover.tga"};
		iconInfo[7]={112,24,24,"GaranStuff/MoorMap/Resources/Rez.tga","GaranStuff/MoorMap/Resources/Rez_hover.tga"};
		iconInfo[8]={113,18,18,"GaranStuff/MoorMap/Resources/CrudeMap.tga","GaranStuff/MoorMap/Resources/CrudeMap_hover.tga"};
		iconInfo[9]={114,18,18,"GaranStuff/MoorMap/Resources/PoorMap.tga","GaranStuff/MoorMap/Resources/PoorMap_hover.tga"};
		iconInfo[10]={115,18,18,"GaranStuff/MoorMap/Resources/GoodMap.tga","GaranStuff/MoorMap/Resources/GoodMap_hover.tga"};
		iconInfo[11]={116,16,16,"GaranStuff/MoorMap/Resources/NPC.tga","GaranStuff/MoorMap/Resources/NPC_hover.tga"};
		iconInfo[12]={117,18,18,"GaranStuff/MoorMap/Resources/FreepMap.tga","GaranStuff/MoorMap/Resources/FreepMap_hover.tga"};
		iconInfo[13]={118,18,18,"GaranStuff/MoorMap/Resources/UnearnedMap.tga","GaranStuff/MoorMap/Resources/UnearnedMap_hover.tga"};
		iconInfo[14]={120,32,32,"GaranStuff/MoorMap/Resources/Auctioneer.tga","GaranStuff/MoorMap/Resources/Auctioneer_hover.tga"};
		iconInfo[15]={121,32,32,"GaranStuff/MoorMap/Resources/Barber.tga","GaranStuff/MoorMap/Resources/Barber_hover.tga"};
		iconInfo[16]={122,32,32,"GaranStuff/MoorMap/Resources/Bard.tga","GaranStuff/MoorMap/Resources/Bard_hover.tga"};
		iconInfo[17]={123,30,30,0x410d4635,0x410d4637}; -- Camp Site (mini=0x410d4636 (15x15))
		iconInfo[18]={124,30,30,"GaranStuff/MoorMap/Resources/CraftSite.tga","GaranStuff/MoorMap/Resources/CraftSite_hover.tga"}; -- Craft Facility (mini=0x410d4636 (15x15))
		iconInfo[19]={125,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- ResourceNode
		iconInfo[20]={126,32,32,"GaranStuff/MoorMap/Resources/CraftVendor.tga","GaranStuff/MoorMap/Resources/CraftVendor_hover.tga"};
		iconInfo[21]={127,32,32,"GaranStuff/MoorMap/Resources/FactionRep.tga","GaranStuff/MoorMap/Resources/FactionRep_hover.tga"};
		iconInfo[22]={128,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Fellow
		iconInfo[23]={129,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- FellowLeader
		iconInfo[24]={130,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- FellowTrack
		iconInfo[25]={131,32,32,"GaranStuff/MoorMap/Resources/Item-master.tga","GaranStuff/MoorMap/Resources/Item-master_hover.tga"};
		iconInfo[26]={132,32,32,"GaranStuff/MoorMap/Resources/Mailbox.tga","GaranStuff/MoorMap/Resources/Mailbox_hover.tga"};--Mailbox mini = 0x41007f7a (18x18)
		iconInfo[27]={133,32,32,"GaranStuff/MoorMap/Resources/Milestone.tga","GaranStuff/MoorMap/Resources/Milestone_hover.tga"};
		iconInfo[28]={134,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Pet
		iconInfo[29]={135,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Quest NPC
		iconInfo[30]={136,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Quest Escort
		iconInfo[31]={137,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Quest Failer
		iconInfo[32]={138,32,32,"GaranStuff/MoorMap/Resources/ReflectingPool.tga","GaranStuff/MoorMap/Resources/ReflectingPool_hover.tga"};
		iconInfo[33]={139,32,32,"GaranStuff/MoorMap/Resources/Settlement.tga","GaranStuff/MoorMap/Resources/Settlement_hover.tga"}; -- Settlement
		iconInfo[34]={140,32,32,"GaranStuff/MoorMap/Resources/Stablemaster.tga","GaranStuff/MoorMap/Resources/Stablemaster_hover.tga"};
		iconInfo[35]={141,32,32,"GaranStuff/MoorMap/Resources/TownCrier.tga","GaranStuff/MoorMap/Resources/TownCrier_hover.tga"};
		iconInfo[36]={142,0,0,"GaranStuff/MoorMap/Resources/placeholder.tga","GaranStuff/MoorMap/Resources/placeholder.tga"}; -- Tracked Target
		iconInfo[37]={143,30,30,0x410d465c,0x410d465d}; -- Trader
		iconInfo[38]={144,32,32,"GaranStuff/MoorMap/Resources/Trainer.tga","GaranStuff/MoorMap/Resources/Trainer_hover.tga"};
		iconInfo[39]={145,32,32,"GaranStuff/MoorMap/Resources/VaultKeeper.tga","GaranStuff/MoorMap/Resources/VaultKeeper_hover.tga"};
		iconInfo[40]={146,32,32,"GaranStuff/MoorMap/Resources/Vendor.tga","GaranStuff/MoorMap/Resources/Vendor_hover.tga"};
		iconInfo[41]={147,63,63,"GaranStuff/MoorMap/Resources/MapConnector_blank.tga",0x410081a2};
		iconInfo[42]={154,32,32,"GaranStuff/MoorMap/Resources/SkirmishCamp.tga","GaranStuff/MoorMap/Resources/SkirmishCamp_hover.tga"};
		iconInfo[43]={155,32,32,"GaranStuff/MoorMap/Resources/OreNode.tga","GaranStuff/MoorMap/Resources/OreNode_hover.tga"};
		iconInfo[44]={156,32,32,"GaranStuff/MoorMap/Resources/WoodNode.tga","GaranStuff/MoorMap/Resources/WoodNode_hover.tga"};
		iconInfo[45]={157,32,32,"GaranStuff/MoorMap/Resources/ScholarNode.tga","GaranStuff/MoorMap/Resources/ScholarNode_hover.tga"};
		iconInfo[46]={162,32,32,"GaranStuff/MoorMap/Resources/Cook.tga","GaranStuff/MoorMap/Resources/Cook_hover.tga"};
		iconInfo[47]={163,32,32,"GaranStuff/MoorMap/Resources/MusterHorn.tga","GaranStuff/MoorMap/Resources/MusterHorn_hover.tga"};
		iconInfo[48]={182,32,32,"GaranStuff/MoorMap/Resources/Scholar.tga","GaranStuff/MoorMap/Resources/Scholar_hover.tga"};
		iconInfo[49]={183,32,32,"GaranStuff/MoorMap/Resources/Dungeon.tga","GaranStuff/MoorMap/Resources/Dungeon_hover.tga"};
		iconInfo[50]={218,30,30,"GaranStuff/MoorMap/Resources/Taskboard.tga","GaranStuff/MoorMap/Resources/Taskboard_hover.tga"};
		iconInfo[51]={248,32,32,"GaranStuff/MoorMap/Resources/StairUp.tga","GaranStuff/MoorMap/Resources/StairUp_hover.tga","GaranStuff/MoorMap/Resources/Stair_icon.tga"};
		iconInfo[52]={249,32,32,"GaranStuff/MoorMap/Resources/StairDn.tga","GaranStuff/MoorMap/Resources/StairDn_hover.tga","GaranStuff/MoorMap/Resources/Stair_icon.tga"};
		iconInfo[53]={272,30,30,0x41005e4e,0x41005e50,0x41005e4f};
	end
	if mapInfo==nil then
		-- just enough to let the constructor run, then the current defaults will get imported
		mapInfo={{1,19,tonumber("0x41008133"),1024,768,63.6,1541,-63.6,-636,3,1}};
	end
	if annotations==nil then annotations={} end
	-- I need to load the strings for each ore/wood/scholar node and their tier
	-- I use this table to derive the tier from "add" target arguments

	nodeTier={};
	if locale=="en" then
		-- ore
		table.insert(nodeTier,{"Copper Deposit",43,1,0});
		table.insert(nodeTier,{"Rich Copper Deposit",43,1,0});
--		table.insert(nodeTier,{"Tin Deposit",43,1,0});
--		table.insert(nodeTier,{"Rich Tin Deposit",43,1,0});
		table.insert(nodeTier,{"Barrow-iron Deposit",43,2,0});
		table.insert(nodeTier,{"Rich Barrow-iron Deposit",43,2,0});
		table.insert(nodeTier,{"Silver Deposit",43,2,0});
		table.insert(nodeTier,{"Rich Silver Deposit",43,2,0});
		table.insert(nodeTier,{"Rich Iron Deposit",43,3,0});
		table.insert(nodeTier,{"Bountiful Iron Deposit",43,3,0});
		table.insert(nodeTier,{"Gold Deposit",43,3,0});
		table.insert(nodeTier,{"Rich Gold Deposit",43,3,0});
		table.insert(nodeTier,{"Dwarf-iron Deposit",43,4,0});
		table.insert(nodeTier,{"Rich Dwarf-iron Deposit",43,4,0});
		table.insert(nodeTier,{"Platinum Deposit",43,4,0});
		table.insert(nodeTier,{"Rich Platinum Deposit",43,4,0});
		table.insert(nodeTier,{"Ancient Iron Deposit",43,5,0});
		table.insert(nodeTier,{"Rich Ancient Iron Deposit",43,5,0});
		table.insert(nodeTier,{"Ancient Silver Deposit",43,5,0});
		table.insert(nodeTier,{"Rich Ancient Silver Deposit",43,5,0});
--		table.insert(nodeTier,{"Khaz"..string.char(195)..string.char(162).."d-tin Deposit",43,6,0});
--		table.insert(nodeTier,{"Khaz"..string.char(195)..string.char(162).."d-copper Deposit",43,6,0});
--		table.insert(nodeTier,{"Khaz"..string.char(195)..string.char(162).."d-iron Deposit",43,6,0});
--		table.insert(nodeTier,{"Khaz"..string.char(195)..string.char(162).."d-gold Deposit",43,6,0});
--		table.insert(nodeTier,{"Rich Khaz"..string.char(195)..string.char(162).."d-tin Deposit",43,6,0});
--		table.insert(nodeTier,{"Rich Khaz"..string.char(195)..string.char(162).."d-copper Deposit",43,6,0});
--		table.insert(nodeTier,{"Rich Khaz"..string.char(195)..string.char(162).."d-iron Deposit",43,6,0});
--		table.insert(nodeTier,{"Rich Khaz"..string.char(195)..string.char(162).."d-gold Deposit",43,6,0});
		table.insert(nodeTier,{"Khaz"..string.char(195)..string.char(162).."d Skarn Deposit",43,6,0});
		table.insert(nodeTier,{"Rich Khaz"..string.char(195)..string.char(162).."d Skarn Deposit",43,6,0});
		-- wood
		table.insert(nodeTier,{"Rowan Branches",44,1,0});
		table.insert(nodeTier,{"Heavy Rowan Branches",44,1,0});
		table.insert(nodeTier,{"Ash Branches",44,2,0});
		table.insert(nodeTier,{"Heavy Ash Branches",44,2,0});
		table.insert(nodeTier,{"Yew Branches",44,3,0});
		table.insert(nodeTier,{"Heavy Yew Branches",44,3,0});
		table.insert(nodeTier,{"Lebethron Branches",44,4,0});
		table.insert(nodeTier,{"Heavy Lebethron Branches",44,4,0});
		table.insert(nodeTier,{"Black Ash Branches",44,5,0});
		table.insert(nodeTier,{"Heavy Black Ash Branches",44,5,0});
		table.insert(nodeTier,{"Ilex Branches",44,6,0});
		table.insert(nodeTier,{"Heavy Ilex Branches",44,6,0});
		table.insert(nodeTier,{"Pile of Ilex Wood",44,6,0});
		table.insert(nodeTier,{"Pile of Heavy Ilex Wood",44,6,0});
--		table.insert(nodeTier,{"Pile of Mallorn Wood",44,6,0});
--		table.insert(nodeTier,{"Pile of Heavy Mallorn Wood",44,6,0});
		-- scholar node
		table.insert(nodeTier,{"Shattered Pitcher",45,1,0});
		table.insert(nodeTier,{"Broken Urn",45,2,0});
		table.insert(nodeTier,{"Antique Vase",45,3,0});
		table.insert(nodeTier,{"Forgotten Text",45,4,0});
		table.insert(nodeTier,{"Ancient Vase",45,5,0});
		table.insert(nodeTier,{"Sage's Lockbox",45,6,0});
		-- scholar items
		table.insert(nodeTier,{"Yarrow Root",48,1,0});
		table.insert(nodeTier,{"Woad Plant",48,2,0});
--*** need to check tier on Indigo plant
		table.insert(nodeTier,{"Indigo Plant",48,2,0});
		-- cook items
		table.insert(nodeTier,{"Cabbage",46,0,0});
		table.insert(nodeTier,{"Green Onion",46,0,0});
		table.insert(nodeTier,{"Stalk of Rhubarb",46,0,0});
		table.insert(nodeTier,{"Bunch of Raspberries",46,0,0});
		table.insert(nodeTier,{"Bunch of Strawberries",46,0,0});
		table.insert(nodeTier,{"Bunch of Blueberries",46,0,0});
		table.insert(nodeTier,{"Bunch of Blackberries",46,0,0});
		table.insert(nodeTier,{"Tater",46,0,0});
		table.insert(nodeTier,{"Golden Shire Tater",46,0,0});
		table.insert(nodeTier,{"Drop of Honey",46,0,0});
		table.insert(nodeTier,{"Drop of Fine Clover Honey",46,0,0});
		-- I use the nodeTier mechanism to autodetect the icon type for some of the fixed default items.
		table.insert(nodeTier,{"Mailbox",26,0,1});
		table.insert(nodeTier,{"Milestone",27,0,1});
		table.insert(nodeTier,{"Camp Site Fire",17,0,1});
		table.insert(nodeTier,{"Mustering Horn",47,0,1});
		table.insert(nodeTier,{"Forge",18,0,1});
		table.insert(nodeTier,{"Superior Forge",18,0,1});
		table.insert(nodeTier,{"Workbench",18,0,1});
		table.insert(nodeTier,{"Superior Workbench",18,0,1});
		table.insert(nodeTier,{"Oven",18,0,1});
		table.insert(nodeTier,{"Superior Oven",18,0,1});
		table.insert(nodeTier,{"Study",18,0,1});
		table.insert(nodeTier,{"Superior Study",18,0,1});

		table.insert(nodeTier,{"Rich Skarn Deposit",43,7,0});
		table.insert(nodeTier,{"Skarn Deposit",43,7,0});
		table.insert(nodeTier,{"Heavy Birch Branches",44,7,0});
		table.insert(nodeTier,{"Birch Branches",44,7,0});
		table.insert(nodeTier,{"Banded Coffer",45,7,0});
		table.insert(nodeTier,{"Heavy Banded Coffer",45,7,0});
		table.insert(nodeTier,{"Ornate Cache",45,8,0});

		table.insert(nodeTier,{"Rich Riddermark Deposit",43,8,0});
		table.insert(nodeTier,{"Riddermark Deposit",43,8,0});
		table.insert(nodeTier,{"Oak Branches",44,8,0});
		table.insert(nodeTier,{"Heavy Oak Branches",44,8,0});

		table.insert(nodeTier,{"Eorlingas Skarn Deposit",43,9,0});
		table.insert(nodeTier,{"Rich Eorlingas Skarn Deposit",43,9,0});
		table.insert(nodeTier,{"Walnut Branches",44,9,0});
		table.insert(nodeTier,{"Heavy Walnut Branches",44,9,0});
		table.insert(nodeTier,{"Adorned Chest",45,9,0});
		table.insert(nodeTier,{"Heavy Adorned Chest",45,9,0});
	else
		-- french /dire Garann ;cible
		-- ore
		table.insert(nodeTier,{"D\195\169p\195\180t de cuivre",43,1,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de cuivre riche",43,1,0});
--		table.insert(nodeTier,{"D\195\169p\195\180t d'\195\169tain",43,1,0});
--		table.insert(nodeTier,{"D\195\169p\195\180t d'\195\169tain riche",43,1,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer des galgals",43,2,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer riche des galgals",43,2,0});
		table.insert(nodeTier,{"D\195\169p\195\180t d'argent",43,2,0});
		table.insert(nodeTier,{"D\195\169p\195\180t d'argent riche",43,2,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer riche",43,3,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer abondant",43,3,0});
		table.insert(nodeTier,{"D\195\169p\195\180t d'or",43,3,0});
		table.insert(nodeTier,{"D\195\169p\195\180t d'or riche",43,3,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer des nains",43,4,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer riche des nains",43,4,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de platine",43,4,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de platine riche",43,4,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer ancien",43,5,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de fer riche ancien",43,5,0});
		table.insert(nodeTier,{"D\195\169p\195\180t d'argent ancien",43,5,0});
		table.insert(nodeTier,{"D\195\169p\195\180t d'argent riche ancien",43,5,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de skarn de Khaz\195\162d",43,6,0});
		table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn de Khaz\195\162d",43,6,0});
		table.insert(nodeTier,{"D\195\169p\195\180t de skarn de Calenard",43,7,0});
		table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn de Calenard",43,7,0});

		table.insert(nodeTier,{"D\195\169p\195\180t de skarn du Riddermark",43,8,0});
		table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn du Riddermark",43,8,0});

		table.insert(nodeTier,{"D\195\169p\195\180t de skarn des Eorlingas",43,9,0});
		table.insert(nodeTier,{"Riche d\195\169p\195\180t de skarn des Eorlingas",43,9,0});

		-- wood
		table.insert(nodeTier,{"Branches de sorbier",44,1,0});
		table.insert(nodeTier,{"Lourdes branches de sorbier",44,1,0});
		table.insert(nodeTier,{"Branches de fr\195\170ne",44,2,0});
		table.insert(nodeTier,{"Lourdes branches de fr\195\170ne",44,2,0});
		table.insert(nodeTier,{"Branches d'if",44,3,0});
		table.insert(nodeTier,{"Lourdes branches d'if",44,3,0});
		table.insert(nodeTier,{"Branches de lebethron",44,4,0});
		table.insert(nodeTier,{"Lourdes branches de lebethron",44,4,0});
		table.insert(nodeTier,{"Branches de fr\195\170ne noir",44,5,0});
		table.insert(nodeTier,{"Lourdes branches de fr\195\170ne noir",44,5,0});
		table.insert(nodeTier,{"Branches d'ilex",44,6,0});
		table.insert(nodeTier,{"Lourdes branches d'ilex",44,6,0});
		table.insert(nodeTier,{"Tas de bois d'ilex",44,6,0}); -- unverified
		table.insert(nodeTier,{"Bois d'ilex lourd",44,6,0}); -- unverified
--		table.insert(nodeTier,{"Tas de bois de mallorne",44,6,0});
--		table.insert(nodeTier,{"Bois de mallorne lourd",44,6,0});
		table.insert(nodeTier,{"Branches de bouleau",44,7,0});
		table.insert(nodeTier,{"Grandes branches de bouleau",44,7,0}); -- not sure why they went with Grandes in stead of Lourdes

		table.insert(nodeTier,{"Branches de ch\195\168ne",44,8,0});
		table.insert(nodeTier,{"Branches de ch\195\168ne lourdes",44,8,0});
		table.insert(nodeTier,{"Branches de noyer",44,9,0});
		table.insert(nodeTier,{"Lourdes branches de noyer",44,9,0});
		-- scholar
		table.insert(nodeTier,{"Broc cass\195\169",45,1,0});
		table.insert(nodeTier,{"Urne bris\195\169e",45,2,0});
		table.insert(nodeTier,{"Vase antique",45,3,0});
		table.insert(nodeTier,{"Texte oubli\195\169",45,4,0});
		table.insert(nodeTier,{"Vase ancien",45,5,0});
		table.insert(nodeTier,{"Coffret de sage",45,6,0}); -- moria
		table.insert(nodeTier,{"Coffre cercl\195\169",45,7,0});
		table.insert(nodeTier,{"Coffre cercl\195\169 lourd",45,7,0});

		table.insert(nodeTier,{"Cache d\195\169cor\195\169e",45,8,0});
		table.insert(nodeTier,{"Cache lourde d\195\169cor\195\169e",45,8,0});
		-- scholar items
		table.insert(nodeTier,{"Racine d'achill\195\169e",48,1,0});
		table.insert(nodeTier,{"Pousse de gu\195\168de",48,2,0});
		-- cook
		table.insert(nodeTier,{"Chou",46,0,0});
		table.insert(nodeTier,{"Oignon vert",46,0,0});
		table.insert(nodeTier,{"P\195\169tiole de rhubarbe",46,0,0});
		table.insert(nodeTier,{"Framboises",46,0,0});
		table.insert(nodeTier,{"Fraises",46,0,0});
		table.insert(nodeTier,{"Myrtilles",46,0,0});
		table.insert(nodeTier,{"M\195\187res",46,0,0});
		table.insert(nodeTier,{"Patate",46,0,0});
		table.insert(nodeTier,{"Patate dor\195\169e de la Comt\195\169",46,0,0});
		table.insert(nodeTier,{"Goutte de miel",46,0,0});
		table.insert(nodeTier,{"Goutte de d\195\169licieux miel de tr\195\168fle",46,0,0});

		--
		-- german /flstern Garann ;ziel
		-- ore
		table.insert(nodeTier,{"Ader: Kupfer",43,1,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Kupfer",43,1,0});
--		table.insert(nodeTier,{"Ader: Zinn",43,1,0});
--		table.insert(nodeTier,{"Reichhaltige Ader: Zinn",43,1,0});
		table.insert(nodeTier,{"Ader: H\195\188gelgrab-Eisen",43,2,0});
		table.insert(nodeTier,{"Reichhaltige Ader: H\195\188gelgrab-Eisen",43,2,0});
		table.insert(nodeTier,{"Ader: Silber",43,2,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Silber",43,2,0});
		table.insert(nodeTier,{"Ader: Hochwertiges Eisen",43,3,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Hochwertiges Eisen",43,3,0});
		table.insert(nodeTier,{"Ader: Gold",43,3,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Gold",43,3,0});
		table.insert(nodeTier,{"Ader: Zwergeneisen",43,4,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Zwergeneisen",43,4,0});
		table.insert(nodeTier,{"Ader: Platin",43,4,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Platin",43,4,0});
		table.insert(nodeTier,{"Ader: Uraltes Eisen",43,5,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Uraltes Eisen",43,5,0});
		table.insert(nodeTier,{"Ader: Uraltes Silber",43,5,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Uraltes Silber",43,5,0});
		table.insert(nodeTier,{"Ader: Khaz\195\162d-Skarn",43,6,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Khaz\195\162d-Skarn",43,6,0});
		table.insert(nodeTier,{"Ader: Calenard-Skarn",43,7,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Calenard-Skarn",43,7,0});
		table.insert(nodeTier,{"Ader: Riddermark-Skarn",43,8,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Riddermark-Skarn",43,8,0});
		table.insert(nodeTier,{"Ader: Skarn der Eorlingas",43,9,0});
		table.insert(nodeTier,{"Reichhaltige Ader: Skarn der Eorlingas",43,9,0});

		-- wood
		table.insert(nodeTier,{"Ebereschen-Zweige",44,1,0});
		table.insert(nodeTier,{"Schwere Ebereschen-Zweige",44,1,0});
		table.insert(nodeTier,{"Eschenzweige",44,2,0});
		table.insert(nodeTier,{"Schwere Eschenzweige",44,2,0});
		table.insert(nodeTier,{"Eibenzweige",44,3,0});
		table.insert(nodeTier,{"Schwere Eibenzweige",44,3,0});
		table.insert(nodeTier,{"Lebethron-Zweige",44,4,0});
		table.insert(nodeTier,{"Schwere Lebethron-Zweige",44,4,0});
		table.insert(nodeTier,{"Schwarzeschen-Zweige",44,5,0});
		table.insert(nodeTier,{"Schwere Schwarzeschen-Zweige",44,5,0});
		table.insert(nodeTier,{"Stechpalmen-Zweige",44,6,0});
		table.insert(nodeTier,{"Schwere Stechpalmen-Zweige",44,6,0});
		table.insert(nodeTier,{"Stapel Stechpalmen-Holz",44,6,0});
		table.insert(nodeTier,{"Stapel schweres Stechpalmen-Holz",44,6,0});
--		table.insert(nodeTier,{"Stapel Mallorn-Holz",44,6,0});
--		table.insert(nodeTier,{"Stapel schweres Mallorn-Holz",44,6,0});
		table.insert(nodeTier,{"Birkenzweige",44,7,0});
		table.insert(nodeTier,{"Schwere Birkenzweige",44,7,0});
		table.insert(nodeTier,{"Eichenzweige",44,8,0});
		table.insert(nodeTier,{"Schwere Eichenzweige",44,8,0});
		table.insert(nodeTier,{"Walnusszweige",44,9,0});
		table.insert(nodeTier,{"Schwere Walnusszweige",44,9,0});

		-- scholar node
		table.insert(nodeTier,{"Zerschmetterter Krug",45,1,0});
		table.insert(nodeTier,{"Zerbrochene Urne",45,2,0});
		table.insert(nodeTier,{"Antike Vase",45,3,0});
		table.insert(nodeTier,{"Vergessener Text",45,4,0});
		table.insert(nodeTier,{"Uralte Vase",45,5,0});
		table.insert(nodeTier,{"Schatulle des Weisen",45,6,0}); -- moria
		table.insert(nodeTier,{"Schrank des Weisen",45,6,0}); -- also moria
		table.insert(nodeTier,{"Truhe mit B\195\164ndern",45,7,0});
		table.insert(nodeTier,{"Schwere Truhe mit B\195\164ndern",45,7,0});

		table.insert(nodeTier,{"Verschn\195\182rkelte Truhe",45,8,0});
		table.insert(nodeTier,{"Schwere Verschn\195\182rkelte Truhe",45,8,0}); -- ? need to verify this
		-- scholar items
		table.insert(nodeTier,{"Schafgarben-Wurzel",48,1,0});
		table.insert(nodeTier,{"Waidpflanze",48,2,0});
		-- cook
		table.insert(nodeTier,{"Kohlkopf",46,0,0});
		table.insert(nodeTier,{"Fr\195\188hlingszwiebel",46,0,0});
		table.insert(nodeTier,{"Rhabarberst\195\164ngel",46,0,0});
		table.insert(nodeTier,{"Handvoll Himbeeren",46,0,0});
		table.insert(nodeTier,{"Handvoll Erdbeeren",46,0,0});
		table.insert(nodeTier,{"Handvoll Blaubeeren",46,0,0});
		table.insert(nodeTier,{"Handvoll Brombeeren",46,0,0});
		table.insert(nodeTier,{"Kartoffel",46,0,0});
		table.insert(nodeTier,{"Goldene Auenland-Kartoffel",46,0,0});
		table.insert(nodeTier,{"Tropfen Honig",46,0,0});
		table.insert(nodeTier,{"Tropfen edler Kleehonig",46,0,0});
	end
--[[	table.insert(nodeTier,{"Bo\195\174te de r\195\169ception",26,0,1});
	table.insert(nodeTier,{"Rep\195\168re",27,0,1});
	table.insert(nodeTier,{"Feu de camp",17,0,1});
	table.insert(nodeTier,{"Cor de rassemblement",47,0,1});
	table.insert(nodeTier,{"Briefkasten",26,0,1});
	table.insert(nodeTier,{"Markstein",27,0,1});
	table.insert(nodeTier,{"Lagerfeuerst\195\164tte",17,0,1});
	table.insert(nodeTier,{"Versammlungshorn",47,0,1});
]]--

end

function AddDefaultOverlays()
	if overlays==nil then overlays={} end
	-- overlays are in the format:{mapID,overlayName,path,width,height,left,top,shown,layer,opacity} where mapID is the id of one of the built-in maps, overlayName is the displayed name of the overlay and path is the path relative to the "GaranStuff/MoorMap/Overlays" folder
	local tmpOverlays={}
	for k,v in pairs(overlays) do
		tmpOverlays[tostring(v[1])..":"..v[2]]=k;
	end
	if tmpOverlays["90:Path to boss"]==nil then
		table.insert(overlays,{90,"Path to boss","Isengraf/PathToBoss.tga",1280,768,0,0,true,1,1})
	else
		overlays[tmpOverlays["90:Path to boss"]]={90,"Path to boss","TheAncientTomb/PathToBoss.tga",1024,768,0,0,overlays[tmpOverlays["90:Path to boss"]][8],1,1}
	end
	if tmpOverlays["94:Path to boss"]==nil then
		table.insert(overlays,{94,"Path to boss","TheAncientTomb/PathToBoss.tga",1024,768,0,0,true,1,1})
	else
		overlays[tmpOverlays["94:Path to boss"]]={94,"Path to boss","TheAncientTomb/PathToBoss.tga",1024,768,0,0,overlays[tmpOverlays["94:Path to boss"]][8],1,1}
	end
	if tmpOverlays["122:Matalan's quest start locations"]==nil then
		table.insert(overlays,{122,"Matalan's quest start locations","Matalan/ForestWithoutFrontiers.tga",1024,768,0,0,false,1,.7})
	else
		overlays[tmpOverlays["122:Matalan's quest start locations"]]={122,"Matalan's quest start locations","Matalan/ForestWithoutFrontiers.tga",1024,768,0,0,overlays[tmpOverlays["122:Matalan's quest start locations"]][8],1,overlays[tmpOverlays["122:Matalan's quest start locations"]][10]}
	end
	-- BDD, index=mapID, value=path to map overlay - default is "BDD/Blank.tga" but if the map has tinted regions it will have it's own tga file
	tmpBDD={}
	tmpBDD[4]="BDD/Blank.tga"
	tmpBDD[5]="BDD/Blank.tga"
	tmpBDD[7]="BDD/Blank.tga"
	tmpBDD[8]="BDD/Blank.tga"
	tmpBDD[11]="BDD/Blank.tga"
	tmpBDD[12]="BDD/Blank.tga"
	tmpBDD[13]="BDD/Blank.tga"
	tmpBDD[17]="BDD/Blank.tga"
	tmpBDD[19]="BDD/Blank.tga"
	tmpBDD[20]="BDD/Blank.tga"
	tmpBDD[21]="BDD/Blank.tga"
	tmpBDD[23]="BDD/Blank.tga"
	tmpBDD[24]="BDD/Blank.tga"
	tmpBDD[25]="BDD/Blank.tga"
	tmpBDD[26]="BDD/Blank.tga"
	tmpBDD[28]="BDD/Blank.tga"
	tmpBDD[31]="BDD/Blank.tga"
	tmpBDD[32]="BDD/Blank.tga"
	tmpBDD[33]="BDD/Blank.tga"
	tmpBDD[34]="BDD/Blank.tga"
	tmpBDD[35]="BDD/Blank.tga"
	tmpBDD[36]="BDD/Blank.tga"
	tmpBDD[37]="BDD/Blank.tga"
	tmpBDD[38]="BDD/Blank.tga"
	tmpBDD[39]="BDD/Blank.tga"
	tmpBDD[41]="BDD/Blank.tga"
	tmpBDD[42]="BDD/Blank.tga"
	tmpBDD[43]="BDD/Blank.tga"
	tmpBDD[44]="BDD/Blank.tga"
	tmpBDD[45]="BDD/Blank.tga"
	tmpBDD[61]="BDD/Blank.tga"
	tmpBDD[62]="BDD/Blank.tga"
	tmpBDD[63]="BDD/Blank.tga"
	tmpBDD[67]="BDD/Blank.tga"
	tmpBDD[68]="BDD/Blank.tga"
	tmpBDD[71]="BDD/Blank.tga"
	tmpBDD[72]="BDD/Blank.tga"
	tmpBDD[73]="BDD/Blank.tga"
	tmpBDD[74]="BDD/Blank.tga"
	tmpBDD[75]="BDD/Blank.tga"
	tmpBDD[76]="BDD/Blank.tga"
	tmpBDD[77]="BDD/Blank.tga"
	tmpBDD[112]="BDD/Blank.tga"
	tmpBDD[113]="BDD/Blank.tga"

	for k,v in pairs(tmpBDD) do
		local tmpOL=tmpOverlays[tostring(k)..":Berry's Deed Data"]
		if tmpOL==nil then
			-- default visibility to false
			table.insert(overlays,{k,"Berry's Deed Data",v,1024,768,0,0,false,1,1})
		else
			-- allow updating map file but preserve visibility flag
			overlays[tmpOL]={k,"Berry's Deed Data",v,1024,768,0,0,overlays[tmpOL][8],1,overlays[tmpOL][10]}
		end
	end
end
 
-- I create the quickslot window here so that it exists prior to setting it's position, etc
	quickWindow = Turbine.UI.Window();
	quickWindow:SetSize(34,34);
	quickWindow:SetPosition(32,Turbine.UI.Display:GetHeight()-32);
	quickWindow:SetBackground("GaranStuff/MoorMap/Resources/ClearBorder.tga");
	quickWindow:SetBackColor(trimColor);
	quickWindow:SetBackColorBlendMode(Turbine.UI.BlendMode.Color)
	quickWindow.Container=Turbine.UI.Control();
	quickWindow.Container:SetParent(quickWindow);
	quickWindow.Container:SetSize(26,26);
	quickWindow.Container:SetPosition(4,4);
	quickWindow.Container:SetMouseVisible(false);
	quickWindow.Quickslot=Turbine.UI.Lotro.Quickslot();
	quickWindow.Quickslot:SetParent(quickWindow.Container);
	quickWindow.Quickslot:SetSize(66,66);
	quickWindow.Quickslot:SetPosition(-34,-34);
	quickWindow.Quickslot:SetAllowDrop(false);
	quickWindow.Quickslot.Update=function()
		-- even though drag drop is disabled, the event fires if we drag over ourselves and it causes the quickslot to get wiped out
		local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"");
		if locale=="fr" then
			sc:SetData("/MoorMap add ;loc:5:FR:;cible");
		elseif locale=="de" then
			sc:SetData("/MoorMap add ;pos:5:DE:;ziel");
		else
			sc:SetData("/MoorMap add ;loc:5::;target");
		end
		quickWindow.Quickslot:SetShortcut(sc);
		quickWindow.Quickslot:SetWantsUpdates(false);
	end
	quickWindow.Quickslot.DragDrop=function()
		quickWindow.Quickslot:SetWantsUpdates(true);
	end

	quickWindow.Displayed=true;
	quickWindow.Icon=Turbine.UI.Control();
	quickWindow.Icon:SetParent(quickWindow);
	quickWindow.Icon:SetPosition(1,1);
	quickWindow.Icon:SetSize(32,32);
	quickWindow.Icon:SetBackground("GaranStuff/MoorMap/Resources/QuickPOI.tga");
	quickWindow.Icon:SetMouseVisible(false);
	quickWindow.Icon:SetVisible(true);
	quickWindow.Opacity=.15;
	quickWindow:SetOpacity(quickWindow.Opacity);
	quickWindow:SetVisible(true);
	quickWindow:SetZOrder(quickWindow:GetZOrder()+1);

	quickWindow.MouseEnter=function()
		quickWindow:SetOpacity(1);
		if quickWindow:IsControlKeyDown() then
			quickWindow:SetBackground("GaranStuff/MoorMap/Resources/MovingBorder.tga");
			quickWindow.Quickslot:SetVisible(false);
		end
	end
	quickWindow.MouseLeave=function()
		quickWindow:SetOpacity(quickWindow.Opacity);
		quickWindow:SetBackground("GaranStuff/MoorMap/Resources/ClearBorder.tga");
		quickWindow.Quickslot:SetVisible(true);
	end
	quickWindow.MoveX=-1;
	quickWindow.MoveY=0;
	quickWindow.Moving=false;

	quickWindow.MouseClick = function(sender,args)
		quickWindow:SetBackground("GaranStuff/MoorMap/Resources/ClearBorder.tga");
		if quickWindow.Moving then
			quickWindow.Moving=false;
			quickWindow.MoveX=-1;
		end
	end
	quickWindow.MouseDown=function(sender,args)
		if quickWindow:IsControlKeyDown() then
				quickWindow:SetBackground("GaranStuff/MoorMap/Resources/MovingBorder.tga");
				quickWindow.MoveX=args.X;
				quickWindow.MoveY=args.Y;
		end
	end
	quickWindow.MouseUp=function(sender,args)
		quickWindow:SetBackground("GaranStuff/MoorMap/Resources/ClearBorder.tga");
		quickWindow.MoveX=-1;
		quickWindow.MoveY=0;
		-- reestablish the quickslot incase the user dragged it out...
		if locale=="fr" then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5:FR:;cible"))
		elseif locale=="de" then
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;pos:5:DE:;ziel"))
		else
			quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5::;target"))
		end
		quickWindow.Quickslot:SetVisible(true);
	end

	quickWindow.MouseMove=function(sender,args)
		if quickWindow.MoveX~=-1 and (args.X~=quickWindow.MoveX or args.Y~= quickWindow.MoveY) then
			quickWindow:SetBackground("GaranStuff/MoorMap/Resources/MovingBorder.tga");
			quickWindow.Moving=true;
			local newLeft=quickWindow:GetLeft()-(quickWindow.MoveX-args.X)
			local newTop=quickWindow:GetTop()-(quickWindow.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
			if newLeft>(displayWidth-quickWindow:GetWidth()) then newLeft=displayWidth-quickWindow:GetWidth() end;
			if newTop<0 then newTop=0 end;
			if newTop>(displayHeight-quickWindow:GetHeight()) then newTop=displayHeight-quickWindow:GetHeight() end;
			quickWindow:SetPosition(newLeft,newTop);
			optionsCanvas.AnnotLeftValue:SetText(tostring(quickWindow:GetLeft()))
			optionsCanvas.AnnotTopValue:SetText(tostring(quickWindow:GetTop()))
		end
	end

CreateMapList=function()
	local tmpIndex;
	-- first, sort mapInfo alphabetically (use the current language)
	table.sort(mapInfo,function(arg1,arg2) if Resource[language][arg1[2]]<Resource[language][arg2[2]] then return(true) end end);
	-- then call AddMapListChildren(0,0)
	AddMapListChildren(0,0);
	-- resort mapInfo by first element (index)
	table.sort(mapInfo,function(arg1,arg2) if arg1[1]<arg2[1] then return(true) end end);

	-- now, set the list element default height based on the map type
	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue]~=nil and mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue][11]==3 then
			mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetForeColor(Turbine.UI.Color(.7,.7,0));
			mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetHeight(0);
		end		
	end

	if mapWindow.CurrentMapID~=nil then
		for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
			if mapWindow.MapSelect.ListData:GetItem(tmpIndex).DataValue==mapWindow.CurrentMapID then
				mapWindow.MapSelect.ListData:GetItem(tmpIndex):SetHeight(20);
				mapWindow.MapSelect:SetSelectedIndex(tmpIndex);
				break;
			end
		end
	else
		if defaultMap==-2 then
			mapWindow.MapSelect:SetSelectedIndex(3);
		else
			mapWindow.MapSelect:SetSelectedIndex(defaultMap);
		end
	end

	-- this isn't perfect, but it allows the "interior" maps to show up only after the parent has been moused over, keeping the map list limitted.
	-- the biggest issue is it causes the map list to "jump" under the cursor when child maps above the currently hovered over map get hidden. it would be better if I could get the list to scroll the correct number of entries to keep the current entry under the mouse
	for tmpIndex=1,mapWindow.MapSelect.ListData:GetItemCount() do
		mapWindow.MapSelect.ListData:GetItem(tmpIndex).MouseHover = function(sender)
			local tmpIndex2
			for tmpIndex2=1,mapWindow.MapSelect.ListData:GetItemCount() do
				if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][10]==sender.DataValue or mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][10]==mapInfo[sender.DataValue][10] then
					mapWindow.MapSelect.ListData:GetItem(tmpIndex2):SetHeight(20);
				else
					if mapInfo[mapWindow.MapSelect.ListData:GetItem(tmpIndex2).DataValue][11]==3 then
						mapWindow.MapSelect.ListData:GetItem(tmpIndex2):SetHeight(0);
					end		
				end		
			end
		end		
	end
end
AddMapListChildren=function(parent,indent)
	local tmpIndex;
	for tmpIndex=1,#mapInfo do
		if mapInfo[tmpIndex][10]==parent then
			mapWindow.MapSelect:AddItem(string.rep(" ", indent*4)..Resource[language][mapInfo[tmpIndex][2]],mapInfo[tmpIndex][1]);
			AddMapListChildren(mapInfo[tmpIndex][1],indent+1);
		end
	end
end
ResolveMap=function(region,NS,EW,unique)
-- this function returns a table with all of the map IDs that match the region and coordinates
	if unique==nil then
		unique=false
	end
	local tmpMap={};
	local tmpIndex;
	region=tonumber(region);
	NS=tonumber(NS);
	EW=tonumber(EW);
	local bestMap=nil
	local bestDelta=nil
	local bestZoom=nil
	for tmpIndex=1,#mapInfo do
		if mapInfo[tmpIndex][12]==region then -- same region
			if debug then
				Turbine.Shell.WriteLine("tmpIndex="..tonumber(tmpIndex)..", NS="..tostring(NS)..", EW="..tostring(EW))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][13]="..tonumber(mapInfo[tmpIndex][13]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][15]="..tonumber(mapInfo[tmpIndex][15]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][14]="..tonumber(mapInfo[tmpIndex][14]))
				Turbine.Shell.WriteLine("mapInfo[tmpIndex][16]="..tonumber(mapInfo[tmpIndex][16]))
			end
			if mapInfo[tmpIndex][13]>=NS and mapInfo[tmpIndex][15]<=NS and mapInfo[tmpIndex][14]<=EW and mapInfo[tmpIndex][16]>=EW then
				if unique then
					-- determine distance from center of valid portion of map
					local tmpDY=(mapInfo[tmpIndex][13]-NS)/(mapInfo[tmpIndex][13]-mapInfo[tmpIndex][15])-.5
					local tmpDX=(mapInfo[tmpIndex][16]-EW)/(mapInfo[tmpIndex][16]-mapInfo[tmpIndex][14])-.5
					local tmpDelta=(tmpDX*tmpDX+tmpDY*tmpDY)^.5
					if debug then
						Turbine.Shell.WriteLine("tmpDX:"..tostring(tmpDX))
						Turbine.Shell.WriteLine("tmpDY:"..tostring(tmpDY))
						Turbine.Shell.WriteLine("tmpDelta:"..tostring(tmpDelta))
					end
					if bestZoom==nil or mapInfo[tmpIndex][17]>bestZoom then
						bestZoom=mapInfo[tmpIndex][17]
						bestMap=tmpIndex
						bestDelta=tmpDelta
					else
						if mapInfo[tmpIndex][17]==bestZoom and tmpDelta<bestDelta then
							bestDelta=tmpDelta
							bestMap=tmpIndex
						end
					end
				end
				-- coordinates fall on this map
				table.insert(tmpMap,tmpIndex);
			end
		end
	end
	if unique then
		if bestMap~=nil then
			tmpMap={bestMap}
		end
	end
	return tmpMap;
end

LoadData();

mapWindow=Turbine.UI.Window();
mapWindow:SetSize(1024,768);
mapWindow.Loaded=false;
mapWindow.Refreshing=false;
mapWindow.ExternalPing=false;

local tmpIndex;
local mapOpacity=1;

mapWindow.PreserveMapID=false;
mapWindow.CurrentMapID=nil; -- default to nil so we can set it to the default if needed
mapWindow.NeedsRefresh=false;
mapWindow.PopUp=nil;
mapWindow.PopUpTop=-1;
mapWindow.PopUpLeft=-1;
mapWindow.PopUpPinned=false

local filterAllegianceCreep=true;
local filterAllegianceFreep=true;
local filterAllegianceDelving=true;
local filterTypeMain=nil;
local filterTypeSecondary=nil;
local filterTypeBase=nil;
local filterTypeOutpost=nil;
local filterTypePOI=nil;
local filterTypeFort=nil;
local filterTypeRez=nil;
local filterTypeMap=nil;
local filterTypeNPC=nil;
local filterTypeCook=nil;
local filterTypeScholarIngredient=nil;
local filterTypeAuctioneer=nil;
local filterTypeBarber=nil;
local filterTypeBard=nil;
local filterTypeCampSite=nil;
local filterTypeCraftSite=nil;
local filterTypeCraftVendor=nil;
local filterTypeFactionRep=nil;
local filterTypeItemMaster=nil;
local filterTypeMailbox=nil;
local filterTypeMilestone=nil;
local filterTypeMusteringHorn=nil;
local filterTypeReflectingPool=nil;
local filterTypeSettlement=nil;
local filterTypeStableMaster=nil;
local filterTypeTaskboard=nil;
local filterTypeTownCrier=nil;
local filterTypeTrader=nil;
local filterTypeTrainer=nil;
local filterTypeVaultKeeper=nil;
local filterTypeVendor=nil;
local filterTypeSkirmishCamp=nil;
local filterTypeOreNode=nil;
local filterTypeWoodNode=nil;
local filterTypeScholarNode=nil;
local filterTypeDungeon=nil;
local filterTypeStair=nil;
local filterTypeQuest=nil;

local filterOreNodeTier=0;
local filterWoodNodeTier=0;
local filterScholarNodeTier=0;
mapWindow.FilterMainDefault=true;
mapWindow.FilterSecondaryDefault=true;
mapWindow.FilterBaseDefault=true;
mapWindow.FilterOutpostDefault=true;
mapWindow.FilterFortDefault=true;
mapWindow.FilterPOIDefault=true;
mapWindow.FilterRezDefault=true;
mapWindow.FilterMapDefault=true;
mapWindow.FilterNPCDefault=true;
mapWindow.FilterCookDefault=true;
mapWindow.FilterScholarIngredientDefault=true;
mapWindow.FilterAuctioneerDefault=true;
mapWindow.FilterBarberDefault=true;
mapWindow.FilterBardDefault=true;
mapWindow.FilterCampSiteDefault=true;
mapWindow.FilterCraftSiteDefault=true;
mapWindow.FilterCraftVendorDefault=true;
mapWindow.FilterFactionRepDefault=true;
mapWindow.FilterItemMasterDefault=true;
mapWindow.FilterMailboxDefault=true;
mapWindow.FilterMilestoneDefault=true;
mapWindow.FilterMusteringHornDefault=true;
mapWindow.FilterReflectingPoolDefault=true;
mapWindow.FilterSettlementDefault=true;
mapWindow.FilterStableMasterDefault=true;
mapWindow.FilterTaskboardDefault=true;
mapWindow.FilterTownCrierDefault=true;
mapWindow.FilterTraderDefault=true;
mapWindow.FilterTrainerDefault=true;
mapWindow.FilterVaultKeeperDefault=true;
mapWindow.FilterVendorDefault=true;
mapWindow.FilterSkirmishCampDefault=true;
mapWindow.FilterOreNodeDefault=true;
mapWindow.FilterWoodNodeDefault=true;
mapWindow.FilterScholarNodeDefault=true;
mapWindow.FilterDungeonDefault=true;
mapWindow.FilterStairDefault=true;
mapWindow.FilterQuestDefault=true;

mapWindow.PluginUnloading=false;
mapWindow.Resizing=false;
mapWindow.MoveX=-1;
mapWindow.MoveY=-1;
mapWindow.LoadMinimized=true;
mapWindow.ShowIconWhenMinimized=true;
tmpSettings=PatchDataLoad(Turbine.DataScope.Character, "MoorMapSettings");
if tmpSettings==nil then
	tmpSettings=PatchDataLoad(Turbine.DataScope.Account, "MoorMapSettings");
end
if (tmpSettings==nil) then
	tmpSettings={};
else
	local priorFormat=euroFormat;
	if tostring(type(tmpSettings))=="table" then
		if tmpSettings[1]~=nil then
			-- convert old format to new format
			for index,data in ipairs(tmpSettings) do
				tmpSettings[data[1]]=Table.Copy(data[2]);
				tmpSettings[index]=nil;
			end
		end
		for name, data in pairs(tmpSettings) do
			if name=="MapTop" then
				tmpSettings.MapTopPercent=tonumber(data)/displayHeight;
			elseif name=="MapLeft" then
				tmpSettings.MapLeftPercent=tonumber(data)/displayWidth;
			elseif name=="MapHeight" then
				tmpSettings.MapHeightPercent=tonumber(data)/displayHeight;
			elseif name=="MapWidth" then
				tmpSettings.MapWidthPercent=tonumber(data)/displayWidth;
			elseif name=="MapTopPercent" then
				-- this is the new way of storing position, using a percentage of the screen display
				tmpSettings.MapTopPercent=euroNormalize(data);
			elseif name=="MapLeftPercent" then
				-- this is the new way of storing position, using a percentage of the screen display
				tmpSettings.MapLeftPercent=euroNormalize(data);
			elseif name=="MapHeightPercent" then
				-- this is the new way of storing position, using a percentage of the screen display
				tmpSettings.MapHeightPercent=euroNormalize(data);
			elseif name=="MapWidthPercent" then
				-- this is the new way of storing position, using a percentage of the screen display
				tmpSettings.MapWidthPercent=euroNormalize(data);
			elseif name=="BDDLegendTopPercent" then
				mapWindow.BDDTop=euroNormalize(data)
			elseif name=="BDDLegendLeftPercent" then
				mapWindow.BDDLeft=euroNormalize(data)
			elseif name=="EnableWaypoint" then
						EnableWaypoint=data;
			elseif name=="MapOpacity" then
						mapOpacity=data;
			elseif name=="trimColor" then
				trimColor=Turbine.UI.Color(euroNormalize(data.R),euroNormalize(data.G),euroNormalize(data.B));
				if quickWindow~=nil then
					quickWindow:SetBackColor(trimColor);
					quickWindow:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
				end
			elseif name=="fontColor" then
				fontColor=Turbine.UI.Color(euroNormalize(data.R),euroNormalize(data.G),euroNormalize(data.B));
			elseif name=="breadcrumbColor" then
					breadcrumbColor=Turbine.UI.Color(euroNormalize(data.R),euroNormalize(data.G),euroNormalize(data.B));
				if breadcrumbWindow~=nil then
					breadcrumbWindow.Color:SetColor(breadcrumbColor);
				end
			elseif name=="backColor" then
				backColor=Turbine.UI.Color(euroNormalize(data.R),euroNormalize(data.G),euroNormalize(data.B));
			elseif name=="headingsColor" then
				headingsColor=Turbine.UI.Color(euroNormalize(data.R),euroNormalize(data.G),euroNormalize(data.B));
			elseif name=="listTextColor" then
				listTextColor=Turbine.UI.Color(euroNormalize(data.R),euroNormalize(data.G),euroNormalize(data.B));
			elseif name=="defaultMap" then
				defaultMap=data;
			elseif name=="loadMinimized" then
				mapWindow.LoadMinimized=data;
			elseif name=="language" then
				if tonumber(data)~=nil then
					language=tonumber(data);
				end
			elseif name=="showIconWhenMinimized" then
				mapWindow.ShowIconWhenMinimized=data;
			elseif name=="DataVersion" then
				priorDataVersion=data;
			elseif name=="currentMapID" then
				mapWindow.CurrentMapID=data;
			elseif name=="refreshing" then
				mapWindow.Refreshing=true;
			elseif name=="filterAllegianceCreep" then
				filterAllegianceCreep=data;
			elseif name=="filterAllegianceFreep" then
				filterAllegianceFreep=data;
			elseif name=="filterAllegianceDelving" then
				filterAllegianceDelving=data;
			elseif name=="filterTypeMain" then
				filterTypeMain=data;
			elseif name=="filterTypeSecondary" then
				filterTypeSecondary=data;
			elseif name=="filterTypeBase" then
				filterTypeBase=data;
			elseif name=="filterTypeOutpost" then
				filterTypeOutpost=data;
			elseif name=="filterTypePOI" then
				filterTypePOI=data;
			elseif name=="filterTypeFort" then
				filterTypeFort=data;
			elseif name=="filterTypeRez" then
				filterTypeRez=data;
			elseif name=="filterTypeMap" then
				filterTypeMap=data;
			elseif name=="filterTypeNPC" then
				filterTypeNPC=data;
			elseif name=="filterTypeCook" then
				filterTypeCook=data;
			elseif name=="filterTypeScholarIngredient" then
				filterTypeScholarIngredient=data;
			elseif name=="filterTypeAuctioneer" then
				filterTypeAuctioneer=data;
			elseif name=="filterTypeBarber" then
				filterTypeBarber=data;
			elseif name=="filterTypeBard" then
				filterTypeBard=data;
			elseif name=="filterTypeCampSite" then
				filterTypeCampSite=data;
			elseif name=="filterTypeCraftSite" then
				filterTypeCraftSite=data;
			elseif name=="filterTypeCraftVendor" then
				filterTypeCraftVendor=data;
			elseif name=="filterTypeFactionRep" then
				filterTypeFactionRep=data;
			elseif name=="filterTypeItemMaster" then
				filterTypeItemMaster=data;
			elseif name=="filterTypeMailbox" then
				filterTypeMailbox=data;
			elseif name=="filterTypeMilestone" then
				filterTypeMilestone=data;
			elseif name=="filterTypeMusteringHorn" then
				filterTypeMusteringHorn=data;
			elseif name=="filterTypeReflectingPool" then
				filterTypeReflectingPool=data;
			elseif name=="filterTypeSettlement" then
				filterTypeSettlement=data;
			elseif name=="filterTypeStableMaster" then
				filterTypeStableMaster=data;
			elseif name=="filterTypeTaskboard" then
				filterTypeTaskboard=data;
			elseif name=="filterTypeTownCrier" then
				filterTypeTownCrier=data;
			elseif name=="filterTypeTrader" then
				filterTypeTrader=data;
			elseif name=="filterTypeTrainer" then
				filterTypeTrainer=data;
			elseif name=="filterTypeVaultKeeper" then
				filterTypeVaultKeeper=data;
			elseif name=="filterTypeVendor" then
				filterTypeVendor=data;
			elseif name=="filterTypeSkirmishCamp" then
				filterTypeSkirmishCamp=data;
			elseif name=="filterTypeOreNode" then
				filterTypeOreNode=data;
			elseif name=="filterTypeWoodNode" then
				filterTypeWoodNode=data;
			elseif name=="filterTypeScholarNode" then
				filterTypeScholarNode=data;
			elseif name=="filterTypeDungeon" then
				filterTypeDungeon=data;
			elseif name=="filterTypeStair" then
				filterTypeStair=data;
			elseif name=="filterTypeQuest" then
				filterTypeQuest=data;
			elseif name=="filterOreNodeTier" then
				filterOreNodeTier=data;
			elseif name=="filterWoodNodeTier" then
				filterWoodNodeTier=data;
			elseif name=="filterScholarNodeTier" then
				filterScholarNodeTier=data;
			elseif name=="euroFormat" then
				priorFormat=data;
			elseif name=="worldName" then
				worldName=data;
				if worldName==nil then worldName="Landroval" end
			elseif name=="pingNS" then
				mapWindow.PingNS=data;
			elseif name=="pingEW" then
				mapWindow.PingEW=data;
			elseif name=="pingName" then
				mapWindow.PingName=data;
			elseif name=="pingDesc" then
				mapWindow.PingDesc=data;
				mapWindow.ExternalPing=true;
				if tmpSettings.searchText~=nil then
					searchText:SetText(tmpSettings.searchText)
					if tmpSettings.searchResult~=nil then
						for index,result in ipairs(tmpSettings.searchResult) do
							searchWindow.AddSearchResult(result.mapID,result.ns,result.ew,result.name,Resource[language][mapInfo[result.mapID][2]],result.description)
						end
					end
					if tmpSettings.SearchTopPercent~=nil then
						searchWindow:SetTop(tmpSettings.SearchTopPercent*displayHeight);
					end
					if tmpSettings.SearchLeftPercent~=nil then
						searchWindow:SetLeft(tmpSettings.SearchLeftPercent*displayWidth);
					end
					searchWindow:SetVisible(true)
				end
			elseif name=="filterMainDefault" then
				mapWindow.FilterMainDefault=data;
			elseif name=="filterSecondaryDefault" then
				mapWindow.FilterSecondaryDefault=data;
			elseif name=="filterBaseDefault" then
				mapWindow.FilterBaseDefault=data;
			elseif name=="filterOutpostDefault" then
				mapWindow.FilterOutpostDefault=data;
			elseif name=="filterFortDefault" then
				mapWindow.FilterFortDefault=data;
			elseif name=="filterPOIDefault" then
				mapWindow.FilterPOIDefault=data;
			elseif name=="filterRezDefault" then
				mapWindow.FilterRezDefault=data;
			elseif name=="filterMapDefault" then
				mapWindow.FilterMapDefault=data;
			elseif name=="filterNPCDefault" then
				mapWindow.FilterNPCDefault=data;
			elseif name=="filterCookDefault" then
				mapWindow.FilterCookDefault=data;
			elseif name=="filterScholarIngredientDefault" then
				mapWindow.FilterScholarIngredientDefault=data;
			elseif name=="filterAuctioneerDefault" then
				mapWindow.FilterAuctioneerDefault=data;
			elseif name=="filterBarberDefault" then
				mapWindow.FilterBarberDefault=data;
			elseif name=="filterBardDefault" then
				mapWindow.FilterBardDefault=data;
			elseif name=="filterCampSiteDefault" then
				mapWindow.FilterCampSiteDefault=data;
			elseif name=="filterCraftSiteDefault" then
				mapWindow.FilterCraftSiteDefault=data;
			elseif name=="filterCraftVendorDefault" then
				mapWindow.FilterCraftVendorDefault=data;
			elseif name=="filterFactionRepDefault" then
				mapWindow.FilterFactionRepDefault=data;
			elseif name=="filterItemMasterDefault" then
				mapWindow.FilterItemMasterDefault=data;
			elseif name=="filterMailboxDefault" then
				mapWindow.FilterMailboxDefault=data;
			elseif name=="filterMilestoneDefault" then
				mapWindow.FilterMilestoneDefault=data;
			elseif name=="filterMusteringHornDefault" then
				mapWindow.FilterMusteringHornDefault=data;
			elseif name=="filterReflectingPoolDefault" then
				mapWindow.FilterReflectingPoolDefault=data;
			elseif name=="filterSettlementDefault" then
				mapWindow.FilterSettlementDefault=data;
			elseif name=="filterStableMasterDefault" then
				mapWindow.FilterStableMasterDefault=data;
			elseif name=="filterTaskboardDefault" then
				mapWindow.FilterTaskboardDefault=data;
			elseif name=="filterTownCrierDefault" then
				mapWindow.FilterTownCrierDefault=data;
			elseif name=="filterTraderDefault" then
				mapWindow.FilterTraderDefault=data;
			elseif name=="filterTrainerDefault" then
				mapWindow.FilterTrainerDefault=data;
			elseif name=="filterVaultKeeperDefault" then
				mapWindow.FilterVaultKeeperDefault=data;
			elseif name=="filterVendorDefault" then
				mapWindow.FilterVendorDefault=data;
			elseif name=="filterSkirmishCampDefault" then
				mapWindow.FilterSkirmishCampDefault=data;
			elseif name=="filterOreNodeDefault" then
				mapWindow.FilterOreNodeDefault=data;
			elseif name=="filterWoodNodeDefault" then
				mapWindow.FilterWoodNodeDefault=data;
			elseif name=="filterScholarNodeDefault" then
				mapWindow.FilterScholarNodeDefault=data;
			elseif name=="filterDungeonDefault" then
				mapWindow.FilterDungeonDefault=data;
			elseif name=="filterStairDefault" then
				mapWindow.FilterStairDefault=data;
			elseif name=="filterQuestDefault" then
				mapWindow.FilterQuestDefault=data;
			elseif name=="quickWindow.Top" then
				quickWindow:SetTop(data); --backwards compatability
			elseif name=="quickWindow.TopPercent" or name=="quickWindowTopPercent" then
				local pos;
				pos=euroNormalize(data);
				if pos==nil then pos=0 end
				pos=pos*displayHeight;
				quickWindow:SetTop(pos);
			elseif name=="quickWindow.Left" then
				quickWindow:SetLeft(data); -- backwards compatability
			elseif name=="quickWindow.LeftPercent" or name=="quickWindowLeftPercent" then
				local pos;
				pos=euroNormalize(data);
				if pos==nil then pos=0 end
				pos=pos*displayWidth;
				quickWindow:SetLeft(pos);
			elseif name=="quickWindow.Opacity" or name=="quickWindowOpacity" then
				quickWindow.Opacity=data;
				quickWindow:SetOpacity(quickWindow.Opacity);
			elseif name=="quickWindow.Displayed" or name=="quickWindowDisplayed" then
				quickWindow.Displayed=data;
				quickWindow:SetVisible(quickWindow.Displayed);
			elseif name=="popUpTop" then
				mapWindow.PopUpTop=data;
			elseif name=="popUpLeft" then
				mapWindow.PopUpLeft=data;
			elseif name=="popUpPinned" then
				mapWindow.PopUpPinned=data
			elseif name=="playerNS" then
				mapWindow.playerNS=data
				mapWindow.showPlayerLoc=true
			elseif name=="playerEW" then
				mapWindow.playerEW=data
				mapWindow.showPlayerLoc=true
			elseif name=="playerHeading" then
				mapWindow.Heading=data
			end
		end
	else
		-- data was unreadable, we need to display a message to the user that the data could not be read
		dataLoadError=true
	end

	if mapWindow.CurrentMapID==nil then
		-- assign the default map since either we loaded an older version or the user never set the option
		if defaultMap==-2 then
			mapWindow.CurrentMapID=3;
		else
			mapWindow.CurrentMapID=defaultMap;
		end
	end
	if locale=="fr" then
		quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5:FR:;cible"))
	elseif locale=="de" then
		quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;pos:5:DE:;ziel"))
	else
		quickWindow.Quickslot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/MoorMap add ;loc:5::;target"))
	end
	if quickWindow:GetTop()+32>Turbine.UI.Display:GetHeight() then quickWindow:SetTop(Turbine.UI.Display:GetHeight()-32) end
	if quickWindow:GetLeft()+32>Turbine.UI.Display:GetWidth() then quickWindow:SetLeft(Turbine.UI.Display:GetWidth()-32) end
		quickWindow.Quickslot:SetVisible(true);
		-- we have to force client decimal formats since we don't know what format they were saved in, iterate through annotations to fix Coordinates and mapInfo to fix Factors
	for tmpIndex=1,#annotations do
		if euroFormat then
			annotations[tmpIndex][2]=euroNormalize(annotations[tmpIndex][2])
			annotations[tmpIndex][3]=euroNormalize(annotations[tmpIndex][3])
		else
			annotations[tmpIndex][2]=euroNormalize(annotations[tmpIndex][2])
			annotations[tmpIndex][3]=euroNormalize(annotations[tmpIndex][3])
		end
	end
	for tmpIndex=1,#mapInfo do
		mapInfo[tmpIndex][6]=euroNormalize(mapInfo[tmpIndex][6])
		mapInfo[tmpIndex][7]=euroNormalize(mapInfo[tmpIndex][7])
		mapInfo[tmpIndex][8]=euroNormalize(mapInfo[tmpIndex][8])
		mapInfo[tmpIndex][9]=euroNormalize(mapInfo[tmpIndex][9])
		if mapInfo[tmpIndex][13]~=nil then
			mapInfo[tmpIndex][13]=euroNormalize(mapInfo[tmpIndex][13])
			mapInfo[tmpIndex][14]=euroNormalize(mapInfo[tmpIndex][14])
			mapInfo[tmpIndex][15]=euroNormalize(mapInfo[tmpIndex][15])
			mapInfo[tmpIndex][16]=euroNormalize(mapInfo[tmpIndex][16])
		else
			mapInfo[tmpIndex][13]=0;
			mapInfo[tmpIndex][14]=0;
			mapInfo[tmpIndex][15]=0;
			mapInfo[tmpIndex][16]=0;
		end
	end

	local tmpAnn;
	LoadedMapID=mapWindow.CurrentMapID;
	tmpAnn=PatchDataLoad( Turbine.DataScope.Account, "MM_CustomAnnotations_"..tostring(mapWindow.CurrentMapID));
	if tmpAnn~=nil and type(tmpAnn)=="table" then
		NumCustomAnnot=#tmpAnn;
		for tmpIndex=1,#tmpAnn do
			-- verify coords are within bounds - some annotations get accidentally added to unbounded maps
if debug then
Turbine.Shell.WriteLine("N Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][13]))
Turbine.Shell.WriteLine("S Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][15]))
Turbine.Shell.WriteLine("W Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][14]))
Turbine.Shell.WriteLine("E Bound:"..tostring(mapInfo[mapWindow.CurrentMapID][16]))
Turbine.Shell.WriteLine("NS:"..tostring(tmpAnn[tmpIndex][2]))
Turbine.Shell.WriteLine("EW:"..tostring(tmpAnn[tmpIndex][3]))
end

			tmpAnn[tmpIndex][2]=euroNormalize(tmpAnn[tmpIndex][2])
			tmpAnn[tmpIndex][3]=euroNormalize(tmpAnn[tmpIndex][3])
				if mapInfo[mapWindow.CurrentMapID][13]==nil or mapInfo[mapWindow.CurrentMapID][14]==nil or mapInfo[mapWindow.CurrentMapID][15]==nil or mapInfo[mapWindow.CurrentMapID][16]==nil or (tmpAnn[tmpIndex][2]<=mapInfo[mapWindow.CurrentMapID][13] and tmpAnn[tmpIndex][2]>=mapInfo[mapWindow.CurrentMapID][15] and tmpAnn[tmpIndex][3]>=mapInfo[mapWindow.CurrentMapID][14] and tmpAnn[tmpIndex][3]<=mapInfo[mapWindow.CurrentMapID][16]) then
				-- force conversion of fields 2 and 3 to match current euroFormat setting
				annotations[#annotations+1]={tmpAnn[tmpIndex][1],euroNormalize(tmpAnn[tmpIndex][2]),euroNormalize(tmpAnn[tmpIndex][3]),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
			end
		end
	end

	tmpAnn=PatchDataLoad( Turbine.DataScope.Account, "MM_MapAnnotations_"..tostring(mapWindow.CurrentMapID));
	if tmpAnn~=nil and type(tmpAnn)=="table" then
		for tmpIndex=1,#tmpAnn do
			-- force conversion of fields 2 and 3 to match current euroFormat setting
			annotations[#annotations+1]={tmpAnn[tmpIndex][1],euroNormalize(tmpAnn[tmpIndex][2]),euroNormalize(tmpAnn[tmpIndex][3]),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
		end
	end
	mapStrings=PatchDataLoad( Turbine.DataScope.Account, "MM_MapStrings_"..tostring(mapWindow.CurrentMapID));
	if mapStrings==nil or type(mapStrings)~="table" then
		mapStrings={};
	end
	if mapStrings[language]==nil or type(mapStrings[language])~="table" then
		mapStrings[language]={};
	end
	if mapWindow.CurrentMapID==1 then
		local stringOffset=#mapStrings[language];
		-- load any server specific annotations and strings and append them to the defaults
			tmpAnn=PatchDataLoad( Turbine.DataScope.Account, "MM_MapAnnotations_1_"..worldName);
		if tmpAnn~=nil and type(tmpAnn)=="table" then
			for tmpIndex=1,#tmpAnn do
				-- force conversion of fields 2 and 3 to match current euroFormat setting
				annotations[#annotations+1]={tmpAnn[tmpIndex][1],euroNormalize(tmpAnn[tmpIndex][2]),euroNormalize(tmpAnn[tmpIndex][3]),tmpAnn[tmpIndex][4],tmpAnn[tmpIndex][5],stringOffset+tmpAnn[tmpIndex][6],tmpAnn[tmpIndex][7],tmpAnn[tmpIndex][8],tmpAnn[tmpIndex][9],tmpAnn[tmpIndex][10],tmpAnn[tmpIndex][11]};
			end
		end
		local tmpMapStrings;
		local tmpLang;
		tmpMapStrings=PatchDataLoad( Turbine.DataScope.Account, "MM_MapStrings_1_"..worldName);
		if tmpMapStrings~=nil and type(tmpMapStrings)=="table" then
-- we only really need the language specific values, right? if the user changes languages, the plugin reloads anyway...
			for tmpIndex=1,#tmpMapStrings[language] do
				mapStrings[language][#mapStrings[language]+1]=tmpMapStrings[language][tmpIndex];
			end
		end
	end
	if annotations==nil then
		NumDefaultAnnot=0;
	else
		NumDefaultAnnot=#annotations-NumCustomAnnot;
	end		
	if debug then
		Turbine.Shell.WriteLine("NumCustomAnnot="..tostring(NumCustomAnnot));
		Turbine.Shell.WriteLine("NumDefaultAnnot="..tostring(NumDefaultAnnot));
	end
end

if mapWindow.CurrentMapID==nil then
	-- no default was assigned, so this is probably a first time run
	if defaultMap==-2 then
		mapWindow.CurrentMapID=3;
	else
		mapWindow.CurrentMapID=defaultMap;
	end
end

if filterTypeMain==nil then filterTypeMain=mapWindow.FilterMainDefault end
if filterTypeSecondary==nil then filterTypeSecondary=mapWindow.FilterSecondaryDefault end
if filterTypeBase==nil then filterTypeBase=mapWindow.FilterBaseDefault end
if filterTypeOutpost==nil then filterTypeOutpost=mapWindow.FilterOutpostDefault end
if filterTypePOI==nil then filterTypePOI=mapWindow.FilterPOIDefault end
if filterTypeFort==nil then filterTypeFort=mapWindow.FilterFortDefault end
if filterTypeRez==nil then filterTypeRez=mapWindow.FilterRezDefault end
if filterTypeMap==nil then filterTypeMap=mapWindow.FilterMapDefault end
if filterTypeNPC==nil then filterTypeNPC=mapWindow.FilterNPCDefault end
if filterTypeCook==nil then filterTypeCook=mapWindow.FilterCookDefault end
if filterTypeScholarIngredient==nil then filterTypeScholarIngredient=mapWindow.FilterScholarIngredientDefault end
if filterTypeAuctioneer==nil then filterTypeAuctioneer=mapWindow.FilterAuctioneerDefault end
if filterTypeBarber==nil then filterTypeBarber=mapWindow.FilterBarberDefault end
if filterTypeBard==nil then filterTypeBard=mapWindow.FilterBardDefault end
if filterTypeCampSite==nil then filterTypeCampSite=mapWindow.FilterCampSiteDefault end
if filterTypeCraftSite==nil then filterTypeCraftSite=mapWindow.FilterCraftSiteDefault end
if filterTypeCraftVendor==nil then filterTypeCraftVendor=mapWindow.FilterCraftVendorDefault end
if filterTypeFactionRep==nil then filterTypeFactionRep=mapWindow.FilterFactionRepDefault end
if filterTypeItemMaster==nil then filterTypeItemMaster=mapWindow.FilterItemMasterDefault end
if filterTypeMailbox==nil then filterTypeMailbox=mapWindow.FilterMailboxDefault end
if filterTypeMilestone==nil then filterTypeMilestone=mapWindow.FilterMilestoneDefault end
if filterTypeMusteringHorn==nil then filterTypeMusteringHorn=mapWindow.FilterMusteringHornDefault end
if filterTypeReflectingPool==nil then filterTypeReflectingPool=mapWindow.FilterReflectingPoolDefault end
if filterTypeSettlement==nil then filterTypeSettlement=mapWindow.FilterSettlementDefault end
if filterTypeStableMaster==nil then filterTypeStableMaster=mapWindow.FilterStableMasterDefault end
if filterTypeTaskboard==nil then filterTypeTaskboard=mapWindow.FilterTaskboardDefault end
if filterTypeTownCrier==nil then filterTypeTownCrier=mapWindow.FilterTownCrierDefault end
if filterTypeTrader==nil then filterTypeTrader=mapWindow.FilterTraderDefault end
if filterTypeTrainer==nil then filterTypeTrainer=mapWindow.FilterTrainerDefault end
if filterTypeVaultKeeper==nil then filterTypeVaultKeeper=mapWindow.FilterVaultKeeperDefault end
if filterTypeVendor==nil then filterTypeVendor=mapWindow.FilterVendorDefault end
if filterTypeSkirmishCamp==nil then filterTypeSkirmishCamp=mapWindow.FilterSkirmishCampDefault end
if filterTypeOreNode==nil then filterTypeOreNode=mapWindow.FilterOreNodeDefault end
if filterTypeWoodNode==nil then filterTypeWoodNode=mapWindow.FilterWoodNodeDefault end
if filterTypeScholarNode==nil then filterTypeScholarNode=mapWindow.FilterScholarNodeDefault end
if filterTypeDungeon==nil then filterTypeDungeon=mapWindow.FilterDungeonDefault end
if filterTypeStair==nil then filterTypeStair=mapWindow.FilterStairDefault end
if filterTypeQuest==nil then filterTypeQuest=mapWindow.FilterQuestDefault end

if tmpSettings.MapTopPercent==nil then tmpSettings.MapTopPercent=0 end;
if tmpSettings.MapLeftPercent==nil then tmpSettings.MapLeftPercent=0 end;
if tmpSettings.MapWidthPercent==nil then tmpSettings.MapWidthPercent=1 end;
if tmpSettings.MapHeightPercent==nil then tmpSettings.MapHeightPercent=1 end;
if tmpSettings.MapWidthPercent>1 then tmpSettings.MapWidthPercent=1 end;
if tmpSettings.MapHeightPercent>1 then tmpSettings.MapHeightPercent=1 end;
if tmpSettings.MapTopPercent+tmpSettings.MapHeightPercent>1 then tmpSettings.MapTopPercent=1-tmpSettings.MapHeightPercent end;
if tmpSettings.MapLeftPercent+tmpSettings.MapWidthPercent>1 then tmpSettings.MapLeftPerecent=1-tmpSettings.MapWidthPercent end;

mapWindow:SetTop(tmpSettings.MapTopPercent*displayHeight);
mapWindow:SetLeft(tmpSettings.MapLeftPercent*displayWidth)
mapWindow:SetHeight(tmpSettings.MapHeightPercent*displayHeight);
mapWindow:SetWidth(tmpSettings.MapWidthPercent*displayWidth);
mapWindow:SetVisible(false);

mapWindow.Map=Turbine.UI.Control();
mapWindow.Map:SetParent(mapWindow);
mapWindow.Map:SetMouseVisible(false);
mapWindow.Map:SetOpacity(mapOpacity);

mapWindow.Map.Overlays={};
BDDHotSpotHover=function(sender)
	local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
	if width<100 then width=100 end
	mapWindow.Map.HoverWindow:SetWidth(width+10);							
	mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
	mapWindow.Map.HoverWindow.MapID=nil;
	mapWindow.Map.HoverWindow.Name.MouseClick=nil;
	mapWindow.Map.HoverWindow.Coord:SetText(sender.Coords);
	mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
	mapWindow.Map.HoverWindow.Edit:SetVisible(false);
	mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
	mapWindow.Map.HoverWindow:SetVisible(true);
	mapWindow.Map.HoverWindow:SetWantsUpdates(true);
end
mapWindow.LoadOverlays=function()
	local tmpOLIndex;
	tmpOLIndex=#mapWindow.Map.Overlays
	while tmpOLIndex>0 do
		mapWindow.Map.Overlays[tmpOLIndex]:SetVisible(false);
		mapWindow.Map.Overlays[tmpOLIndex]=nil;
		tmpOLIndex=tmpOLIndex-1;
	end
	local count=mapWindow.OverlaySelect:GetItemCount();
	while count>1 do
		mapWindow.OverlaySelect:RemoveItemAt(count)
		count=count-1
	end
	mapWindow.Map.Overlays={};
	local tmpOverlays={};
	for tmpOLIndex,tmpData in ipairs(overlays) do
		if tmpData[1]==mapWindow.CurrentMapID then
			table.insert(tmpOverlays,{tmpData[1],tmpData[2],tmpData[3],tmpData[4],tmpData[5],tmpData[6],tmpData[7],tmpData[8],tmpData[9],tmpData[10],tmpOLIndex})
		end
	end
	-- sort by layer order
	table.sort(tmpOverlays,function(arg1,arg2) if arg1[9]==nil then return false elseif arg2[9]==nil or arg1[9]<arg2[9] then return true end end)
	for tmpOLIndex,tmpData in ipairs(tmpOverlays) do
		mapWindow.Map.Overlays[tmpOLIndex]=Turbine.UI.Control();
		mapWindow.Map.Overlays[tmpOLIndex]:SetParent(mapWindow.Map);

		mapWindow.Map.Overlays[tmpOLIndex]:SetMouseVisible(false);
		local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.Map.Overlays[tmpOLIndex],"GaranStuff/MoorMap/Overlays/"..tmpData[3]);
		local tmpRow=Turbine.UI.Lotro.CheckBox();
		tmpRow:SetParent(mapWindow.OverlaySelect);
		tmpRow:SetSize(mapWindow.OverlaySelect:GetWidth(),20);
		tmpRow:SetText(tmpData[2]);
		tmpRow.OLIndex=tmpData[11];
-- 		add annotations if this is a BDD overlay
		
		if tmpData[2]=="Berry's Deed Data" and (BDD==nil or BDD[1]==nil) then
			BDD={}
			local success,result=pcall(import,importPath.."Overlays.BDD.Data"..tostring(mapWindow.CurrentMapID));
			if success then
				local topmost=100+#mapWindow.Map.Icons
				local isvisible=tmpData[8]
				local bddWidth=320
				local bddHeight=400
				BDDLegend=Turbine.UI.Window()
				local top=mapWindow.BDDTop
				local left=mapWindow.BDDLeft
				if top==nil then top=0 end
				if left==nil then left=0 end
				BDDLegend:SetPosition(left*displayWidth,top*displayHeight)

				BDDLegend:SetSize(bddWidth,bddHeight)
				BDDLegend:SetZOrder(mapWindow:GetZOrder()+1)
				BDDLegend:SetOpacity(.95)
				BDDLegend:SetZOrder(2)
				BDDLegend:SetStretchMode(3);
				BDDVis=isvisible
				BDDLegend:SetVisible(isvisible and mapWindow:IsVisible())
				BDDLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
				BDDLegend.Border=Turbine.UI.Control()
				BDDLegend.Border:SetParent(BDDLegend)
				BDDLegend.Border:SetSize(bddWidth-2,bddHeight-2)
				BDDLegend.Border:SetPosition(1,1)
				BDDLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
				BDDLegend.Title=Turbine.UI.Control()
				BDDLegend.Title:SetParent(BDDLegend.Border)
				BDDLegend.Title:SetSize(250,65)
				BDDLegend.Title:SetPosition((bddWidth-252)/2,1)
				BDDLegend.Title:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				BDDLegend.Title:SetBackground("GaranStuff/MoorMap/Resources/BDDCaption.tga")
				BDDLegend.Title.MouseDown=function(sender,args)
					BDDLegend.Border:SetBackColor(Turbine.UI.Color(.8,.85,.85,.75))
					BDDLegend.X=args.X
					BDDLegend.Y=args.Y
					BDDLegend.Moving=true
				end
				BDDLegend.Title.MouseMove=function(sender,args)
					if BDDLegend.Moving then
						BDDLegend:SetPosition(BDDLegend:GetLeft()-(BDDLegend.X-args.X),BDDLegend:GetTop()-(BDDLegend.Y-args.Y))
					end
				end
				BDDLegend.Title.MouseUp=function(sender,args)
					BDDLegend.Border:SetBackColor(Turbine.UI.Color(.95,.95,.85))
					BDDLegend.Moving=false
				end
				BDDLegend.Title.MouseLeave=function(sender,args)
					BDDLegend:SetBackground(nil); -- cheesy way to generate a checkerboard background
					BDDLegend:SetBackColor(Turbine.UI.Color(.5,.5,1))
				end
				BDDLegend.Title.MouseEnter=function(sender,args)
					BDDLegend:SetBackground(0); -- cheesy way to generate a checkerboard background
					BDDLegend:SetBackColor(nil)
				end

				BDDLegend.DeedList=Turbine.UI.TreeView()
				BDDLegend.DeedList:SetParent(BDDLegend.Border)
				BDDLegend.DeedList:SetSize(bddWidth-24,bddHeight-72)
				BDDLegend.DeedList:SetPosition(5,70)
				BDDVScroll=Turbine.UI.Lotro.ScrollBar()
				BDDVScroll:SetParent(BDDLegend.Border)
				BDDVScroll:SetSize(10,bddHeight-32);
				BDDVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
				BDDVScroll:SetPosition(bddWidth-12,25);
				BDDLegend.DeedList:SetVerticalScrollBar(BDDVScroll)
				BDDPing=Turbine.UI.Control();
				BDDPing:SetParent(mapWindow.Map);
				BDDPing:SetZOrder(topmost+1);
				BDDPing.State=0;
				BDDPing:SetVisible(false);
				BDDPing:SetSize(23,23);
				BDDPing:SetPosition(512,512);
				BDDPing:SetWantsUpdates(false);
				BDDPing.Counter=1;
				BDDPing.MaxCounter=2;
				BDDPing:SetBlendMode(Turbine.UI.BlendMode.Overlay)
				BDDPing:SetBackground("GaranStuff/MoorMap/Resources/Ping1.tga");
				BDDPing.MouseClick=function(sender,args)
					BDDPing.State=0; -- it will auto hide itmapWindow on next tick
				end
				BDDPing.Update=function(sender)
					if BDDPing.State==0 then
						BDDPing:SetWantsUpdates(false);
						BDDPing:SetVisible(false);
						BDDPing.Counter=0;
						BDDPing:SetBackground("GaranStuff/MoorMap/Resources/Ping1.tga");
					elseif BDDPing.State==7 then
						BDDPing.Counter=BDDPing.Counter+1;
						if BDDPing.Counter>BDDPing.MaxCounter then
							BDDPing.Counter=0;
							BDDPing.State=3;
							BDDPing:SetBackground("GaranStuff/MoorMap/Resources/Ping3.tga");
						end
					else
						BDDPing.Counter=BDDPing.Counter+1;
						if BDDPing.Counter>BDDPing.MaxCounter then
							BDDPing.Counter=0;
							BDDPing.State=BDDPing.State+1;
							BDDPing:SetBackground("GaranStuff/MoorMap/Resources/Ping"..tostring(BDDPing.State)..".tga");
						end
					end
				end

				mapWindow.Map.Overlays[tmpOLIndex].HotSpots={}
				local root=BDDLegend.DeedList:GetNodes()
				for groupIndex,groupData in ipairs(BDD) do
					local tmpNode=Turbine.UI.TreeNode()
					tmpNode:SetParent(BDDLegend.DeedList)
					tmpNode:SetSize(bddWidth-24,18)
					tmpNode.Icon=Turbine.UI.Control()
					tmpNode.Icon:SetParent(tmpNode)
					tmpNode.Icon:SetMouseVisible(false)
					tmpNode.Icon:SetSize(16,16)
					tmpNode.Icon:SetBackground(0x41007E27) -- expand
					tmpNode.Title=Turbine.UI.Label()
					tmpNode.Title:SetParent(tmpNode)
					tmpNode.Title:SetSize(bddWidth-42,18)
					tmpNode.Title:SetLeft(18)
					tmpNode.Title:SetForeColor(groupData[2])
					tmpNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana16)
					tmpNode.Title:SetFontStyle(Turbine.UI.FontStyle.Outline)
					tmpNode.Title:SetOutlineColor(Turbine.UI.Color(.3,.3,.3))
					tmpNode.Title:SetText(groupData[1])
					tmpNode.Title:SetMouseVisible(false)
					tmpNode.MouseDown=function(sender)
						if sender:IsExpanded() then
							sender.Icon:SetBackground(0x41007E27)
						else
							sender.Icon:SetBackground(0x41007E26)
						end
					end
					root:Add(tmpNode)
					for itemIndex,itemData in ipairs(BDD[groupData[1]]) do
						-- add the hotspot to the overlay
						if itemData[1]~=nil and itemData[3]~=nil and itemData[4]~=nil then
							local NS,EW=itemData[3],itemData[4]
							local X,Y
							if itemData[6]~=nil then
								X=math.floor(itemData[6]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
							else
								X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
							end
							if itemData[5]~=nil then
								Y=math.floor(itemData[5]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
							else
								Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
							end
							local tmpHotSpot=Turbine.UI.Control()
							-- if the hotspots are on the overlay we don't get mouse events :(
							tmpHotSpot:SetParent(mapWindow.Map)
							tmpHotSpot:SetVisible(isvisible)
							tmpHotSpot:SetZOrder(topmost)
							tmpHotSpot:SetSize(30,20)
							tmpHotSpot:SetPosition(X-15,Y-10)
							-- create the text as a child so that the blendmode/backcolor alpha works correctly instead of poking holes in the map
							tmpHotSpot.Text=Turbine.UI.Label()
							tmpHotSpot.Text:SetParent(tmpHotSpot)
							tmpHotSpot.Text:SetSize(tmpHotSpot:GetSize())
							tmpHotSpot.Text:SetFont(Turbine.UI.Lotro.Font.Verdana20)
							tmpHotSpot.Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
							tmpHotSpot.Text:SetOutlineColor(Turbine.UI.Color.Black)
							tmpHotSpot.Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
							tmpHotSpot.Text:SetForeColor(groupData[2])
							tmpHotSpot.Text:SetMouseVisible(false)
							if itemData[1]<10 then
								tmpHotSpot.Text:SetText("0"..tostring(itemData[1]))
							else
								tmpHotSpot.Text:SetText(itemData[1])
							end
							tmpHotSpot.Text:SetBackColorBlendMode(Turbine.UI.BlendMode.Overlay)
							tmpHotSpot.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
							tmpHotSpot.ShortDescription=itemData[2]
							if NS<0 then
								tmpHotSpot.Coords=tostring(0-NS).."S, "
							else
								tmpHotSpot.Coords=tostring(NS).."N, "
							end
							if EW<0 then
								tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(0-EW).."W"
							else
								tmpHotSpot.Coords=tmpHotSpot.Coords..tostring(EW).."E"
							end
							tmpHotSpot.MouseEnter=function(sender)
								sender.Text:SetBackColor(Turbine.UI.Color(.9,.9,.9))
							end
							tmpHotSpot.MouseLeave=function(sender)
								sender.Text:SetBackColor(Turbine.UI.Color(.6,.7,.8,.8))
							end
							tmpHotSpot.MouseHover=function(sender)
								BDDHotSpotHover(sender)
							end

							table.insert(mapWindow.Map.Overlays[tmpOLIndex].HotSpots,tmpHotSpot)
						end
						-- only add node if name isn't alread in tree
						local childNodes=tmpNode:GetChildNodes()
						local exists=false
						local tmpLabel
						if itemData[1]~=nil then
							tmpLabel=tostring(itemData[1]).." "..itemData[2]
							if itemData[1]<10 then tmpLabel="0"..tmpLabel end
						else
							tmpLabel=itemData[2]
						end
						local tmpLen=string.len(tmpLabel)
						-- not sure how I feel about this feature. if not exists then don't show duplicate entry in legend...
--						for tmpindex=1,childNodes:GetCount() do
--							if string.sub(childNodes:Get(tmpindex).Title:GetText(),1,tmpLen)==tmpLabel then
--								exists=true
--								break
--							end
--						end
						if itemData[3]~=nil and itemData[4]~=nil then
							if itemData[3]<0 then
								tmpLabel=tmpLabel.." ("..tostring(0-itemData[3]).."S,"
							else
								tmpLabel=tmpLabel.." ("..tostring(itemData[3]).."N,"
							end
							if itemData[4]<0 then
								tmpLabel=tmpLabel..tostring(0-itemData[4]).."W)"
							else
								tmpLabel=tmpLabel..tostring(itemData[4]).."E)"
							end
						end
						if not exists then
							local tmpItemNode=Turbine.UI.TreeNode()
							tmpItemNode:SetParent(tmpNode)
							tmpItemNode:SetSize(bddWidth-24,16)
							tmpItemNode.Title=Turbine.UI.Label()
							tmpItemNode.Title:SetParent(tmpItemNode)
							tmpItemNode.Title:SetSize(bddWidth-44,16)
							tmpItemNode.Title:SetLeft(20)
							tmpItemNode.Title:SetForeColor(Turbine.UI.Color.DarkOliveGreen)
							tmpItemNode.Title:SetFont(Turbine.UI.Lotro.Font.Verdana14)
							tmpItemNode.Title:SetText(tmpLabel)
							tmpItemNode.Title:SetMouseVisible(false)
							if itemData[1]==nil and itemData[3]~=nil then
								-- map node
								tmpItemNode.MapID=itemData[3]
								tmpItemNode.MouseClick=function(sender)
									RefreshMap(sender.MapID)
								end
							end
							if itemData[1]~=nil and itemData[3]~=nil and itemData[4]~=nil then
								-- ping node
								if itemData[6]~=nil then
									tmpItemNode.X=math.floor(itemData[6]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
								else
									tmpItemNode.X=math.floor(itemData[4]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
								end
								if itemData[5]~=nil then
									tmpItemNode.Y=math.floor(itemData[5]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
								else
									tmpItemNode.Y=math.floor(itemData[3]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
								end
								tmpItemNode.MouseClick=function(sender)
									BDDPing:SetPosition(math.floor(sender.X-11.5),math.floor(sender.Y-11.5));
									BDDPing.State=1;
									BDDPing:SetVisible(true);
									BDDPing:SetWantsUpdates(true);
								end
							end
							childNodes:Add(tmpItemNode)
						end
					end
				end
			end
		end
		tmpRow.Data={tmpOLIndex,tmpData[4],tmpData[5],tmpData[6],tmpData[7],tmpData[10]}
		tmpRow.CheckedChanged=function(sender)
			if sender:IsChecked() then
				overlays[sender.OLIndex][8]=true;
				mapWindow.Map.Overlays[sender.Data[1]]:SetVisible(true);
				mapWindow.Map.Overlays[sender.Data[1]]:SetSize(sender.Data[2],sender.Data[3]);
				mapWindow.Map.Overlays[sender.Data[1]]:SetStretchMode(2);
				mapWindow.Map.Overlays[sender.Data[1]]:SetSize(mapWindow.Map:GetSize());
				mapWindow.Map.Overlays[sender.Data[1]]:SetOpacity(sender.Data[6]);
				if sender.Data[4]~=nil then mapWindow.Map.Overlays[sender.Data[1]]:SetLeft(sender.Data[4]) end
				if sender.Data[5]~=nil then mapWindow.Map.Overlays[sender.Data[1]]:SetTop(sender.Data[5]) end
			else
				overlays[sender.OLIndex][8]=false;
				mapWindow.Map.Overlays[sender.Data[1]]:SetVisible(false);
			end
			if overlays[sender.OLIndex][2]=="Berry's Deed Data" and BDDLegend~=nil then
				local isvisible=overlays[sender.OLIndex][8]
				for k,v in ipairs(mapWindow.Map.Overlays[sender.Data[1]].HotSpots) do
					v:SetVisible(isvisible)
				end
				BDDVis=isvisible
				BDDLegend:SetVisible(isvisible and mapWindow:IsVisible())
			end
			if overlayWindow~=nil and refreshOLList~=nil then
				refreshOLList()
			end
		end
		if tmpData[8]==true then
			tmpRow:SetChecked(true)
			mapWindow.Map.Overlays[tmpOLIndex]:SetVisible(true);
			mapWindow.Map.Overlays[tmpOLIndex]:SetSize(tmpData[4],tmpData[5]);
			mapWindow.Map.Overlays[tmpOLIndex]:SetStretchMode(2);
			mapWindow.Map.Overlays[tmpOLIndex]:SetSize(mapWindow.Map:GetSize());
			mapWindow.Map.Overlays[tmpOLIndex]:SetOpacity(tmpData[10]);
			if tmpData[6]~=nil then mapWindow.Map.Overlays[tmpOLIndex]:SetLeft(tmpData[6]) end
			if tmpData[7]~=nil then mapWindow.Map.Overlays[tmpOLIndex]:SetTop(tmpData[7]) end
		else
			tmpRow:SetChecked(false)
			mapWindow.Map.Overlays[tmpOLIndex]:SetVisible(false);
		end
		mapWindow.OverlaySelect:AddItem(tmpRow);
	end
	if mapWindow.OverlaySelect:GetItemCount()>1 then
		mapWindow.OverlaySelect:SetVisible(true);
	else
		mapWindow.OverlaySelect:SetVisible(false);
	end
end
mapWindow.LoadBreadcrumbs=function()
	mapWindow.Breadcrumbs=PatchDataLoad( Turbine.DataScope.Account, "MM_Breadcrumbs_"..tostring(mapWindow.CurrentMapID));
	if mapWindow.Breadcrumbs==nil then mapWindow.Breadcrumbs={} end;
end

mapWindow.ControlPanel=Turbine.UI.Control();
mapWindow.ControlPanel:SetParent(mapWindow);
mapWindow.ControlPanel:SetSize(mapWindow:GetWidth(),32);
mapWindow.ControlPanel:SetTop(4);
mapWindow.ControlPanel:SetStretchMode(3);
mapWindow.ControlPanel:SetMouseVisible(false);

mapWindow.ControlPanel.OptionsButton=Turbine.UI.Control();
mapWindow.ControlPanel.OptionsButton:SetParent(mapWindow.ControlPanel);
mapWindow.ControlPanel.OptionsButton:SetBackground("GaranStuff/MoorMap/Resources/options.tga");
mapWindow.ControlPanel.OptionsButton:SetSize(32,32);
mapWindow.ControlPanel.OptionsButton:SetLeft(18);

mapWindow.ControlPanel.OptionsButton.MouseEnter=function()
	mapWindow.ControlPanel.OptionsButton:SetBackground("GaranStuff/MoorMap/Resources/options_hover.tga");
end
mapWindow.ControlPanel.OptionsButton.MouseLeave = function()
	mapWindow.ControlPanel.OptionsButton:SetBackground("GaranStuff/MoorMap/Resources/options.tga");
	mapWindow.OptionsHover:Close();
end
mapWindow.ControlPanel.OptionsButton.MouseClick=function()
	optionsWindow:SetText(Resource[language][3]);
	optionsWindow.RefreshOptions();
	optionsWindow:SetVisible(true);
end
mapWindow.OptionsHover=Turbine.UI.ContextMenu();
mapWindow.OptionsHover:GetItems():Add(Turbine.UI.MenuItem(Resource[language][3]));
mapWindow.ControlPanel.OptionsButton.MouseHover=function(sender,args)
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.OptionsHover:ShowMenuAt(x+2,y+15);
end

mapWindow.ControlPanel.AnnotationsButton=Turbine.UI.Control();
mapWindow.ControlPanel.AnnotationsButton:SetParent(mapWindow.ControlPanel);
mapWindow.ControlPanel.AnnotationsButton:SetBackground("GaranStuff/MoorMap/Resources/annotations.tga");
mapWindow.ControlPanel.AnnotationsButton:SetSize(32,32);
if mapWindow.ControlPanel.OptionsButton~=nil then
	mapWindow.ControlPanel.AnnotationsButton:SetLeft(mapWindow.ControlPanel.OptionsButton:GetLeft()+mapWindow.ControlPanel.OptionsButton:GetWidth()+5);
else
	mapWindow.ControlPanel.AnnotationsButton:SetLeft(18);
end
mapWindow.ControlPanel.AnnotationsButton.MouseEnter=function()
	mapWindow.ControlPanel.AnnotationsButton:SetBackground("GaranStuff/MoorMap/Resources/annotations_hover.tga");
end
mapWindow.ControlPanel.AnnotationsButton.MouseLeave = function()
	mapWindow.ControlPanel.AnnotationsButton:SetBackground("GaranStuff/MoorMap/Resources/annotations.tga");
	mapWindow.AnnotationsHover:Close();
end
mapWindow.ControlPanel.AnnotationsButton.MouseClick=function()
	annotWindow:SetVisible(true);
end
mapWindow.AnnotationsHover=Turbine.UI.ContextMenu();
mapWindow.AnnotationsHover:GetItems():Add(Turbine.UI.MenuItem(Resource[language][72]));
mapWindow.ControlPanel.AnnotationsButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.AnnotationsHover:ShowMenuAt(x+2,y+15);
end

mapWindow.FilterButton=Turbine.UI.Control();
mapWindow.FilterButton:SetParent(mapWindow.ControlPanel);
mapWindow.FilterButton:SetBackground("GaranStuff/MoorMap/Resources/Filter.tga");
mapWindow.FilterButton:SetSize(32,32);
mapWindow.FilterButton:SetLeft(mapWindow.ControlPanel.AnnotationsButton:GetLeft()+mapWindow.ControlPanel.AnnotationsButton:GetWidth()+5);
mapWindow.FilterButton.MouseEnter=function()
	mapWindow.FilterButton:SetBackground("GaranStuff/MoorMap/Resources/Filter_hover.tga");
end
mapWindow.FilterButton.MouseLeave=function()
	mapWindow.FilterButton:SetBackground("GaranStuff/MoorMap/Resources/Filter.tga");
	mapWindow.FilterHover:Close();
end
mapWindow.FilterButton.MouseClick=function()
	mapWindow.FilterPanel:SetVisible(not mapWindow.FilterPanel:IsVisible());
end
mapWindow.FilterHover=Turbine.UI.ContextMenu();
mapWindow.FilterHover:GetItems():Add(Turbine.UI.MenuItem(Resource[language][65]));
mapWindow.FilterButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.FilterHover:ShowMenuAt(x+2,y+15);
end

mapWindow.SearchButton=Turbine.UI.Control();
mapWindow.SearchButton:SetParent(mapWindow.ControlPanel);
mapWindow.SearchButton:SetBackground("GaranStuff/MoorMap/Resources/Search.tga");
mapWindow.SearchButton:SetSize(32,32);
mapWindow.SearchButton:SetLeft(mapWindow.FilterButton:GetLeft()+mapWindow.FilterButton:GetWidth()+5);
mapWindow.SearchButton.MouseEnter=function()
	mapWindow.SearchButton:SetBackground("GaranStuff/MoorMap/Resources/Search_hover.tga");
end
mapWindow.SearchButton.MouseLeave=function()
	mapWindow.SearchButton:SetBackground("GaranStuff/MoorMap/Resources/Search.tga");
	mapWindow.SearchHover:Close();
end
mapWindow.SearchButton.MouseClick=function()
	mapWindow.SearchPanel:SetVisible(not mapWindow.SearchPanel:IsVisible());
	mapWindow.Map.IconSearch:SetWantsUpdates(mapWindow.SearchPanel:IsVisible());
end
mapWindow.SearchHover=Turbine.UI.ContextMenu();
mapWindow.SearchHover:GetItems():Add(Turbine.UI.MenuItem(Resource[language][220]));
mapWindow.SearchButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.SearchHover:ShowMenuAt(x+2,y+15);
end


mapWindow.SearchButton2=Turbine.UI.Control();
mapWindow.SearchButton2:SetParent(mapWindow.ControlPanel);
mapWindow.SearchButton2:SetBackground("GaranStuff/MoorMap/Resources/Search2.tga");
mapWindow.SearchButton2:SetSize(32,32);
mapWindow.SearchButton2:SetLeft(mapWindow.SearchButton:GetLeft()+mapWindow.SearchButton:GetWidth()+5);
mapWindow.SearchButton2.MouseEnter=function()
	mapWindow.SearchButton2:SetBackground("GaranStuff/MoorMap/Resources/Search2_hover.tga");
end
mapWindow.SearchButton2.MouseLeave=function()
	mapWindow.SearchButton2:SetBackground("GaranStuff/MoorMap/Resources/Search2.tga");
	mapWindow.SearchHover2:Close();
end
mapWindow.SearchButton2.MouseClick=function()
	searchWindow:SetVisible(true);
end
mapWindow.SearchHover2=Turbine.UI.ContextMenu();
mapWindow.SearchHover2:GetItems():Add(Turbine.UI.MenuItem(Resource[language][220]));
mapWindow.SearchButton2.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.SearchHover2:ShowMenuAt(x+2,y+15);
end

mapWindow.PlayerIconVisible=false;

mapWindow.LocationContainer=Turbine.UI.Control();
mapWindow.LocationContainer:SetParent(mapWindow.ControlPanel);
mapWindow.LocationContainer:SetSize(22,22);
mapWindow.LocationContainer:SetPosition(mapWindow.SearchButton2:GetLeft()+mapWindow.SearchButton2:GetWidth()+10,9);

mapWindow.LocationQuickSlot=Turbine.UI.Lotro.Quickslot();
mapWindow.LocationQuickSlot:SetParent(mapWindow.LocationContainer);
mapWindow.LocationQuickSlot:SetSize(66,66);
mapWindow.LocationQuickSlot:SetPosition(-34,-34);
mapWindow.LocationQuickSlot:SetAllowDrop(false);
local locSC=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "");
if locale=="en" then
	locSC:SetData("/loc"); -- resource[1][210]
elseif locale=="fr" then
	locSC:SetData("/emp");
elseif locale=="de" then
	locSC:SetData("/pos");
end
mapWindow.LocationQuickSlot:SetShortcut(locSC);
mapWindow.LocationQuickSlot:SetVisible(true);
mapWindow.LocationQuickSlot.DragDrop=function()
	-- reestablish the shortcut if the user accidentally drags it onto itmapWindow which wipes it out
	local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "");
	sc:SetData(Resource[language][210]);
	mapWindow.LocationQuickSlot:SetShortcut(sc);
end

mapWindow.LocationButton=Turbine.UI.Control();
mapWindow.LocationButton:SetParent(mapWindow.ControlPanel);
mapWindow.LocationButton:SetSize(32,32);
mapWindow.LocationButton:SetBackground("GaranStuff/MoorMap/Resources/Location.tga");
mapWindow.LocationButton:SetPosition(mapWindow.SearchButton2:GetLeft()+mapWindow.SearchButton2:GetWidth()+5,0);
mapWindow.LocationButton:SetMouseVisible(false);

mapWindow.OverlayButton=Turbine.UI.Control();
mapWindow.OverlayButton:SetParent(mapWindow.ControlPanel);
mapWindow.OverlayButton:SetSize(32,32);
mapWindow.OverlayButton:SetPosition(mapWindow.LocationButton:GetLeft()+mapWindow.LocationButton:GetWidth()+5,0);
mapWindow.OverlayButton:SetBackground("Garanstuff/MoorMap/Resources/Overlay.tga")
mapWindow.OverlayHover=Turbine.UI.ContextMenu();
mapWindow.OverlayHover:GetItems():Add(Turbine.UI.MenuItem(Resource[language][219]));

mapWindow.OverlayButton.MouseEnter=function()
	mapWindow.OverlayButton:SetBackground("Garanstuff/MoorMap/Resources/Overlay_hover.tga")
end
mapWindow.OverlayButton.MouseLeave=function()
	mapWindow.OverlayButton:SetBackground("Garanstuff/MoorMap/Resources/Overlay.tga")
	mapWindow.OverlayHover:Close();
end
mapWindow.OverlayButton.MouseClick=function()
	overlayWindow:SetVisible(not overlayWindow:IsVisible());
end
mapWindow.OverlayButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.OverlayHover:ShowMenuAt(x+2,y+15)
end

mapWindow.BreadcrumbButton=Turbine.UI.Control();
mapWindow.BreadcrumbButton:SetParent(mapWindow.ControlPanel);
mapWindow.BreadcrumbButton:SetSize(32,32);
mapWindow.BreadcrumbButton:SetPosition(mapWindow.OverlayButton:GetLeft()+mapWindow.OverlayButton:GetWidth()+5,0);
mapWindow.BreadcrumbButton:SetBackground("Garanstuff/MoorMap/Resources/BreadcrumbButton.tga")
mapWindow.BreadcrumbHover=Turbine.UI.ContextMenu();
mapWindow.BreadcrumbHover:GetItems():Add(Turbine.UI.MenuItem(Resource[language][238]));

mapWindow.BreadcrumbButton.MouseEnter=function()
	mapWindow.BreadcrumbButton:SetBackground("Garanstuff/MoorMap/Resources/BreadcrumbButton_hover.tga")
end
mapWindow.BreadcrumbButton.MouseLeave=function()
	mapWindow.BreadcrumbButton:SetBackground("Garanstuff/MoorMap/Resources/BreadcrumbButton.tga")
	mapWindow.BreadcrumbHover:Close();
end
mapWindow.BreadcrumbButton.MouseClick=function()
	breadcrumbWindow:SetVisible(not breadcrumbWindow:IsVisible());
end
mapWindow.BreadcrumbButton.MouseHover=function()
	local x,y=Turbine.UI.Display:GetMousePosition()
	mapWindow.BreadcrumbHover:ShowMenuAt(x+2,y+15)
end

mapWindow.LocationContainer.MouseEnter=function()
	mapWindow.LocationButton:SetBackground("GaranStuff/MoorMap/Resources/Location_hover.tga");
end
mapWindow.LocationContainer.MouseLeave=function()
	mapWindow.LocationButton:SetBackground("GaranStuff/MoorMap/Resources/Location.tga");
end

mapWindow.LocationContainer.MouseUp=function(sender,args)
	-- reestablish the quickslot incase the user dragged it out...
	if locale=="fr" then
		mapWindow.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
	elseif locale=="de" then
		mapWindow.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;pos"))
	else
		mapWindow.LocationQuickSlot:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/Moormap setloc ;loc"))
	end
	mapWindow.LocationQuickSlot:SetVisible(true);
end
-- create Chat listener for the /loc command

mapWindow.chatListener=function(sender, args)
	-- check message for standard channel matching "You are at: r.* lx.* ly.* ox.* oy.* oz.* h.*"
--Votre emplacement est: r1 lx941 ly948 ox104.77 oy82.95 oz389.86 h300.9
--Ihr befindet Euch hier: r1 lx938 ly948 ox53.66 oy85.26 oz388.50 h300.9
	local locationString,headingString,patternString1,patternString2,patternString3,patternString4;
	if locale=="en" then
		locationString="You are at: r.*"
		headingString="You are at: r.* h.*"
		patternString1="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="You are at: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	elseif locale=="fr" then
		locationString="Votre emplacement .*: r.*"
		headingString="Votre emplacement .*: r.* h.*"
		patternString1="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="Votre emplacement est.*: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	else
		locationString="Ihr befindet Euch hier: r.*"
		headingString="Ihr befindet Euch hier: r.* h.*"
		patternString1="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString2="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
		patternString3="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) ox(%d+%.?%d*) oy(%d+%.?%d*) oz(%d+%.?%d*)"
		patternString4="Ihr befindet Euch hier: r(%d+) lx(%d+%.?%d*) ly(%d+%.?%d*) i(%d+) cInside ox(.-%d+%.?%d*) oy(.-%d+%.?%d*) oz(.-%d+%.?%d*)"
	end
	if (args.ChatType==Turbine.ChatType.Standard or (debug and args.ChatType==Turbine.ChatType.Tell)) and string.find(args.Message,locationString)~=nil then
		local region, lx, ly, ox, oy, oz, heading;
		if string.find(args.Message,headingString)==nil then
			-- there is a carriage return at the end of the message :(
			heading=0;
			region, lx, ly, ox, oy, oz = string.match(args.Message,patternString1);
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2);
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3);
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4);
					end
				end
			end
		else
			region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString1.." h(%d+%.?%d*)");
			if region==nil then
				--You are at: r1 lx1984 ly1536 cInside ox105.19 oy-11.28 oz-56.47 h129.4
				region, lx, ly, ox, oy, oz, heading = string.match(args.Message,patternString2.." h(%d+%.?%d*)");
				if region==nil then
					region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString3.." h(%d+%.?%d*)");
					if region==nil then
						region, lx, ly, i, ox, oy, oz, heading = string.match(args.Message,patternString4.." h(%d+%.?%d*).*");
					end
				end
			end
		end
		if debug then
			Turbine.Shell.WriteLine("/loc values")
			Turbine.Shell.WriteLine("region:"..tostring(region))
			Turbine.Shell.WriteLine("lx:"..tostring(lx))
			Turbine.Shell.WriteLine("ly:"..tostring(ly))
			Turbine.Shell.WriteLine("c:"..tostring(c))
			Turbine.Shell.WriteLine("i:"..tostring(i))
			Turbine.Shell.WriteLine("ox:"..tostring(ox))
			Turbine.Shell.WriteLine("oy:"..tostring(oy))
			Turbine.Shell.WriteLine("oz:"..tostring(oz))
			Turbine.Shell.WriteLine("heading:"..tostring(heading))
		end
		if region ~= nil then
			if heading ==nil then
				-- when facing north the heading value is not present
				heading=0
			end
			region=tonumber(region);
			ox=euroNormalize(ox);
			oy=euroNormalize(oy);
			oz=euroNormalize(oz);
			heading=euroNormalize(heading);
				mapWindow.PlayerIconVisible=false;
			local ew,ns=(( math.floor( lx / 8 ) * 160 + ox ) - 29360) / 200,(( math.floor( ly / 8 ) * 160 + oy ) - 24880) / 200;

			-- check if the coordinates are on the current map
			if mapInfo[mapWindow.CurrentMapID][12]==tonumber(region) then -- same region
				if mapInfo[mapWindow.CurrentMapID][13]>=ns and mapInfo[mapWindow.CurrentMapID][15]<=ns and mapInfo[mapWindow.CurrentMapID][14]<=ew and mapInfo[mapWindow.CurrentMapID][16]>=ew then
					if debug then
						Turbine.Shell.WriteLine("on current map")
					end
					-- coordinates fall on current map
					mapWindow.Heading=heading;
					mapWindow.PlayerIconVisible=true;
					-- move the icon to the correct coordinates
					local X=math.floor(ew*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
					local Y=math.floor(ns*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
					if debug then
						Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
					end
					mapWindow.LocationIcon.X=X;
					mapWindow.LocationIcon.Y=Y;
					-- if control is down then add breadcrumb
					if mapWindow:IsControlKeyDown() then
						local tmpIconIndex;
						if mapWindow.Breadcrumbs==nil or #mapWindow.Breadcrumbs==0 then
							mapWindow.Breadcrumbs={};
							mapWindow.mapbreadcrumbImage={};
						end
						tmpIconIndex=#mapWindow.Breadcrumbs+1;

						mapWindow.Breadcrumbs[tmpIconIndex]={ew,ns};
						if mapWindow.Map.breadcrumbImage==nil then mapWindow.Map.breadcrumbImage={} end;
						mapWindow.Map.breadcrumbImage[tmpIconIndex]=Turbine.UI.Control();
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetParent(mapWindow.Map);
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetSize(5,5);
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetPosition(math.floor(X-2.5),math.floor(Y-2.5));
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColor(breadcrumbColor);
						mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
						if mapWindow.Map.breadcrumbImage[1].Update==nil then
							mapWindow.Map.breadcrumbImage[1].Update=function()
								RefreshBreadcrumbs();
							end
						end
					end
					-- need to adjust for the stretching
					X=X*mapWindow:GetWidth()/mapInfo[mapWindow.CurrentMapID][4]-14
					Y=Y*mapWindow:GetHeight()/mapInfo[mapWindow.CurrentMapID][5]-14
					mapWindow.LocationIcon:SetPosition(X,Y);
					if mapWindow:IsVisible() then
						mapWindow.LocationIcon:SetVisible(true);
						mapWindow.LocationIcon:SetRotation({x=0,y=0,z=0-(mapWindow.Heading-90)});
					end
					mapWindow.LocationIcon:SetZOrder(101+#mapWindow.Map.Icons);
					-- and activate a "ping" for it
					mapWindow.Map.Ping:SetZOrder(mapWindow.LocationIcon:GetZOrder()+1);
					mapWindow.Map.Ping:SetPosition(math.floor(mapWindow.LocationIcon.X-11.5),math.floor(mapWindow.LocationIcon.Y-11.5));
					mapWindow.Map.Ping.State=1;
					mapWindow.Map.Ping:SetVisible(true);
					mapWindow.Map.Ping:SetWantsUpdates(true);
				else
					if defAnnWindow==nil or not defAnnWindow:IsVisible() then
						local bestMap=ResolveMap(region,ns,ew,true)[1]
						-- now to reload the map and force a ping at location
						mapWindow.playerNS=ns
						mapWindow.playerEW=ew
						mapWindow.Heading=heading
						mapWindow.showLocOnReload=true
						RefreshMap(bestMap)
						if debug then
							Turbine.Shell.WriteLine("NOT on current map")
							Turbine.Shell.WriteLine("Best Map="..tostring(bestMap))
							local X=math.floor(ew*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
							local Y=math.floor(ns*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
							Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
						end
					end
				end
			else
				local bestMap=ResolveMap(region,ns,ew,true)[1]
				mapWindow.playerNS=ns
				mapWindow.playerEW=ew
				mapWindow.Heading=heading
				mapWindow.showLocOnReload=true
				RefreshMap(bestMap)
				if debug then
					Turbine.Shell.WriteLine("NOT on current map")
					Turbine.Shell.WriteLine("Best Map="..tostring(bestMap))
					local X=math.floor(ew*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
					local Y=math.floor(ns*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
					Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
				end
			end
			if defAnnWindow~=nil then
				-- update the defAnnWindow with the more precise coords
				if ew<0 then
					ew=0-ew
					defAnnWindow.EWButtons:SetSelectedChoice(2);
				else
					defAnnWindow.EWButtons:SetSelectedChoice(1);
				end
				if ns<0 then
					ns=0-ns
					defAnnWindow.NSButtons:SetSelectedChoice(2);
				else
					defAnnWindow.NSButtons:SetSelectedChoice(1);
				end
				defAnnWindow.EWCoordText:SetText(math.floor(ew*100+.5)/100);
				defAnnWindow.NSCoordText:SetText(math.floor(ns*100+.5)/100);
			end
		end
	end
end

AddCallback(Turbine.Chat, "Received", mapWindow.chatListener)
mapWindow.LocationIcon=Turbine.UI.Window();
mapWindow.LocationIcon:SetParent(mapWindow);
mapWindow.LocationIcon:SetSize(28,28)
mapWindow.LocationIcon:SetBackground(0x41007f4c);
mapWindow.LocationIcon:SetVisible(false);
mapWindow.LocationIcon:SetMouseVisible(false);
mapWindow.LocationIcon.X=0;
mapWindow.LocationIcon.Y=0;
if mapWindow.Heading==nil then
	mapWindow.Heading=0;
end

mapWindow.NSCoord=Turbine.UI.Label();
mapWindow.NSCoord:SetParent(mapWindow.ControlPanel);
mapWindow.NSCoord:SetSize(45,18);
mapWindow.NSCoord:SetPosition(mapWindow.BreadcrumbButton:GetLeft()+mapWindow.BreadcrumbButton:GetWidth()+5,6);
mapWindow.NSCoord:SetForeColor(fontColor);
mapWindow.NSCoord:SetBackColor(backColor);
mapWindow.NSCoord:SetFont(fontFace);
mapWindow.NSCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.NSCoord:SetText("");

mapWindow.EWCoord=Turbine.UI.Label();
mapWindow.EWCoord:SetParent(mapWindow.ControlPanel);
mapWindow.EWCoord:SetSize(45,18);
mapWindow.EWCoord:SetPosition(mapWindow.NSCoord:GetLeft()+mapWindow.NSCoord:GetWidth()+5,6);
mapWindow.EWCoord:SetForeColor(fontColor);
mapWindow.EWCoord:SetBackColor(backColor);
mapWindow.EWCoord:SetFont(fontFace);
mapWindow.EWCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.EWCoord:SetText("");

if mapWindow.CurrentMapID==2 then
	-- we don't show coords on world map since they are meaningless (and erroneous)
	mapWindow.NSCoord:SetVisible(false);
	mapWindow.EWCoord:SetVisible(false);
end

mapWindow.MapSelect=DropDownList()
mapWindow.MapSelect:SetParent(mapWindow);
mapWindow.MapSelect:SetSize(280,20); -- the excess space is used in German and French map names
mapWindow.MapSelect:SetPosition(mapWindow.EWCoord:GetLeft()+mapWindow.EWCoord:GetWidth()+5,9);
mapWindow.MapSelect:SetStretchMode(3);
mapWindow.MapSelect:SetBorderColor(trimColor);
mapWindow.MapSelect:SetBackColor(backColor);
mapWindow.MapSelect.CurrentValue:SetBackColor(backColor);
mapWindow.MapSelect:SetTextColor(listTextColor);
mapWindow.MapSelect:SetDropRows(15);

mapWindow.MapSelect:SetSelectedIndex(1);
mapWindow.MapSelect.SelectedIndexChanged=function()
	mapWindow.PreserveMapID=true;
	if debug then Turbine.Shell.WriteLine("mapWindow.MapSelect:GetValue()="..tostring(mapWindow.MapSelect:GetValue())) end
	RefreshMap(mapWindow.MapSelect:GetValue());
end

mapWindow.OverlaySelect=Turbine.UI.ListBox();
mapWindow.OverlaySelect:SetParent(mapWindow);
mapWindow.OverlaySelect:SetSize(280,20);

if mapWindow:GetWidth()<mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth()+mapWindow.OverlaySelect:GetWidth() then
	mapWindow.OverlaySelect:SetPosition(mapWindow.ControlPanel:GetLeft(),mapWindow.ControlPanel:GetTop()+mapWindow.ControlPanel:GetHeight()+2)
else
	mapWindow.OverlaySelect:SetPosition(mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth(),mapWindow.MapSelect:GetTop())
end

mapWindow.OverlaySelect:SetStretchMode(3);
mapWindow.OverlayVScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.OverlayVScroll:SetSize(10,20);
mapWindow.OverlayVScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.OverlayVScroll:SetPosition(mapWindow.OverlaySelect:GetLeft()+mapWindow.OverlaySelect:GetWidth(),9);
mapWindow.OverlayVScroll:SetStretchMode(3);
mapWindow.OverlayVScroll:SetBackColor(Turbine.UI.Color.Black);
mapWindow.OverlayVScroll:SetVisible(false);

local tmpRow=Turbine.UI.Label();
tmpRow:SetSize(280,20);
tmpRow:SetText(Resource[language][295]);
tmpRow:SetFont(Turbine.UI.Lotro.Font.Verdana18);
tmpRow:SetForeColor(Turbine.UI.Color(.8,.8,1));
tmpRow:SetOutlineColor(Turbine.UI.Color(0,0,1));
tmpRow:SetFontStyle(Turbine.UI.FontStyle.Outline);
tmpRow:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
tmpRow:SetParent(mapWindow.OverlaySelect);
tmpRow.MouseHover=function(sender)
	sender.MouseClick(sender);
end
tmpRow.MouseClick=function(sender)
	local height=20*mapWindow.OverlaySelect:GetItemCount();
	if height>mapWindow:GetHeight()-18 then
		height=mapWindow:GetHeight()-18;
		mapWindow.OverlayVScroll:SetHeight(height);
		mapWindow.OverlaySelect:SetVerticalScrollBar(mapWindow.OverlayVScroll);
		mapWindow.OverlayVScroll:SetParent(mapWindow);
		mapWindow.OverlayVScroll:SetVisible(true);
	else
		mapWindow.OverlayVScroll:SetParent(nil);
		mapWindow.OverlaySelect:SetVerticalScrollBar(nil);
	end
	mapWindow.OverlaySelect:SetBackColor(Turbine.UI.Color.Black);
	mapWindow.OverlaySelect:SetHeight(height);
end
mapWindow.OverlaySelect:AddItem(tmpRow);

mapWindow.XCoord=Turbine.UI.Label();
mapWindow.XCoord:SetParent(mapWindow.ControlPanel);
mapWindow.XCoord:SetSize(45,18);
mapWindow.XCoord:SetPosition(mapWindow.OverlaySelect:GetLeft()+mapWindow.OverlaySelect:GetWidth()+15,6);
mapWindow.XCoord:SetForeColor(fontColor);
mapWindow.XCoord:SetBackColor(backColor);
mapWindow.XCoord:SetFont(fontFace);
mapWindow.XCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.XCoord:SetText("");
mapWindow.XCoord:SetVisible(debug)

mapWindow.YCoord=Turbine.UI.Label();
mapWindow.YCoord:SetParent(mapWindow.ControlPanel);
mapWindow.YCoord:SetSize(45,18);
mapWindow.YCoord:SetPosition(mapWindow.XCoord:GetLeft()+mapWindow.XCoord:GetWidth()+5,6);
mapWindow.YCoord:SetForeColor(fontColor);
mapWindow.YCoord:SetBackColor(backColor);
mapWindow.YCoord:SetFont(fontFace);
mapWindow.YCoord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.YCoord:SetText("");
mapWindow.YCoord:SetVisible(debug)

mapWindow.CloseButton=Turbine.UI.Control();
mapWindow.CloseButton:SetParent(mapWindow);
mapWindow.CloseButton:SetStretchMode(3);
mapWindow.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
mapWindow.CloseButton:SetSize(16,16);
mapWindow.CloseButton:SetLeft(mapWindow.Map:GetWidth()-20);
mapWindow.CloseButton.MouseEnter = function()
	mapWindow.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close_hover.tga");
end
mapWindow.CloseButton.MouseLeave = function()
	mapWindow.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
end
mapWindow.CloseButton.MouseClick=function()
	mapWindow:SetVisible(false);
	if mapWindow.PopUp~=nil and not mapWindow.PopUp:IsPinned() then
		mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
		mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
		mapWindow.PopUp:SetVisible(false);
		mapWindow.PopUp=nil; -- dismiss the dialog
	end
	if BDDLegend~=nil then
		BDDLegend:SetVisible(false)
	end
end

mapWindow.Map.Icons={};
mapWindow.Map.MapPoints={};
mapWindow.Map.MapPoints.Item={};

mapWindow.SearchPanel=Turbine.UI.Control();
mapWindow.SearchPanel:SetParent(mapWindow);
mapWindow.SearchPanel:SetPosition(mapWindow:GetWidth()-400,35);
mapWindow.SearchPanel:SetSize(380,mapWindow:GetHeight()-50);
mapWindow.SearchPanel:SetBackColor(Turbine.UI.Color(.05,.07,.12));
mapWindow.SearchPanel:SetVisible(false);
mapWindow.SearchPanel:SetStretchMode(3);
mapWindow.Map.SearchFilterCaption=Turbine.UI.Label();
mapWindow.Map.SearchFilterCaption:SetParent(mapWindow.SearchPanel);
mapWindow.Map.SearchFilterCaption:SetPosition(0,4);
mapWindow.Map.SearchFilterCaption:SetSize(55,18);
mapWindow.Map.SearchFilterCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.Map.SearchFilterCaption:SetForeColor(fontColor);
mapWindow.Map.SearchFilterCaption:SetText(Resource[language][65]..":");

mapWindow.Map.IconSearch=Turbine.UI.Lotro.TextBox();
mapWindow.Map.IconSearch:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconSearch:SetSize(mapWindow.SearchPanel:GetWidth()-57,20);
mapWindow.Map.IconSearch:SetFont(fontFace);
mapWindow.Map.IconSearch:SetPosition(56,0);
mapWindow.Map.IconSearch:SetText("");
mapWindow.Map.IconSearch.OldText="";
mapWindow.Map.IconSearch.OldAllegianceCreep=true;
mapWindow.Map.IconSearch.OldAllegianceFreep=true;
mapWindow.Map.IconSearch.OldAllegianceDelving=true;
mapWindow.Map.IconSearch.Update=function(sender)
	if mapWindow.Map.IconSearch:GetText()~=mapWindow.Map.IconSearch.OldText or mapWindow.Map.IconSearch.OldAllegianceCreep~=mapWindow.Map.IconCreepCB:IsChecked() or mapWindow.Map.IconSearch.OldAllegianceFreep~=mapWindow.Map.IconFreepCB:IsChecked() or mapWindow.Map.IconSearch.OldAllegianceDelving~=mapWindow.Map.IconDelvingCB:IsChecked() then
		mapWindow.Map.IconSearch.OldText=mapWindow.Map.IconSearch:GetText();
		mapWindow.Map.IconSearch.OldAllegianceCreep=mapWindow.Map.IconCreepCB:IsChecked();
		mapWindow.Map.IconSearch.OldAllegianceFreep=mapWindow.Map.IconFreepCB:IsChecked();
		mapWindow.Map.IconSearch.OldAllegianceDelving=mapWindow.Map.IconDelvingCB:IsChecked();
		-- filter the results by search string and checkboxes ...
		local tmpIndex;
		local tmpHeight;
		local tmpAnnotationIndex;
		local tmpSearchText=string.lower(string.stripaccent(mapWindow.Map.IconSearch:GetText()))
		for tmpIndex=1,mapWindow.Map.IconList:GetItemCount() do
			tmpHeight=mapWindow.Map.IconList:GetItem(tmpIndex).NormalHeight

			tmpAnnotationIndex=mapWindow.Map.IconList:GetItem(tmpIndex).AnnotationIndex
			if tmpAnnotationIndex~=nil and tmpAnnotationIndex~=0 then
				if annotations[tmpAnnotationIndex][5]==2 then
					if not mapWindow.Map.IconCreepCB:IsChecked() then tmpHeight=0 end
				elseif annotations[tmpAnnotationIndex][5]==3 then
					if not mapWindow.Map.IconFreepCB:IsChecked() then tmpHeight=0 end
				elseif annotations[tmpAnnotationIndex][5]==4 then
					if not mapWindow.Map.IconDelvingCB:IsChecked() then tmpHeight=0 end
				end

				if tmpHeight>0 and mapWindow.Map.IconSearch:GetText()~="" then
					if string.find(string.lower(string.stripaccent(mapWindow.Map.IconList:GetItem(tmpIndex):GetText())),tmpSearchText,nil,true)==nil then
						tmpHeight=0;
					end
				end
			end
			mapWindow.Map.IconList:GetItem(tmpIndex):SetHeight(tmpHeight);
		end
	end
end

mapWindow.Map.IconCreepCB=Turbine.UI.Lotro.CheckBox();
mapWindow.Map.IconCreepCB:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconCreepCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.Map.IconCreepCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.IconCreepCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.IconCreepCB:SetForeColor(Turbine.UI.Color(1,0,0));
mapWindow.Map.IconCreepCB:SetSize(mapWindow.SearchPanel:GetWidth()/3-1,18);
mapWindow.Map.IconCreepCB:SetPosition(2,24);
mapWindow.Map.IconCreepCB:SetText(Resource[language][68]);
mapWindow.Map.IconCreepCB:SetChecked(true);
mapWindow.Map.IconCreepCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.Map.IconCreepCBHS:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconCreepCBHS:SetSize(mapWindow.Map.IconCreepCB:GetSize());
mapWindow.Map.IconCreepCBHS:SetPosition(mapWindow.Map.IconCreepCB:GetPosition());
mapWindow.Map.IconCreepCBHS.MouseClick=function()
	mapWindow.Map.IconCreepCB:SetChecked(not mapWindow.Map.IconCreepCB:IsChecked());
end
mapWindow.Map.IconCreepCBHS:SetZOrder(mapWindow.Map.IconCreepCB:GetZOrder()+1);

mapWindow.Map.IconFreepCB=Turbine.UI.Lotro.CheckBox();
mapWindow.Map.IconFreepCB:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconFreepCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.Map.IconFreepCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.IconFreepCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.IconFreepCB:SetForeColor(Turbine.UI.Color(.35,.35,1));
mapWindow.Map.IconFreepCB:SetSize(mapWindow.SearchPanel:GetWidth()/3-1,18);
mapWindow.Map.IconFreepCB:SetPosition(mapWindow.SearchPanel:GetWidth()/3+2,24);
mapWindow.Map.IconFreepCB:SetText(Resource[language][69]);
mapWindow.Map.IconFreepCB:SetChecked(true);
mapWindow.Map.IconFreepCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.Map.IconFreepCBHS:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconFreepCBHS:SetSize(mapWindow.Map.IconFreepCB:GetSize());
mapWindow.Map.IconFreepCBHS:SetPosition(mapWindow.Map.IconFreepCB:GetPosition());
mapWindow.Map.IconFreepCBHS.MouseClick=function()
	mapWindow.Map.IconFreepCB:SetChecked(not mapWindow.Map.IconFreepCB:IsChecked());
end
mapWindow.Map.IconFreepCBHS:SetZOrder(mapWindow.Map.IconFreepCB:GetZOrder()+1);

mapWindow.Map.IconDelvingCB=Turbine.UI.Lotro.CheckBox();
mapWindow.Map.IconDelvingCB:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconDelvingCB:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.Map.IconDelvingCB:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.IconDelvingCB:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.IconDelvingCB:SetForeColor(Turbine.UI.Color(.5,.35,.7));
mapWindow.Map.IconDelvingCB:SetSize(mapWindow.SearchPanel:GetWidth()/3-1,18);
mapWindow.Map.IconDelvingCB:SetPosition(mapWindow.SearchPanel:GetWidth()*2/3+2,24);
mapWindow.Map.IconDelvingCB:SetText(Resource[language][70]);
mapWindow.Map.IconDelvingCB:SetChecked(true);
mapWindow.Map.IconDelvingCBHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.Map.IconDelvingCBHS:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconDelvingCBHS:SetSize(mapWindow.Map.IconDelvingCB:GetSize());
mapWindow.Map.IconDelvingCBHS:SetPosition(mapWindow.Map.IconDelvingCB:GetPosition());
mapWindow.Map.IconDelvingCBHS.MouseClick=function()
	mapWindow.Map.IconDelvingCB:SetChecked(not mapWindow.Map.IconDelvingCB:IsChecked());
end
mapWindow.Map.IconDelvingCBHS:SetZOrder(mapWindow.Map.IconDelvingCB:GetZOrder()+1);

mapWindow.Map.IconList=Turbine.UI.ListBox();
mapWindow.Map.IconList:SetParent(mapWindow.SearchPanel);
mapWindow.Map.IconList:SetSize(mapWindow.SearchPanel:GetWidth(),mapWindow.SearchPanel:GetHeight()-46);
mapWindow.Map.IconList:SetPosition(0,46);
mapWindow.Map.IconList:SetBackColor(Turbine.UI.Color(.05,.07,.12));

mapWindow.Map.IconSearch:SetWantsUpdates(false);
mapWindow.Map.IconList.VScroll=Turbine.UI.Lotro.ScrollBar();
mapWindow.Map.IconList.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.Map.IconList.VScroll:SetParent(mapWindow.Map.IconList);
mapWindow.Map.IconList.VScroll:SetBackColor(backColor);
mapWindow.Map.IconList.VScroll:SetPosition(mapWindow.Map.IconList:GetWidth()-12,0);
mapWindow.Map.IconList.VScroll:SetWidth(12);
mapWindow.Map.IconList.VScroll:SetHeight(mapWindow.Map.IconList:GetHeight());
mapWindow.Map.IconList:SetVerticalScrollBar(mapWindow.Map.IconList.VScroll);
mapWindow.Map.IconList.VScroll:SetVisible(false);

mapWindow.FilterPanel=Turbine.UI.Control();
mapWindow.FilterPanel:SetParent(mapWindow);
mapWindow.FilterPanel:SetPosition(20,35);
mapWindow.FilterPanel:SetSize(390,mapWindow:GetHeight()-50);
mapWindow.FilterPanel:SetStretchMode(3);
mapWindow.FilterPanel:SetBackColor(Turbine.UI.Color(.10,.07,.05));
mapWindow.FilterPanel:SetVisible(false);

mapWindow.FilterPanel.CloseButton=Turbine.UI.Control();
mapWindow.FilterPanel.CloseButton:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.CloseButton:SetBlendMode(Turbine.UI.BlendMode.Overlay);
mapWindow.FilterPanel.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
mapWindow.FilterPanel.CloseButton:SetSize(16,16);
mapWindow.FilterPanel.CloseButton:SetTop(4);
mapWindow.FilterPanel.CloseButton:SetLeft(mapWindow.FilterPanel:GetWidth()-20);
mapWindow.FilterPanel.CloseButton.MouseEnter = function()
	mapWindow.FilterPanel.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close_hover.tga");
end
mapWindow.FilterPanel.CloseButton.MouseLeave = function()
	mapWindow.FilterPanel.CloseButton:SetBackground("GaranStuff/MoorMap/Resources/Close.tga");
end
mapWindow.FilterPanel.CloseButton.MouseClick=function()
	mapWindow.FilterPanel:SetVisible(false);
end
mapWindow.FilterPanel.Title=Turbine.UI.Label()
mapWindow.FilterPanel.Title:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.Title:SetSize(mapWindow.FilterPanel:GetWidth()-45,18);
mapWindow.FilterPanel.Title:SetPosition((mapWindow.FilterPanel:GetWidth()-mapWindow.FilterPanel.Title:GetWidth())/2,1);
mapWindow.FilterPanel.Title:SetFont(Turbine.UI.Lotro.Font.TrajanPro16);
mapWindow.FilterPanel.Title:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.FilterPanel.Title:SetText(Resource[language][66]);

mapWindow.FilterPanel.Separator1=Turbine.UI.Control();
mapWindow.FilterPanel.Separator1:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.Separator1:SetPosition(5,mapWindow.FilterPanel.Title:GetTop()+21);
mapWindow.FilterPanel.Separator1:SetSize(mapWindow.FilterPanel:GetWidth()-10,1);
mapWindow.FilterPanel.Separator1:SetBackColor(trimColor);

mapWindow.FilterPanel.ViewPane=Turbine.UI.Control()
mapWindow.FilterPanel.ViewPane:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.ViewPane:SetPosition(0,mapWindow.FilterPanel.Separator1:GetTop()+3);
mapWindow.FilterPanel.ViewPane:SetSize(380,mapWindow.FilterPanel:GetHeight()-mapWindow.FilterPanel.Separator1:GetTop()-3);
mapWindow.FilterPanel.ViewPane:SetBackColor(Turbine.UI.Color(.10,.07,.05));

mapWindow.FilterPanel.ScrollPanel=Turbine.UI.Control();
mapWindow.FilterPanel.ScrollPanel:SetParent(mapWindow.FilterPanel.ViewPane);
mapWindow.FilterPanel.ScrollPanel:SetPosition(0,0);
if mapWindow.CurrentMapID==1 then
	mapWindow.FilterPanel.ScrollPanel:SetSize(380,876);
else
	mapWindow.FilterPanel.ScrollPanel:SetSize(380,756);
end
mapWindow.FilterPanel.ScrollPanel:SetBackColor(Turbine.UI.Color(.10,.07,.05));
mapWindow.FilterPanel.VScroll=Turbine.UI.Lotro.ScrollBar();

mapWindow.FilterPanel.VScroll:SetParent(mapWindow.FilterPanel);
mapWindow.FilterPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
mapWindow.FilterPanel.VScroll:SetPosition(380,mapWindow.FilterPanel.ViewPane:GetTop());
mapWindow.FilterPanel.VScroll:SetSize(10,mapWindow.FilterPanel.ViewPane:GetHeight());

mapWindow.FilterPanel.VScroll.ValueChanged=function(sender,args)
	local lValue=mapWindow.FilterPanel.VScroll:GetValue();
	mapWindow.FilterPanel.ScrollPanel:SetTop(0-lValue);
end
mapWindow.FilterPanel.VScroll:SetMaximum(mapWindow.FilterPanel.ScrollPanel:GetHeight()-mapWindow.FilterPanel.ViewPane:GetHeight());
mapWindow.FilterPanel.VScroll:SetVisible(mapWindow.FilterPanel.ViewPane:GetHeight()<mapWindow.FilterPanel.ScrollPanel:GetHeight());

mapWindow.FilterPanel.AllegianceCaption=Turbine.UI.Label();
mapWindow.FilterPanel.AllegianceCaption:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceCaption:SetPosition(5,0);
mapWindow.FilterPanel.AllegianceCaption:SetSize(95,18);
mapWindow.FilterPanel.AllegianceCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.AllegianceCaption:SetForeColor(fontColor);
mapWindow.FilterPanel.AllegianceCaption:SetText(Resource[language][67]..":");

mapWindow.FilterPanel.AllegianceCreep=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.AllegianceCreep:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceCreep:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.AllegianceCreep:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.FilterPanel.AllegianceCreep:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.FilterPanel.AllegianceCreep:SetForeColor(Turbine.UI.Color(1,0,0));
mapWindow.FilterPanel.AllegianceCreep:SetSize((mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.AllegianceCaption:GetWidth()-10),18);
mapWindow.FilterPanel.AllegianceCreep:SetPosition(mapWindow.FilterPanel.AllegianceCaption:GetLeft()+mapWindow.FilterPanel.AllegianceCaption:GetWidth(),mapWindow.FilterPanel.AllegianceCaption:GetTop());
mapWindow.FilterPanel.AllegianceCreep:SetText(Resource[language][68]);
mapWindow.FilterPanel.AllegianceCreep:SetChecked(filterAllegianceCreep);
mapWindow.FilterPanel.AllegianceCreepHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.FilterPanel.AllegianceCreepHS:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceCreepHS:SetSize(mapWindow.FilterPanel.AllegianceCreep:GetSize());
mapWindow.FilterPanel.AllegianceCreepHS:SetPosition(mapWindow.FilterPanel.AllegianceCreep:GetPosition());
mapWindow.FilterPanel.AllegianceCreepHS.MouseClick=function()
	mapWindow.FilterPanel.AllegianceCreep:SetChecked(not mapWindow.FilterPanel.AllegianceCreep:IsChecked());
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.AllegianceCreepHS:SetZOrder(mapWindow.FilterPanel.AllegianceCreep:GetZOrder()+1);

mapWindow.FilterPanel.AllegianceFreep=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.AllegianceFreep:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceFreep:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.FilterPanel.AllegianceFreep:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.FilterPanel.AllegianceFreep:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.AllegianceFreep:SetForeColor(Turbine.UI.Color(.35,.35,1));
mapWindow.FilterPanel.AllegianceFreep:SetSize((mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.AllegianceCaption:GetWidth()-10),18);
mapWindow.FilterPanel.AllegianceFreep:SetPosition(mapWindow.FilterPanel.AllegianceCreep:GetLeft(),mapWindow.FilterPanel.AllegianceCreep:GetTop()+20);
mapWindow.FilterPanel.AllegianceFreep:SetText(Resource[language][69]);
mapWindow.FilterPanel.AllegianceFreep:SetChecked(filterAllegianceFreep);
mapWindow.FilterPanel.AllegianceFreepHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.FilterPanel.AllegianceFreepHS:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceFreepHS:SetSize(mapWindow.FilterPanel.AllegianceFreep:GetSize());
mapWindow.FilterPanel.AllegianceFreepHS:SetPosition(mapWindow.FilterPanel.AllegianceFreep:GetPosition());
mapWindow.FilterPanel.AllegianceFreepHS.MouseClick=function()
	mapWindow.FilterPanel.AllegianceFreep:SetChecked(not mapWindow.FilterPanel.AllegianceFreep:IsChecked());
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.AllegianceFreepHS:SetZOrder(mapWindow.FilterPanel.AllegianceFreep:GetZOrder()+1);

mapWindow.FilterPanel.AllegianceDelving=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.AllegianceDelving:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceDelving:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.FilterPanel.AllegianceDelving:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.FilterPanel.AllegianceDelving:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.AllegianceDelving:SetForeColor(Turbine.UI.Color(.5,.35,.7));
mapWindow.FilterPanel.AllegianceDelving:SetSize((mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.AllegianceCaption:GetWidth()-10),18);
mapWindow.FilterPanel.AllegianceDelving:SetPosition(mapWindow.FilterPanel.AllegianceCreep:GetLeft(),mapWindow.FilterPanel.AllegianceFreep:GetTop()+20);
mapWindow.FilterPanel.AllegianceDelving:SetText(Resource[language][70]);
mapWindow.FilterPanel.AllegianceDelving:SetChecked(filterAllegianceDelving);
mapWindow.FilterPanel.AllegianceDelvingHS=Turbine.UI.Control() -- this creates a hotspot over the entire control so we can capture the clicks and force the correct IsChecked() state
mapWindow.FilterPanel.AllegianceDelvingHS:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.AllegianceDelvingHS:SetSize(mapWindow.FilterPanel.AllegianceDelving:GetSize());
mapWindow.FilterPanel.AllegianceDelvingHS:SetPosition(mapWindow.FilterPanel.AllegianceDelving:GetPosition());
mapWindow.FilterPanel.AllegianceDelvingHS.MouseClick=function()
	mapWindow.FilterPanel.AllegianceDelving:SetChecked(not mapWindow.FilterPanel.AllegianceDelving:IsChecked());
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.AllegianceDelvingHS:SetZOrder(mapWindow.FilterPanel.AllegianceDelving:GetZOrder()+1);

mapWindow.FilterPanel.Separator2=Turbine.UI.Control();
mapWindow.FilterPanel.Separator2:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.Separator2:SetPosition(5,mapWindow.FilterPanel.AllegianceDelving:GetTop()+22);
mapWindow.FilterPanel.Separator2:SetSize(mapWindow.FilterPanel.ScrollPanel:GetWidth()-10,1);
mapWindow.FilterPanel.Separator2:SetBackColor(trimColor);

mapWindow.FilterPanel.SelectAllButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.SelectAllButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.SelectAllButton:SetSize(140,18);
mapWindow.FilterPanel.SelectAllButton:SetTop(mapWindow.FilterPanel.Separator2:GetTop()+6);
mapWindow.FilterPanel.SelectAllButton:SetLeft(5);
mapWindow.FilterPanel.SelectAllButton:SetText("Select All");
mapWindow.FilterPanel.SelectAllButton.MouseClick=function()
	-- we don't currently include allegiance in "select all"
	--mapWindow.FilterPanel.AllegianceCreep:SetChecked(true);
	--mapWindow.FilterPanel.AllegianceFreep:SetChecked(true);
	--mapWindow.FilterPanel.AllegianceDelving:SetChecked(true);
	-- set all Type filter options on
	mapWindow.FilterPanel.TypeMain:SetChecked(true);
	mapWindow.FilterPanel.TypeSecondary:SetChecked(true);
	mapWindow.FilterPanel.TypeBase:SetChecked(true);
	mapWindow.FilterPanel.TypeOutpost:SetChecked(true);
	mapWindow.FilterPanel.TypeFort:SetChecked(true);
	mapWindow.FilterPanel.TypePOI:SetChecked(true);
	mapWindow.FilterPanel.TypeRez:SetChecked(true);
	mapWindow.FilterPanel.TypeMap:SetChecked(true);
	mapWindow.FilterPanel.TypeNPC:SetChecked(true);
	mapWindow.FilterPanel.TypeCook:SetChecked(true);
	mapWindow.FilterPanel.TypeScholarIngredient:SetChecked(true);
	mapWindow.FilterPanel.TypeAuctioneer:SetChecked(true);
	mapWindow.FilterPanel.TypeBarber:SetChecked(true);
	mapWindow.FilterPanel.TypeBard:SetChecked(true);
	mapWindow.FilterPanel.TypeCampSite:SetChecked(true);
	mapWindow.FilterPanel.TypeCraftSite:SetChecked(true);
	mapWindow.FilterPanel.TypeCraftVendor:SetChecked(true);
	mapWindow.FilterPanel.TypeFactionRep:SetChecked(true);
	mapWindow.FilterPanel.TypeItemMaster:SetChecked(true);
	mapWindow.FilterPanel.TypeMailbox:SetChecked(true);
	mapWindow.FilterPanel.TypeMilestone:SetChecked(true);
	mapWindow.FilterPanel.TypeMusteringHorn:SetChecked(true);
	mapWindow.FilterPanel.TypeReflectingPool:SetChecked(true);
	mapWindow.FilterPanel.TypeSettlement:SetChecked(true);
	mapWindow.FilterPanel.TypeStableMaster:SetChecked(true);
	mapWindow.FilterPanel.TypeTaskboard:SetChecked(true);
	mapWindow.FilterPanel.TypeTownCrier:SetChecked(true);
	mapWindow.FilterPanel.TypeTrader:SetChecked(true);
	mapWindow.FilterPanel.TypeTrainer:SetChecked(true);
	mapWindow.FilterPanel.TypeVaultKeeper:SetChecked(true);
	mapWindow.FilterPanel.TypeVendor:SetChecked(true);
	mapWindow.FilterPanel.TypeSkirmishCamp:SetChecked(true);
	mapWindow.FilterPanel.TypeOreNode:SetChecked(true);
	mapWindow.FilterPanel.TypeWoodNode:SetChecked(true);
	mapWindow.FilterPanel.TypeScholarNode:SetChecked(true);
	mapWindow.FilterPanel.TypeDungeon:SetChecked(true);
	mapWindow.FilterPanel.TypeStair:SetChecked(true);
	mapWindow.FilterPanel.TypeQuest:SetChecked(true);

	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.ClearAllButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.ClearAllButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.ClearAllButton:SetSize(140,18);
mapWindow.FilterPanel.ClearAllButton:SetTop(mapWindow.FilterPanel.SelectAllButton:GetTop());
mapWindow.FilterPanel.ClearAllButton:SetLeft(mapWindow.FilterPanel.ScrollPanel:GetWidth()-145);
mapWindow.FilterPanel.ClearAllButton:SetText("Clear All");
mapWindow.FilterPanel.ClearAllButton.MouseClick=function()
	--mapWindow.FilterPanel.AllegianceCreep:SetChecked(false);
	--mapWindow.FilterPanel.AllegianceFreep:SetChecked(false);
	--mapWindow.FilterPanel.AllegianceDelving:SetChecked(false);
	-- set all Type filter options off
	mapWindow.FilterPanel.TypeMain:SetChecked(false);
	mapWindow.FilterPanel.TypeSecondary:SetChecked(false);
	mapWindow.FilterPanel.TypeBase:SetChecked(false);
	mapWindow.FilterPanel.TypeOutpost:SetChecked(false);
	mapWindow.FilterPanel.TypeFort:SetChecked(false);
	mapWindow.FilterPanel.TypePOI:SetChecked(false);
	mapWindow.FilterPanel.TypeRez:SetChecked(false);
	mapWindow.FilterPanel.TypeMap:SetChecked(false);
	mapWindow.FilterPanel.TypeNPC:SetChecked(false);
	mapWindow.FilterPanel.TypeCook:SetChecked(false);
	mapWindow.FilterPanel.TypeScholarIngredient:SetChecked(false);
	mapWindow.FilterPanel.TypeAuctioneer:SetChecked(false);
	mapWindow.FilterPanel.TypeBarber:SetChecked(false);
	mapWindow.FilterPanel.TypeBard:SetChecked(false);
	mapWindow.FilterPanel.TypeCampSite:SetChecked(false);
	mapWindow.FilterPanel.TypeCraftSite:SetChecked(false);
	mapWindow.FilterPanel.TypeCraftVendor:SetChecked(false);
	mapWindow.FilterPanel.TypeFactionRep:SetChecked(false);
	mapWindow.FilterPanel.TypeItemMaster:SetChecked(false);
	mapWindow.FilterPanel.TypeMailbox:SetChecked(false);
	mapWindow.FilterPanel.TypeMilestone:SetChecked(false);
	mapWindow.FilterPanel.TypeMusteringHorn:SetChecked(false);
	mapWindow.FilterPanel.TypeReflectingPool:SetChecked(false);
	mapWindow.FilterPanel.TypeSettlement:SetChecked(false);
	mapWindow.FilterPanel.TypeStableMaster:SetChecked(false);
	mapWindow.FilterPanel.TypeTaskboard:SetChecked(false);
	mapWindow.FilterPanel.TypeTownCrier:SetChecked(false);
	mapWindow.FilterPanel.TypeTrader:SetChecked(false);
	mapWindow.FilterPanel.TypeTrainer:SetChecked(false);
	mapWindow.FilterPanel.TypeVaultKeeper:SetChecked(false);
	mapWindow.FilterPanel.TypeVendor:SetChecked(false);
	mapWindow.FilterPanel.TypeSkirmishCamp:SetChecked(false);
	mapWindow.FilterPanel.TypeOreNode:SetChecked(false);
	mapWindow.FilterPanel.TypeWoodNode:SetChecked(false);
	mapWindow.FilterPanel.TypeScholarNode:SetChecked(false);
	mapWindow.FilterPanel.TypeDungeon:SetChecked(false);
	mapWindow.FilterPanel.TypeStair:SetChecked(false);
	mapWindow.FilterPanel.TypeQuest:SetChecked(false);

	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.SetDefaultButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.SetDefaultButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.SetDefaultButton:SetSize(140,18);
mapWindow.FilterPanel.SetDefaultButton:SetTop(mapWindow.FilterPanel.SelectAllButton:GetTop()+20);
mapWindow.FilterPanel.SetDefaultButton:SetLeft(5);
mapWindow.FilterPanel.SetDefaultButton:SetText("Select Default");
mapWindow.FilterPanel.SetDefaultButton.MouseClick=function()
	mapWindow.FilterPanel.TypeMain:SetChecked(mapWindow.FilterMainDefault);
	mapWindow.FilterPanel.TypeSecondary:SetChecked(mapWindow.FilterSecondaryDefault);
	mapWindow.FilterPanel.TypeBase:SetChecked(mapWindow.FilterBaseDefault);
	mapWindow.FilterPanel.TypeOutpost:SetChecked(mapWindow.FilterOutpostDefault);
	mapWindow.FilterPanel.TypeFort:SetChecked(mapWindow.FilterFortDefault);
	mapWindow.FilterPanel.TypePOI:SetChecked(mapWindow.FilterPOIDefault);
	mapWindow.FilterPanel.TypeRez:SetChecked(mapWindow.FilterRezDefault);
	mapWindow.FilterPanel.TypeMap:SetChecked(mapWindow.FilterMapDefault);
	mapWindow.FilterPanel.TypeNPC:SetChecked(mapWindow.FilterNPCDefault);
	mapWindow.FilterPanel.TypeCook:SetChecked(mapWindow.FilterCookDefault);
	mapWindow.FilterPanel.TypeScholarIngredient:SetChecked(mapWindow.FilterScholarIngredientDefault);
	mapWindow.FilterPanel.TypeAuctioneer:SetChecked(mapWindow.FilterAuctioneerDefault);
	mapWindow.FilterPanel.TypeBarber:SetChecked(mapWindow.FilterBarberDefault);
	mapWindow.FilterPanel.TypeBard:SetChecked(mapWindow.FilterBardDefault);
	mapWindow.FilterPanel.TypeCampSite:SetChecked(mapWindow.FilterCampSiteDefault);
	mapWindow.FilterPanel.TypeCraftSite:SetChecked(mapWindow.FilterCraftSiteDefault);
	mapWindow.FilterPanel.TypeCraftVendor:SetChecked(mapWindow.FilterCraftVendorDefault);
	mapWindow.FilterPanel.TypeFactionRep:SetChecked(mapWindow.FilterFactionRepDefault);
	mapWindow.FilterPanel.TypeItemMaster:SetChecked(mapWindow.FilterItemMasterDefault);
	mapWindow.FilterPanel.TypeMailbox:SetChecked(mapWindow.FilterMailboxDefault);
	mapWindow.FilterPanel.TypeMilestone:SetChecked(mapWindow.FilterMilestoneDefault);
	mapWindow.FilterPanel.TypeMusteringHorn:SetChecked(mapWindow.FilterMusteringHornDefault);
	mapWindow.FilterPanel.TypeReflectingPool:SetChecked(mapWindow.FilterReflectingPoolDefault);
	mapWindow.FilterPanel.TypeSettlement:SetChecked(mapWindow.FilterSettlementDefault);
	mapWindow.FilterPanel.TypeStableMaster:SetChecked(mapWindow.FilterStableMasterDefault);
	mapWindow.FilterPanel.TypeTaskboard:SetChecked(mapWindow.FilterTaskboardDefault);
	mapWindow.FilterPanel.TypeTownCrier:SetChecked(mapWindow.FilterTownCrierDefault);
	mapWindow.FilterPanel.TypeTrader:SetChecked(mapWindow.FilterTraderDefault);
	mapWindow.FilterPanel.TypeTrainer:SetChecked(mapWindow.FilterTrainerDefault);
	mapWindow.FilterPanel.TypeVaultKeeper:SetChecked(mapWindow.FilterVaultKeeperDefault);
	mapWindow.FilterPanel.TypeVendor:SetChecked(mapWindow.FilterVendorDefault);
	mapWindow.FilterPanel.TypeSkirmishCamp:SetChecked(mapWindow.FilterSkirmishCampDefault);
	mapWindow.FilterPanel.TypeOreNode:SetChecked(mapWindow.FilterOreNodeDefault);
	mapWindow.FilterPanel.TypeWoodNode:SetChecked(mapWindow.FilterWoodNodeDefault);
	mapWindow.FilterPanel.TypeScholarNode:SetChecked(mapWindow.FilterScholarNodeDefault);
	mapWindow.FilterPanel.TypeDungeon:SetChecked(mapWindow.FilterDungeonDefault);
	mapWindow.FilterPanel.TypeStair:SetChecked(mapWindow.FilterStairDefault);
	mapWindow.FilterPanel.TypeQuest:SetChecked(mapWindow.FilterQuestDefault);

	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.SaveDefaultButton=Turbine.UI.Lotro.Button();
mapWindow.FilterPanel.SaveDefaultButton:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.SaveDefaultButton:SetSize(140,18);
mapWindow.FilterPanel.SaveDefaultButton:SetTop(mapWindow.FilterPanel.SelectAllButton:GetTop()+20);
mapWindow.FilterPanel.SaveDefaultButton:SetLeft(mapWindow.FilterPanel.ScrollPanel:GetWidth()-145);
mapWindow.FilterPanel.SaveDefaultButton:SetText("Save Default");
mapWindow.FilterPanel.SaveDefaultButton.MouseClick=function()
	mapWindow.FilterMainDefault=mapWindow.FilterPanel.TypeMain:IsChecked();
	mapWindow.FilterSecondaryDefault=mapWindow.FilterPanel.TypeSecondary:IsChecked();
	mapWindow.FilterBaseDefault=mapWindow.FilterPanel.TypeBase:IsChecked();
	mapWindow.FilterOutpostDefault=mapWindow.FilterPanel.TypeOutpost:IsChecked();
	mapWindow.FilterFortDefault=mapWindow.FilterPanel.TypeFort:IsChecked();
	mapWindow.FilterPOIDefault=mapWindow.FilterPanel.TypePOI:IsChecked();
	mapWindow.FilterRezDefault=mapWindow.FilterPanel.TypeRez:IsChecked();
	mapWindow.FilterMapDefault=mapWindow.FilterPanel.TypeMap:IsChecked();
	mapWindow.FilterNPCDefault=mapWindow.FilterPanel.TypeNPC:IsChecked();
	mapWindow.FilterCookDefault=mapWindow.FilterPanel.TypeCook:IsChecked();
	mapWindow.FilterScholarIngredientDefault=mapWindow.FilterPanel.TypeScholarIngredient:IsChecked();
	mapWindow.FilterAuctioneerDefault=mapWindow.FilterPanel.TypeAuctioneer:IsChecked();
	mapWindow.FilterBarberDefault=mapWindow.FilterPanel.TypeBarber:IsChecked();
	mapWindow.FilterBardDefault=mapWindow.FilterPanel.TypeBard:IsChecked();
	mapWindow.FilterCampSiteDefault=mapWindow.FilterPanel.TypeCampSite:IsChecked();
	mapWindow.FilterCraftSiteDefault=mapWindow.FilterPanel.TypeCraftSite:IsChecked();
	mapWindow.FilterCraftVendorDefault=mapWindow.FilterPanel.TypeCraftVendor:IsChecked();
	mapWindow.FilterFactionRepDefault=mapWindow.FilterPanel.TypeFactionRep:IsChecked();
	mapWindow.FilterItemMasterDefault=mapWindow.FilterPanel.TypeItemMaster:IsChecked();
	mapWindow.FilterMailboxDefault=mapWindow.FilterPanel.TypeMailbox:IsChecked();
	mapWindow.FilterMilestoneDefault=mapWindow.FilterPanel.TypeMilestone:IsChecked();
	mapWindow.FilterMusteringHornDefault=mapWindow.FilterPanel.TypeMusteringHorn:IsChecked();
	mapWindow.FilterReflectingPoolDefault=mapWindow.FilterPanel.TypeReflectingPool:IsChecked();
	mapWindow.FilterSettlementDefault=mapWindow.FilterPanel.TypeSettlement:IsChecked();
	mapWindow.FilterStableMasterDefault=mapWindow.FilterPanel.TypeStableMaster:IsChecked();
	mapWindow.FilterTaskboardDefault=mapWindow.FilterPanel.TypeTaskboard:IsChecked();
	mapWindow.FilterTownCrierDefault=mapWindow.FilterPanel.TypeTownCrier:IsChecked();
	mapWindow.FilterTraderDefault=mapWindow.FilterPanel.TypeTrader:IsChecked();
	mapWindow.FilterTrainerDefault=mapWindow.FilterPanel.TypeTrainer:IsChecked();
	mapWindow.FilterVaultKeeperDefault=mapWindow.FilterPanel.TypeVaultKeeper:IsChecked();
	mapWindow.FilterVendorDefault=mapWindow.FilterPanel.TypeVendor:IsChecked();
	mapWindow.FilterSkirmishCampDefault=mapWindow.FilterPanel.TypeSkirmishCamp:IsChecked();
	mapWindow.FilterOreNodeDefault=mapWindow.FilterPanel.TypeOreNode:IsChecked();
	mapWindow.FilterWoodNodeDefault=mapWindow.FilterPanel.TypeWoodNode:IsChecked();
	mapWindow.FilterScholarNodeDefault=mapWindow.FilterPanel.TypeScholarNode:IsChecked();
	mapWindow.FilterDungeonDefault=mapWindow.FilterPanel.TypeDungeon:IsChecked();
	mapWindow.FilterStairDefault=mapWindow.FilterPanel.TypeStair:IsChecked();
	mapWindow.FilterQuestDefault=mapWindow.FilterPanel.TypeQuest:IsChecked();
end

mapWindow.FilterPanel.TypeCaption=Turbine.UI.Label();
mapWindow.FilterPanel.TypeCaption:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCaption:SetPosition(5,mapWindow.FilterPanel.SetDefaultButton:GetTop()+22);
mapWindow.FilterPanel.TypeCaption:SetSize(80,18);
mapWindow.FilterPanel.TypeCaption:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeCaption:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeCaption:SetText(Resource[language][74]..":");

mapWindow.FilterPanel.TypeMain=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeMain:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMain:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeMain:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeMain:SetSize(mapWindow.FilterPanel.ScrollPanel:GetWidth()-mapWindow.FilterPanel.TypeCaption:GetWidth()-10,18);
mapWindow.FilterPanel.TypeMain:SetPosition(mapWindow.FilterPanel.TypeCaption:GetLeft()+mapWindow.FilterPanel.TypeCaption:GetWidth(),mapWindow.FilterPanel.TypeCaption:GetTop());
mapWindow.FilterPanel.TypeMain:SetText(Resource[language][106]);
mapWindow.FilterPanel.TypeMain:SetChecked(filterTypeMain);
mapWindow.FilterPanel.TypeMain.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeMainIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeMainIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMainIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[1]~=nil and iconInfo[1][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeMainIcon,iconInfo[1][6]);
end
mapWindow.FilterPanel.TypeMainIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeMainIcon:SetSize(mapWindow.FilterPanel.TypeMainIcon:GetWidth(),mapWindow.FilterPanel.TypeMainIcon:GetHeight());
mapWindow.FilterPanel.TypeMainIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeMainIcon:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft()-20,mapWindow.FilterPanel.TypeMain:GetTop());

mapWindow.FilterPanel.TypeMain:SetVisible((mapWindow.CurrentMapID==1))
mapWindow.FilterPanel.TypeMainIcon:SetVisible((mapWindow.CurrentMapID==1))

mapWindow.FilterPanel.TypeSecondary=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeSecondary:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeSecondary:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeSecondary:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeSecondary:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeSecondary:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeMain:GetTop()+20);
mapWindow.FilterPanel.TypeSecondary:SetText(Resource[language][107]);
mapWindow.FilterPanel.TypeSecondary:SetChecked(filterTypeSecondary);
mapWindow.FilterPanel.TypeSecondary.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeSecondaryIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeSecondaryIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeSecondaryIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[2]~=nil and iconInfo[2][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeSecondaryIcon,iconInfo[2][6]);
--	mapWindow.FilterPanel.TypeSecondaryIcon:SetBackground(iconInfo[2][6]);
end
mapWindow.FilterPanel.TypeSecondaryIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeSecondaryIcon:SetSize(mapWindow.FilterPanel.TypeSecondaryIcon:GetWidth(),mapWindow.FilterPanel.TypeSecondaryIcon:GetHeight());
mapWindow.FilterPanel.TypeSecondaryIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeSecondaryIcon:SetPosition(mapWindow.FilterPanel.TypeSecondary:GetLeft()-20,mapWindow.FilterPanel.TypeSecondary:GetTop());

mapWindow.FilterPanel.TypeSecondary:SetVisible((mapWindow.CurrentMapID==1))
mapWindow.FilterPanel.TypeSecondaryIcon:SetVisible((mapWindow.CurrentMapID==1))

mapWindow.FilterPanel.TypeBase=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeBase:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeBase:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeBase:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeBase:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeBase:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeSecondary:GetTop()+20);
mapWindow.FilterPanel.TypeBase:SetText(Resource[language][108]);
mapWindow.FilterPanel.TypeBase:SetChecked(filterTypeBase);
mapWindow.FilterPanel.TypeBase.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeBaseIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeBaseIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeBaseIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[3]~=nil and iconInfo[3][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeBaseIcon,iconInfo[3][6]);
end
mapWindow.FilterPanel.TypeBaseIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeBaseIcon:SetSize(mapWindow.FilterPanel.TypeBaseIcon:GetWidth(),mapWindow.FilterPanel.TypeBaseIcon:GetHeight());
mapWindow.FilterPanel.TypeBaseIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeBaseIcon:SetPosition(mapWindow.FilterPanel.TypeBase:GetLeft()-20,mapWindow.FilterPanel.TypeBase:GetTop());

mapWindow.FilterPanel.TypeBase:SetVisible((mapWindow.CurrentMapID==1))
mapWindow.FilterPanel.TypeBaseIcon:SetVisible((mapWindow.CurrentMapID==1))

mapWindow.FilterPanel.TypeOutpost=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeOutpost:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeOutpost:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeOutpost:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeOutpost:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeOutpost:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeBase:GetTop()+20);
mapWindow.FilterPanel.TypeOutpost:SetText(Resource[language][109]);
mapWindow.FilterPanel.TypeOutpost:SetChecked(filterTypeOutpost);
mapWindow.FilterPanel.TypeOutpost.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeOutpostIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeOutpostIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeOutpostIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[4]~=nil and iconInfo[4][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeOutpostIcon,iconInfo[4][6]);
end
mapWindow.FilterPanel.TypeOutpostIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeOutpostIcon:SetSize(mapWindow.FilterPanel.TypeOutpostIcon:GetWidth(),mapWindow.FilterPanel.TypeOutpostIcon:GetHeight());
mapWindow.FilterPanel.TypeOutpostIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeOutpostIcon:SetPosition(mapWindow.FilterPanel.TypeOutpost:GetLeft()-20,mapWindow.FilterPanel.TypeOutpost:GetTop());

mapWindow.FilterPanel.TypeOutpost:SetVisible((mapWindow.CurrentMapID==1))
mapWindow.FilterPanel.TypeOutpostIcon:SetVisible((mapWindow.CurrentMapID==1))

mapWindow.FilterPanel.TypeFort=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeFort:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeFort:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeFort:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeFort:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeFort:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeOutpost:GetTop()+20);
mapWindow.FilterPanel.TypeFort:SetText(Resource[language][111]);
mapWindow.FilterPanel.TypeFort:SetChecked(filterTypeFort);
mapWindow.FilterPanel.TypeFort.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeFortIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeFortIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeFortIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[6]~=nil and iconInfo[6][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeFortIcon,iconInfo[6][6]);
end
mapWindow.FilterPanel.TypeFortIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeFortIcon:SetSize(mapWindow.FilterPanel.TypeFortIcon:GetWidth(),mapWindow.FilterPanel.TypeFortIcon:GetHeight());
mapWindow.FilterPanel.TypeFortIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeFortIcon:SetPosition(mapWindow.FilterPanel.TypeFort:GetLeft()-20,mapWindow.FilterPanel.TypeFort:GetTop());

mapWindow.FilterPanel.TypeFort:SetVisible((mapWindow.CurrentMapID==1))
mapWindow.FilterPanel.TypeFortIcon:SetVisible((mapWindow.CurrentMapID==1))

mapWindow.FilterPanel.TypeMap=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeMap:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMap:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeMap:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeMap:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeMap:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeFort:GetTop()+20);
mapWindow.FilterPanel.TypeMap:SetText(Resource[language][119]);
mapWindow.FilterPanel.TypeMap:SetChecked(filterTypeMap);
mapWindow.FilterPanel.TypeMap.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeMapIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeMapIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMapIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[10]~=nil and iconInfo[10][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeMapIcon,iconInfo[10][6]);
end
mapWindow.FilterPanel.TypeMapIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeMapIcon:SetSize(mapWindow.FilterPanel.TypeMapIcon:GetWidth(),mapWindow.FilterPanel.TypeMapIcon:GetHeight());
mapWindow.FilterPanel.TypeMapIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeMapIcon:SetPosition(mapWindow.FilterPanel.TypeMap:GetLeft()-20,mapWindow.FilterPanel.TypeMap:GetTop());

mapWindow.FilterPanel.TypeMap:SetVisible((mapWindow.CurrentMapID==1))
mapWindow.FilterPanel.TypeMapIcon:SetVisible((mapWindow.CurrentMapID==1))

mapWindow.FilterPanel.TypePOI=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypePOI:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypePOI:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypePOI:SetForeColor(fontColor);
mapWindow.FilterPanel.TypePOI:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
if mapWindow.CurrentMapID==1 then
	mapWindow.FilterPanel.TypePOI:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeMap:GetTop()+20);
else
	mapWindow.FilterPanel.TypePOI:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeCaption:GetTop());
end

mapWindow.FilterPanel.TypePOI:SetText(Resource[language][110]);
mapWindow.FilterPanel.TypePOI:SetChecked(filterTypePOI);
mapWindow.FilterPanel.TypePOI.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypePOIIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypePOIIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypePOIIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[5]~=nil and iconInfo[5][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypePOIIcon,iconInfo[5][6]);
end
mapWindow.FilterPanel.TypePOIIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypePOIIcon:SetSize(mapWindow.FilterPanel.TypePOIIcon:GetWidth(),mapWindow.FilterPanel.TypePOIIcon:GetHeight());
mapWindow.FilterPanel.TypePOIIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypePOIIcon:SetPosition(mapWindow.FilterPanel.TypePOI:GetLeft()-20,mapWindow.FilterPanel.TypePOI:GetTop());

mapWindow.FilterPanel.TypeRez=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeRez:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeRez:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeRez:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeRez:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeRez:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypePOI:GetTop()+20);
mapWindow.FilterPanel.TypeRez:SetText(Resource[language][112]);
mapWindow.FilterPanel.TypeRez:SetChecked(filterTypeRez);
mapWindow.FilterPanel.TypeRez.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeRezIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeRezIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeRezIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[7]~=nil and iconInfo[7][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeRezIcon,iconInfo[7][6]);
end
mapWindow.FilterPanel.TypeRezIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeRezIcon:SetSize(mapWindow.FilterPanel.TypeRezIcon:GetWidth(),mapWindow.FilterPanel.TypeRezIcon:GetHeight());
mapWindow.FilterPanel.TypeRezIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeRezIcon:SetPosition(mapWindow.FilterPanel.TypeRez:GetLeft()-20,mapWindow.FilterPanel.TypeRez:GetTop());

mapWindow.FilterPanel.TypeNPC=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeNPC:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeNPC:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeNPC:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeNPC:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeNPC:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeRez:GetTop()+20);
mapWindow.FilterPanel.TypeNPC:SetText(Resource[language][116]);
mapWindow.FilterPanel.TypeNPC:SetChecked(filterTypeNPC);
mapWindow.FilterPanel.TypeNPC.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeNPCIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeNPCIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeNPCIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[11]~=nil and iconInfo[11][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeNPCIcon,iconInfo[11][6]);
end
mapWindow.FilterPanel.TypeNPCIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeNPCIcon:SetSize(mapWindow.FilterPanel.TypeNPCIcon:GetWidth(),mapWindow.FilterPanel.TypeNPCIcon:GetHeight());
mapWindow.FilterPanel.TypeNPCIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeNPCIcon:SetPosition(mapWindow.FilterPanel.TypeNPC:GetLeft()-20,mapWindow.FilterPanel.TypeNPC:GetTop());

mapWindow.FilterPanel.TypeOreNode=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeOreNode:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeOreNode:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeOreNode:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeOreNode:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth()/2,18);
mapWindow.FilterPanel.TypeOreNode:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeNPC:GetTop()+20);
mapWindow.FilterPanel.TypeOreNode:SetText(Resource[language][155]);
mapWindow.FilterPanel.TypeOreNode:SetChecked(filterTypeOreNode);
mapWindow.FilterPanel.TypeOreNode.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeOreNodeIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeOreNodeIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeOreNodeIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[43]~=nil and iconInfo[43][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeOreNodeIcon,iconInfo[43][6]);
end
mapWindow.FilterPanel.TypeOreNodeIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeOreNodeIcon:SetSize(mapWindow.FilterPanel.TypeOreNodeIcon:GetWidth(),mapWindow.FilterPanel.TypeOreNodeIcon:GetHeight());
mapWindow.FilterPanel.TypeOreNodeIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeOreNodeIcon:SetPosition(mapWindow.FilterPanel.TypeOreNode:GetLeft()-20,mapWindow.FilterPanel.TypeOreNode:GetTop());
	mapWindow.FilterPanel.TypeOreNodeTier=GaranStuff.MoorMap.DropDownList();
mapWindow.FilterPanel.TypeOreNodeTier:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeOreNodeTier:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth()/2,20);
mapWindow.FilterPanel.TypeOreNodeTier:SetPosition(mapWindow.FilterPanel.TypeOreNode:GetLeft()+mapWindow.FilterPanel.TypeOreNode:GetWidth(),mapWindow.FilterPanel.TypeOreNode:GetTop());
mapWindow.FilterPanel.TypeOreNodeTier:SetBorderColor(trimColor);
mapWindow.FilterPanel.TypeOreNodeTier:SetBackColor(backColor);
mapWindow.FilterPanel.TypeOreNodeTier.CurrentValue:SetBackColor(backColor);
mapWindow.FilterPanel.TypeOreNodeTier:SetTextColor(listTextColor);
mapWindow.FilterPanel.TypeOreNodeTier:SetDropRows(7);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][158],0);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 1",1);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 2",2);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 3",3);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 4",4);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 5",5);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 6",6);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 7",7);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 8",8);
mapWindow.FilterPanel.TypeOreNodeTier:AddItem(Resource[language][159].." 9",9);
mapWindow.FilterPanel.TypeOreNodeTier:SetSelectedIndex(filterOreNodeTier+1);
mapWindow.FilterPanel.TypeOreNodeTier.SelectedIndexChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.TypeWoodNode=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeWoodNode:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeWoodNode:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeWoodNode:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeWoodNode:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth()/2,18);
mapWindow.FilterPanel.TypeWoodNode:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeOreNode:GetTop()+21);
mapWindow.FilterPanel.TypeWoodNode:SetText(Resource[language][156]);
mapWindow.FilterPanel.TypeWoodNode:SetChecked(filterTypeWoodNode);
mapWindow.FilterPanel.TypeWoodNode.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeWoodNodeIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeWoodNodeIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeWoodNodeIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[44]~=nil and iconInfo[44][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeWoodNodeIcon,iconInfo[44][6]);
end
mapWindow.FilterPanel.TypeWoodNodeIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeWoodNodeIcon:SetSize(mapWindow.FilterPanel.TypeWoodNodeIcon:GetWidth(),mapWindow.FilterPanel.TypeWoodNodeIcon:GetHeight());
mapWindow.FilterPanel.TypeWoodNodeIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeWoodNodeIcon:SetPosition(mapWindow.FilterPanel.TypeWoodNode:GetLeft()-20,mapWindow.FilterPanel.TypeWoodNode:GetTop());

mapWindow.FilterPanel.TypeWoodNodeTier=GaranStuff.MoorMap.DropDownList();
mapWindow.FilterPanel.TypeWoodNodeTier:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeWoodNodeTier:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth()/2,20);
mapWindow.FilterPanel.TypeWoodNodeTier:SetPosition(mapWindow.FilterPanel.TypeWoodNode:GetLeft()+mapWindow.FilterPanel.TypeWoodNode:GetWidth(),mapWindow.FilterPanel.TypeWoodNode:GetTop());
mapWindow.FilterPanel.TypeWoodNodeTier:SetBorderColor(trimColor);
mapWindow.FilterPanel.TypeWoodNodeTier:SetBackColor(backColor);
mapWindow.FilterPanel.TypeWoodNodeTier.CurrentValue:SetBackColor(backColor);
mapWindow.FilterPanel.TypeWoodNodeTier:SetTextColor(listTextColor);
mapWindow.FilterPanel.TypeWoodNodeTier:SetDropRows(7);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][158],0);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 1",1);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 2",2);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 3",3);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 4",4);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 5",5);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 6",6);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 7",7);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 8",8);
mapWindow.FilterPanel.TypeWoodNodeTier:AddItem(Resource[language][159].." 9",9);
mapWindow.FilterPanel.TypeWoodNodeTier:SetSelectedIndex(filterWoodNodeTier+1);
mapWindow.FilterPanel.TypeWoodNodeTier.SelectedIndexChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.TypeScholarNode=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeScholarNode:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeScholarNode:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeScholarNode:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeScholarNode:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth()/2,18);
mapWindow.FilterPanel.TypeScholarNode:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeWoodNode:GetTop()+21);
mapWindow.FilterPanel.TypeScholarNode:SetText(Resource[language][157]);
mapWindow.FilterPanel.TypeScholarNode:SetChecked(filterTypeScholarNode);
mapWindow.FilterPanel.TypeScholarNode.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeScholarNodeIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeScholarNodeIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeScholarNodeIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[45]~=nil and iconInfo[45][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeScholarNodeIcon,iconInfo[45][6]);
end
mapWindow.FilterPanel.TypeScholarNodeIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeScholarNodeIcon:SetSize(mapWindow.FilterPanel.TypeScholarNodeIcon:GetWidth(),mapWindow.FilterPanel.TypeScholarNodeIcon:GetHeight());
mapWindow.FilterPanel.TypeScholarNodeIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeScholarNodeIcon:SetPosition(mapWindow.FilterPanel.TypeScholarNode:GetLeft()-20,mapWindow.FilterPanel.TypeScholarNode:GetTop());

mapWindow.FilterPanel.TypeScholarNodeTier=GaranStuff.MoorMap.DropDownList();
mapWindow.FilterPanel.TypeScholarNodeTier:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeScholarNodeTier:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth()/2,20);
mapWindow.FilterPanel.TypeScholarNodeTier:SetPosition(mapWindow.FilterPanel.TypeScholarNode:GetLeft()+mapWindow.FilterPanel.TypeScholarNode:GetWidth(),mapWindow.FilterPanel.TypeScholarNode:GetTop());
mapWindow.FilterPanel.TypeScholarNodeTier:SetBorderColor(trimColor);
mapWindow.FilterPanel.TypeScholarNodeTier:SetBackColor(backColor);
mapWindow.FilterPanel.TypeScholarNodeTier.CurrentValue:SetBackColor(backColor);
mapWindow.FilterPanel.TypeScholarNodeTier:SetTextColor(listTextColor);
mapWindow.FilterPanel.TypeScholarNodeTier:SetDropRows(7);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][158],0);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 1",1);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 2",2);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 3",3);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 4",4);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 5",5);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 6",6);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 7",7);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 8",8);
mapWindow.FilterPanel.TypeScholarNodeTier:AddItem(Resource[language][159].." 9",9);
mapWindow.FilterPanel.TypeScholarNodeTier:SetSelectedIndex(filterScholarNodeTier+1);
mapWindow.FilterPanel.TypeScholarNodeTier.SelectedIndexChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end

mapWindow.FilterPanel.TypeCook=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeCook:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCook:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeCook:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeCook:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeCook:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeScholarNode:GetTop()+21);
mapWindow.FilterPanel.TypeCook:SetText(Resource[language][162]);
mapWindow.FilterPanel.TypeCook:SetChecked(filterTypeCook);
mapWindow.FilterPanel.TypeCook.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeCookIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeCookIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCookIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[46]~=nil and iconInfo[46][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeCookIcon,iconInfo[46][6]);
end
mapWindow.FilterPanel.TypeCookIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeCookIcon:SetSize(mapWindow.FilterPanel.TypeCookIcon:GetWidth(),mapWindow.FilterPanel.TypeCookIcon:GetHeight());
mapWindow.FilterPanel.TypeCookIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeCookIcon:SetPosition(mapWindow.FilterPanel.TypeCook:GetLeft()-20,mapWindow.FilterPanel.TypeCook:GetTop());

mapWindow.FilterPanel.TypeScholarIngredient=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeScholarIngredient:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeScholarIngredient:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeScholarIngredient:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeScholarIngredient:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeScholarIngredient:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeCook:GetTop()+21);
mapWindow.FilterPanel.TypeScholarIngredient:SetText(Resource[language][182]);
mapWindow.FilterPanel.TypeScholarIngredient:SetChecked(filterTypeScholarIngredient);
mapWindow.FilterPanel.TypeScholarIngredient.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeScholarIngredientIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeScholarIngredientIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeScholarIngredientIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[48]~=nil and iconInfo[48][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeScholarIngredientIcon,iconInfo[48][6]);
end
mapWindow.FilterPanel.TypeScholarIngredientIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeScholarIngredientIcon:SetSize(mapWindow.FilterPanel.TypeScholarIngredientIcon:GetWidth(),mapWindow.FilterPanel.TypeScholarIngredientIcon:GetHeight());
mapWindow.FilterPanel.TypeScholarIngredientIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeScholarIngredientIcon:SetPosition(mapWindow.FilterPanel.TypeScholarIngredient:GetLeft()-20,mapWindow.FilterPanel.TypeScholarIngredient:GetTop());

mapWindow.FilterPanel.TypeAuctioneer=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeAuctioneer:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeAuctioneer:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeAuctioneer:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeAuctioneer:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeAuctioneer:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeScholarIngredient:GetTop()+21);
mapWindow.FilterPanel.TypeAuctioneer:SetText(Resource[language][120]);
mapWindow.FilterPanel.TypeAuctioneer:SetChecked(filterTypeAuctioneer);
mapWindow.FilterPanel.TypeAuctioneer.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeAuctioneerIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeAuctioneerIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeAuctioneerIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[14]~=nil and iconInfo[14][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeAuctioneerIcon,iconInfo[14][6]);
end
mapWindow.FilterPanel.TypeAuctioneerIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeAuctioneerIcon:SetSize(mapWindow.FilterPanel.TypeAuctioneerIcon:GetWidth(),mapWindow.FilterPanel.TypeAuctioneerIcon:GetHeight());
mapWindow.FilterPanel.TypeAuctioneerIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeAuctioneerIcon:SetPosition(mapWindow.FilterPanel.TypeAuctioneer:GetLeft()-20,mapWindow.FilterPanel.TypeAuctioneer:GetTop());

mapWindow.FilterPanel.TypeBarber=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeBarber:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeBarber:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeBarber:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeBarber:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeBarber:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeAuctioneer:GetTop()+20);
mapWindow.FilterPanel.TypeBarber:SetText(Resource[language][121]);
mapWindow.FilterPanel.TypeBarber:SetChecked(filterTypeBarber);
mapWindow.FilterPanel.TypeBarber.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeBarberIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeBarberIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeBarberIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[15]~=nil and iconInfo[15][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeBarberIcon,iconInfo[15][6]);
end
mapWindow.FilterPanel.TypeBarberIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeBarberIcon:SetSize(mapWindow.FilterPanel.TypeBarberIcon:GetWidth(),mapWindow.FilterPanel.TypeBarberIcon:GetHeight());
mapWindow.FilterPanel.TypeBarberIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeBarberIcon:SetPosition(mapWindow.FilterPanel.TypeBarber:GetLeft()-20,mapWindow.FilterPanel.TypeBarber:GetTop());

mapWindow.FilterPanel.TypeBard=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeBard:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeBard:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeBard:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeBard:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeBard:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeBarber:GetTop()+20);
mapWindow.FilterPanel.TypeBard:SetText(Resource[language][122]);
mapWindow.FilterPanel.TypeBard:SetChecked(filterTypeBard);
mapWindow.FilterPanel.TypeBard.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeBardIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeBardIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeBardIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[15]~=nil and iconInfo[16][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeBardIcon,iconInfo[16][6]);
end
mapWindow.FilterPanel.TypeBardIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeBardIcon:SetSize(mapWindow.FilterPanel.TypeBardIcon:GetWidth(),mapWindow.FilterPanel.TypeBardIcon:GetHeight());
mapWindow.FilterPanel.TypeBardIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeBardIcon:SetPosition(mapWindow.FilterPanel.TypeBard:GetLeft()-20,mapWindow.FilterPanel.TypeBard:GetTop());

mapWindow.FilterPanel.TypeCampSite=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeCampSite:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCampSite:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeCampSite:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeCampSite:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeCampSite:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeBard:GetTop()+20);
mapWindow.FilterPanel.TypeCampSite:SetText(Resource[language][123]);
mapWindow.FilterPanel.TypeCampSite:SetChecked(filterTypeCampSite);
mapWindow.FilterPanel.TypeCampSite.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeCampSiteIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeCampSiteIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCampSiteIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[17]~=nil and iconInfo[17][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeCampSiteIcon,iconInfo[17][6]);
end
mapWindow.FilterPanel.TypeCampSiteIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeCampSiteIcon:SetSize(mapWindow.FilterPanel.TypeCampSiteIcon:GetWidth(),mapWindow.FilterPanel.TypeCampSiteIcon:GetHeight());
mapWindow.FilterPanel.TypeCampSiteIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeCampSiteIcon:SetPosition(mapWindow.FilterPanel.TypeCampSite:GetLeft()-20,mapWindow.FilterPanel.TypeCampSite:GetTop());

mapWindow.FilterPanel.TypeCraftSite=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeCraftSite:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCraftSite:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeCraftSite:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeCraftSite:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeCraftSite:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeCampSite:GetTop()+20);
mapWindow.FilterPanel.TypeCraftSite:SetText(Resource[language][124]);
mapWindow.FilterPanel.TypeCraftSite:SetChecked(filterTypeCraftSite);
mapWindow.FilterPanel.TypeCraftSite.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeCraftSiteIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeCraftSiteIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCraftSiteIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[18]~=nil and iconInfo[18][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeCraftSiteIcon,iconInfo[18][6]);
end
mapWindow.FilterPanel.TypeCraftSiteIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeCraftSiteIcon:SetSize(mapWindow.FilterPanel.TypeCraftSiteIcon:GetWidth(),mapWindow.FilterPanel.TypeCraftSiteIcon:GetHeight());
mapWindow.FilterPanel.TypeCraftSiteIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeCraftSiteIcon:SetPosition(mapWindow.FilterPanel.TypeCraftSite:GetLeft()-20,mapWindow.FilterPanel.TypeCraftSite:GetTop());

mapWindow.FilterPanel.TypeCraftVendor=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeCraftVendor:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCraftVendor:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeCraftVendor:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeCraftVendor:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeCraftVendor:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeCraftSite:GetTop()+20);
mapWindow.FilterPanel.TypeCraftVendor:SetText(Resource[language][126]);
mapWindow.FilterPanel.TypeCraftVendor:SetChecked(filterTypeCraftVendor);
mapWindow.FilterPanel.TypeCraftVendor.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeCraftVendorIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeCraftVendorIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeCraftVendorIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[20]~=nil and iconInfo[20][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeCraftVendorIcon,iconInfo[20][6]);
end
mapWindow.FilterPanel.TypeCraftVendorIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeCraftVendorIcon:SetSize(mapWindow.FilterPanel.TypeCraftVendorIcon:GetWidth(),mapWindow.FilterPanel.TypeCraftVendorIcon:GetHeight());
mapWindow.FilterPanel.TypeCraftVendorIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeCraftVendorIcon:SetPosition(mapWindow.FilterPanel.TypeCraftVendor:GetLeft()-20,mapWindow.FilterPanel.TypeCraftVendor:GetTop());

mapWindow.FilterPanel.TypeDungeon=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeDungeon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeDungeon:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeDungeon:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeDungeon:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeDungeon:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeCraftVendor:GetTop()+20);
mapWindow.FilterPanel.TypeDungeon:SetText(Resource[language][183]);
mapWindow.FilterPanel.TypeDungeon:SetChecked(filterTypeDungeon);
mapWindow.FilterPanel.TypeDungeon.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeDungeonIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeDungeonIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeDungeonIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[49]~=nil and iconInfo[49][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeDungeonIcon,iconInfo[49][6]);
end
mapWindow.FilterPanel.TypeDungeonIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeDungeonIcon:SetSize(mapWindow.FilterPanel.TypeDungeonIcon:GetWidth(),mapWindow.FilterPanel.TypeDungeonIcon:GetHeight());
mapWindow.FilterPanel.TypeDungeonIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeDungeonIcon:SetPosition(mapWindow.FilterPanel.TypeDungeon:GetLeft()-20,mapWindow.FilterPanel.TypeDungeon:GetTop());

mapWindow.FilterPanel.TypeFactionRep=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeFactionRep:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeFactionRep:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeFactionRep:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeFactionRep:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeFactionRep:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeDungeon:GetTop()+20);
mapWindow.FilterPanel.TypeFactionRep:SetText(Resource[language][127]);
mapWindow.FilterPanel.TypeFactionRep:SetChecked(filterTypeFactionRep);
mapWindow.FilterPanel.TypeFactionRep.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeFactionRepIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeFactionRepIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeFactionRepIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[21]~=nil and iconInfo[21][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeFactionRepIcon,iconInfo[21][6]);
end
mapWindow.FilterPanel.TypeFactionRepIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeFactionRepIcon:SetSize(mapWindow.FilterPanel.TypeFactionRepIcon:GetWidth(),mapWindow.FilterPanel.TypeFactionRepIcon:GetHeight());
mapWindow.FilterPanel.TypeFactionRepIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeFactionRepIcon:SetPosition(mapWindow.FilterPanel.TypeFactionRep:GetLeft()-20,mapWindow.FilterPanel.TypeFactionRep:GetTop());

mapWindow.FilterPanel.TypeItemMaster=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeItemMaster:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeItemMaster:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeItemMaster:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeItemMaster:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeItemMaster:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeFactionRep:GetTop()+20);
mapWindow.FilterPanel.TypeItemMaster:SetText(Resource[language][131]);
mapWindow.FilterPanel.TypeItemMaster:SetChecked(filterTypeItemMaster);
mapWindow.FilterPanel.TypeItemMaster.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeItemMasterIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeItemMasterIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeItemMasterIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[25]~=nil and iconInfo[25][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeItemMasterIcon,iconInfo[25][6]);
end
mapWindow.FilterPanel.TypeItemMasterIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeItemMasterIcon:SetSize(mapWindow.FilterPanel.TypeItemMasterIcon:GetWidth(),mapWindow.FilterPanel.TypeItemMasterIcon:GetHeight());
mapWindow.FilterPanel.TypeItemMasterIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeItemMasterIcon:SetPosition(mapWindow.FilterPanel.TypeItemMaster:GetLeft()-20,mapWindow.FilterPanel.TypeItemMaster:GetTop());

mapWindow.FilterPanel.TypeMailbox=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeMailbox:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMailbox:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeMailbox:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeMailbox:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeMailbox:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeItemMaster:GetTop()+20);
mapWindow.FilterPanel.TypeMailbox:SetText(Resource[language][132]);
mapWindow.FilterPanel.TypeMailbox:SetChecked(filterTypeMailbox);
mapWindow.FilterPanel.TypeMailbox.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeMailboxIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeMailboxIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMailboxIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[26]~=nil and iconInfo[26][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeMailboxIcon,iconInfo[26][6]);
end
mapWindow.FilterPanel.TypeMailboxIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeMailboxIcon:SetSize(mapWindow.FilterPanel.TypeMailboxIcon:GetWidth(),mapWindow.FilterPanel.TypeMailboxIcon:GetHeight());
mapWindow.FilterPanel.TypeMailboxIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeMailboxIcon:SetPosition(mapWindow.FilterPanel.TypeMailbox:GetLeft()-20,mapWindow.FilterPanel.TypeMailbox:GetTop());

mapWindow.FilterPanel.TypeMilestone=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeMilestone:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMilestone:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeMilestone:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeMilestone:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeMilestone:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeMailbox:GetTop()+20);
mapWindow.FilterPanel.TypeMilestone:SetText(Resource[language][133]);
mapWindow.FilterPanel.TypeMilestone:SetChecked(filterTypeMilestone);
mapWindow.FilterPanel.TypeMilestone.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeMilestoneIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeMilestoneIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMilestoneIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[27]~=nil and iconInfo[27][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeMilestoneIcon,iconInfo[27][6]);
end
mapWindow.FilterPanel.TypeMilestoneIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeMilestoneIcon:SetSize(mapWindow.FilterPanel.TypeMilestoneIcon:GetWidth(),mapWindow.FilterPanel.TypeMilestoneIcon:GetHeight());
mapWindow.FilterPanel.TypeMilestoneIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeMilestoneIcon:SetPosition(mapWindow.FilterPanel.TypeMilestone:GetLeft()-20,mapWindow.FilterPanel.TypeMilestone:GetTop());
	mapWindow.FilterPanel.TypeMusteringHorn=Turbine.UI.Lotro.CheckBox();

mapWindow.FilterPanel.TypeMusteringHorn:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMusteringHorn:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeMusteringHorn:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeMusteringHorn:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeMusteringHorn:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeMilestone:GetTop()+20);
mapWindow.FilterPanel.TypeMusteringHorn:SetText(Resource[language][163]);
mapWindow.FilterPanel.TypeMusteringHorn:SetChecked(filterTypeMusteringHorn);
mapWindow.FilterPanel.TypeMusteringHorn.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeMusteringHornIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeMusteringHornIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeMusteringHornIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[47]~=nil and iconInfo[47][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeMusteringHornIcon,iconInfo[47][6]);
end
mapWindow.FilterPanel.TypeMusteringHornIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeMusteringHornIcon:SetSize(mapWindow.FilterPanel.TypeMusteringHornIcon:GetWidth(),mapWindow.FilterPanel.TypeMusteringHornIcon:GetHeight());
mapWindow.FilterPanel.TypeMusteringHornIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeMusteringHornIcon:SetPosition(mapWindow.FilterPanel.TypeMusteringHorn:GetLeft()-20,mapWindow.FilterPanel.TypeMusteringHorn:GetTop());

mapWindow.FilterPanel.TypeQuest=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeQuest:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeQuest:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeQuest:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeQuest:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeQuest:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeMusteringHorn:GetTop()+20);
mapWindow.FilterPanel.TypeQuest:SetText(Resource[language][272]);
mapWindow.FilterPanel.TypeQuest:SetChecked(filterTypeQuest);
mapWindow.FilterPanel.TypeQuest.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeQuestIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeQuestIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeQuestIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[53]~=nil and iconInfo[53][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeQuestIcon,iconInfo[53][6]);
end
mapWindow.FilterPanel.TypeQuestIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeQuestIcon:SetSize(mapWindow.FilterPanel.TypeQuestIcon:GetWidth(),mapWindow.FilterPanel.TypeQuestIcon:GetHeight());
mapWindow.FilterPanel.TypeQuestIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeQuestIcon:SetPosition(mapWindow.FilterPanel.TypeQuest:GetLeft()-20,mapWindow.FilterPanel.TypeQuest:GetTop());

mapWindow.FilterPanel.TypeReflectingPool=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeReflectingPool:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeReflectingPool:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeReflectingPool:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeReflectingPool:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeReflectingPool:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeQuest:GetTop()+20);
mapWindow.FilterPanel.TypeReflectingPool:SetText(Resource[language][138]);
mapWindow.FilterPanel.TypeReflectingPool:SetChecked(filterTypeReflectingPool);
mapWindow.FilterPanel.TypeReflectingPool.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeReflectingPoolIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeReflectingPoolIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeReflectingPoolIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[32]~=nil and iconInfo[32][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeReflectingPoolIcon,iconInfo[32][6]);
end
mapWindow.FilterPanel.TypeReflectingPoolIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeReflectingPoolIcon:SetSize(mapWindow.FilterPanel.TypeReflectingPoolIcon:GetWidth(),mapWindow.FilterPanel.TypeReflectingPoolIcon:GetHeight());
mapWindow.FilterPanel.TypeReflectingPoolIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeReflectingPoolIcon:SetPosition(mapWindow.FilterPanel.TypeReflectingPool:GetLeft()-20,mapWindow.FilterPanel.TypeReflectingPool:GetTop());

mapWindow.FilterPanel.TypeSettlement=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeSettlement:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeSettlement:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeSettlement:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeSettlement:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeSettlement:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeReflectingPool:GetTop()+20);
mapWindow.FilterPanel.TypeSettlement:SetText(Resource[language][139]);
mapWindow.FilterPanel.TypeSettlement:SetChecked(filterTypeSettlement);
mapWindow.FilterPanel.TypeSettlement.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeSettlementIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeSettlementIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeSettlementIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[33]~=nil and iconInfo[33][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeSettlementIcon,iconInfo[33][6]);
end
mapWindow.FilterPanel.TypeSettlementIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeSettlementIcon:SetSize(mapWindow.FilterPanel.TypeSettlementIcon:GetWidth(),mapWindow.FilterPanel.TypeSettlementIcon:GetHeight());
mapWindow.FilterPanel.TypeSettlementIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeSettlementIcon:SetPosition(mapWindow.FilterPanel.TypeSettlement:GetLeft()-20,mapWindow.FilterPanel.TypeSettlement:GetTop());

mapWindow.FilterPanel.TypeStableMaster=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeStableMaster:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeStableMaster:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeStableMaster:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeStableMaster:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeStableMaster:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeSettlement:GetTop()+20);
mapWindow.FilterPanel.TypeStableMaster:SetText(Resource[language][140]);
mapWindow.FilterPanel.TypeStableMaster:SetChecked(filterTypeStableMaster);
mapWindow.FilterPanel.TypeStableMaster.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeStableMasterIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeStableMasterIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeStableMasterIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[34]~=nil and iconInfo[34][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeStableMasterIcon,iconInfo[34][6]);
end
mapWindow.FilterPanel.TypeStableMasterIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeStableMasterIcon:SetSize(mapWindow.FilterPanel.TypeStableMasterIcon:GetWidth(),mapWindow.FilterPanel.TypeStableMasterIcon:GetHeight());
mapWindow.FilterPanel.TypeStableMasterIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeStableMasterIcon:SetPosition(mapWindow.FilterPanel.TypeStableMaster:GetLeft()-20,mapWindow.FilterPanel.TypeStableMaster:GetTop());

mapWindow.FilterPanel.TypeStair=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeStair:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeStair:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeStair:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeStair:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeStair:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeStableMaster:GetTop()+20);
mapWindow.FilterPanel.TypeStair:SetText(Resource[language][273]);
mapWindow.FilterPanel.TypeStair:SetChecked(filterTypeStair);
mapWindow.FilterPanel.TypeStair.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeStairIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeStairIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeStairIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[51]~=nil and iconInfo[51][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeStairIcon,iconInfo[51][6]);
end
mapWindow.FilterPanel.TypeStairIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeStairIcon:SetSize(mapWindow.FilterPanel.TypeStairIcon:GetWidth(),mapWindow.FilterPanel.TypeStairIcon:GetHeight());
mapWindow.FilterPanel.TypeStairIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeStairIcon:SetPosition(mapWindow.FilterPanel.TypeStair:GetLeft()-20,mapWindow.FilterPanel.TypeStair:GetTop());

mapWindow.FilterPanel.TypeTaskboard=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeTaskboard:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTaskboard:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeTaskboard:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeTaskboard:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeTaskboard:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeStair:GetTop()+20);
mapWindow.FilterPanel.TypeTaskboard:SetText(Resource[language][218]);
mapWindow.FilterPanel.TypeTaskboard:SetChecked(filterTypeTaskboard);
mapWindow.FilterPanel.TypeTaskboard.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeTaskboardIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeTaskboardIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTaskboardIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[50]~=nil and iconInfo[50][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeTaskboardIcon,iconInfo[50][6]);
end
mapWindow.FilterPanel.TypeTaskboardIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeTaskboardIcon:SetSize(mapWindow.FilterPanel.TypeTaskboardIcon:GetWidth(),mapWindow.FilterPanel.TypeTaskboardIcon:GetHeight());
mapWindow.FilterPanel.TypeTaskboardIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeTaskboardIcon:SetPosition(mapWindow.FilterPanel.TypeTaskboard:GetLeft()-20,mapWindow.FilterPanel.TypeTaskboard:GetTop());

mapWindow.FilterPanel.TypeTownCrier=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeTownCrier:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTownCrier:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeTownCrier:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeTownCrier:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeTownCrier:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeTaskboard:GetTop()+20);
mapWindow.FilterPanel.TypeTownCrier:SetText(Resource[language][141]);
mapWindow.FilterPanel.TypeTownCrier:SetChecked(filterTypeTownCrier);
mapWindow.FilterPanel.TypeTownCrier.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeTownCrierIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeTownCrierIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTownCrierIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[35]~=nil and iconInfo[35][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeTownCrierIcon,iconInfo[35][6]);
end
mapWindow.FilterPanel.TypeTownCrierIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeTownCrierIcon:SetSize(mapWindow.FilterPanel.TypeTownCrierIcon:GetWidth(),mapWindow.FilterPanel.TypeTownCrierIcon:GetHeight());
mapWindow.FilterPanel.TypeTownCrierIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeTownCrierIcon:SetPosition(mapWindow.FilterPanel.TypeTownCrier:GetLeft()-20,mapWindow.FilterPanel.TypeTownCrier:GetTop());

mapWindow.FilterPanel.TypeTrader=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeTrader:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTrader:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeTrader:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeTrader:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeTrader:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeTownCrier:GetTop()+20);
mapWindow.FilterPanel.TypeTrader:SetText(Resource[language][143]);
mapWindow.FilterPanel.TypeTrader:SetChecked(filterTypeTrader);
mapWindow.FilterPanel.TypeTrader.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeTraderIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeTraderIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTraderIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[37]~=nil and iconInfo[37][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeTraderIcon,iconInfo[37][6]);
end
mapWindow.FilterPanel.TypeTraderIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeTraderIcon:SetSize(mapWindow.FilterPanel.TypeTraderIcon:GetWidth(),mapWindow.FilterPanel.TypeTraderIcon:GetHeight());
mapWindow.FilterPanel.TypeTraderIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeTraderIcon:SetPosition(mapWindow.FilterPanel.TypeTrader:GetLeft()-20,mapWindow.FilterPanel.TypeTrader:GetTop());

mapWindow.FilterPanel.TypeTrainer=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeTrainer:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTrainer:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeTrainer:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeTrainer:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeTrainer:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeTrader:GetTop()+20);
mapWindow.FilterPanel.TypeTrainer:SetText(Resource[language][144]);
mapWindow.FilterPanel.TypeTrainer:SetChecked(filterTypeTrainer);
mapWindow.FilterPanel.TypeTrainer.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeTrainerIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeTrainerIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeTrainerIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[38]~=nil and iconInfo[38][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeTrainerIcon,iconInfo[38][6]);
end
mapWindow.FilterPanel.TypeTrainerIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeTrainerIcon:SetSize(mapWindow.FilterPanel.TypeTrainerIcon:GetWidth(),mapWindow.FilterPanel.TypeTrainerIcon:GetHeight());
mapWindow.FilterPanel.TypeTrainerIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeTrainerIcon:SetPosition(mapWindow.FilterPanel.TypeTrainer:GetLeft()-20,mapWindow.FilterPanel.TypeTrainer:GetTop());

mapWindow.FilterPanel.TypeVaultKeeper=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeVaultKeeper:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeVaultKeeper:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeVaultKeeper:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeVaultKeeper:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeVaultKeeper:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeTrainer:GetTop()+20);
mapWindow.FilterPanel.TypeVaultKeeper:SetText(Resource[language][145]);
mapWindow.FilterPanel.TypeVaultKeeper:SetChecked(filterTypeVaultKeeper);
mapWindow.FilterPanel.TypeVaultKeeper.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeVaultKeeperIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeVaultKeeperIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeVaultKeeperIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[39]~=nil and iconInfo[39][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeVaultKeeperIcon,iconInfo[39][6]);
end
mapWindow.FilterPanel.TypeVaultKeeperIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeVaultKeeperIcon:SetSize(mapWindow.FilterPanel.TypeVaultKeeperIcon:GetWidth(),mapWindow.FilterPanel.TypeVaultKeeperIcon:GetHeight());
mapWindow.FilterPanel.TypeVaultKeeperIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeVaultKeeperIcon:SetPosition(mapWindow.FilterPanel.TypeVaultKeeper:GetLeft()-20,mapWindow.FilterPanel.TypeVaultKeeper:GetTop());

mapWindow.FilterPanel.TypeVendor=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeVendor:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeVendor:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeVendor:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeVendor:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeVendor:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeVaultKeeper:GetTop()+20);
mapWindow.FilterPanel.TypeVendor:SetText(Resource[language][146]);
mapWindow.FilterPanel.TypeVendor:SetChecked(filterTypeVendor);
mapWindow.FilterPanel.TypeVendor.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeVendorIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeVendorIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeVendorIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[40]~=nil and iconInfo[40][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeVendorIcon,iconInfo[40][6]);
end
mapWindow.FilterPanel.TypeVendorIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeVendorIcon:SetSize(mapWindow.FilterPanel.TypeVendorIcon:GetWidth(),mapWindow.FilterPanel.TypeVendorIcon:GetHeight());
mapWindow.FilterPanel.TypeVendorIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeVendorIcon:SetPosition(mapWindow.FilterPanel.TypeVendor:GetLeft()-20,mapWindow.FilterPanel.TypeVendor:GetTop());

mapWindow.FilterPanel.TypeSkirmishCamp=Turbine.UI.Lotro.CheckBox();
mapWindow.FilterPanel.TypeSkirmishCamp:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeSkirmishCamp:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
mapWindow.FilterPanel.TypeSkirmishCamp:SetForeColor(fontColor);
mapWindow.FilterPanel.TypeSkirmishCamp:SetSize(mapWindow.FilterPanel.TypeMain:GetWidth(),18);
mapWindow.FilterPanel.TypeSkirmishCamp:SetPosition(mapWindow.FilterPanel.TypeMain:GetLeft(),mapWindow.FilterPanel.TypeVendor:GetTop()+20);
mapWindow.FilterPanel.TypeSkirmishCamp:SetText(Resource[language][154]);
mapWindow.FilterPanel.TypeSkirmishCamp:SetChecked(filterTypeSkirmishCamp);
mapWindow.FilterPanel.TypeSkirmishCamp.CheckedChanged=function()
	mapWindow.NeedsRefresh=true;
	mapWindow:SetWantsUpdates(true);
end
mapWindow.FilterPanel.TypeSkirmishCampIcon=Turbine.UI.Control();
mapWindow.FilterPanel.TypeSkirmishCampIcon:SetParent(mapWindow.FilterPanel.ScrollPanel);
mapWindow.FilterPanel.TypeSkirmishCampIcon:SetBlendMode(Turbine.UI.BlendMode.Overlay);
if iconInfo[42]~=nil and iconInfo[42][6]~=nil then
	local success,result=pcall(Turbine.UI.Control.SetBackground,mapWindow.FilterPanel.TypeSkirmishCampIcon,iconInfo[42][6]);
end
mapWindow.FilterPanel.TypeSkirmishCampIcon:SetStretchMode(2);
mapWindow.FilterPanel.TypeSkirmishCampIcon:SetSize(mapWindow.FilterPanel.TypeSkirmishCampIcon:GetWidth(),mapWindow.FilterPanel.TypeSkirmishCampIcon:GetHeight());
mapWindow.FilterPanel.TypeSkirmishCampIcon:SetStretchMode(0);
mapWindow.FilterPanel.TypeSkirmishCampIcon:SetPosition(mapWindow.FilterPanel.TypeSkirmishCamp:GetLeft()-20,mapWindow.FilterPanel.TypeSkirmishCamp:GetTop());

mapWindow.FilterPanel.TypeScholarNodeTier:SetZOrder(mapWindow.FilterPanel.TypeSkirmishCampIcon:GetZOrder()+1);
mapWindow.FilterPanel.TypeWoodNodeTier:SetZOrder(mapWindow.FilterPanel.TypeScholarNodeTier:GetZOrder()+1);
mapWindow.FilterPanel.TypeOreNodeTier:SetZOrder(mapWindow.FilterPanel.TypeWoodNodeTier:GetZOrder()+1);

mapWindow.Map.Ping=Turbine.UI.Control();
mapWindow.Map.Ping:SetParent(mapWindow.Map);
mapWindow.Map.Ping.State=0;
mapWindow.Map.Ping:SetVisible(false);
mapWindow.Map.Ping:SetSize(23,23);
mapWindow.Map.Ping:SetPosition(512,512);
mapWindow.Map.Ping:SetWantsUpdates(false);
mapWindow.Map.Ping.Counter=1;
mapWindow.Map.Ping.MaxCounter=2;
mapWindow.Map.Ping:SetBlendMode(Turbine.UI.BlendMode.Overlay)
mapWindow.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping1.tga");
mapWindow.Map.Ping.MouseClick=function(sender,args)
	mapWindow.Map.Ping.State=0; -- it will auto hide itmapWindow on next tick
end
mapWindow.Map.Ping.Update=function(sender)
	if mapWindow.Map.Ping.State==0 then
		mapWindow.Map.Ping:SetWantsUpdates(false);
		mapWindow.Map.Ping:SetVisible(false);
		mapWindow.Map.Ping.Counter=0;
		mapWindow.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping1.tga");
	elseif mapWindow.Map.Ping.State==7 then
		mapWindow.Map.Ping.Counter=mapWindow.Map.Ping.Counter+1;
		if mapWindow.Map.Ping.Counter>mapWindow.Map.Ping.MaxCounter then
			mapWindow.Map.Ping.Counter=0;
			mapWindow.Map.Ping.State=3;
			mapWindow.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping3.tga");
		end

	else
		mapWindow.Map.Ping.Counter=mapWindow.Map.Ping.Counter+1;
		if mapWindow.Map.Ping.Counter>mapWindow.Map.Ping.MaxCounter then
			mapWindow.Map.Ping.Counter=0;
			mapWindow.Map.Ping.State=mapWindow.Map.Ping.State+1;
			mapWindow.Map.Ping:SetBackground("GaranStuff/MoorMap/Resources/Ping"..tostring(mapWindow.Map.Ping.State)..".tga");
		end
	end
end

mapWindow.FontMetric=FontMetric();
mapWindow.FontMetric.SetFont(Turbine.UI.Lotro.Font.Verdana14);

mapWindow.Map.HoverWindow=Turbine.UI.Window();
mapWindow.Map.HoverWindow:SetZOrder(2);
mapWindow.Map.HoverWindow:SetVisible(false);
mapWindow.Map.HoverWindow:SetPosition(0,0);
mapWindow.Map.HoverWindow:SetBackColor(Turbine.UI.Color(.7,.05,.05,.05));
mapWindow.Map.HoverWindow.Name=Turbine.UI.Label();
mapWindow.Map.HoverWindow.Name:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Name:SetSize(100,16);
mapWindow.Map.HoverWindow.Name:SetPosition(0,0);
mapWindow.Map.HoverWindow.Name:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.HoverWindow.Name:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.HoverWindow.Name:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.HoverWindow.Name:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.Map.HoverWindow.Name:SetText("");
mapWindow.Map.HoverWindow.Waypoint=Turbine.UI.Lotro.Quickslot();
mapWindow.Map.HoverWindow.Waypoint:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Waypoint:SetSize(100,16);
mapWindow.Map.HoverWindow.Waypoint:SetPosition(5,18);
mapWindow.Map.HoverWindow.Waypoint:SetAllowDrop(false);
mapWindow.Map.HoverWindow.Waypoint.DragDrop=function()
	if mapWindow.Map.HoverWindow.Waypoint.Alias~=nil and mapWindow.Map.HoverWindow.Waypoint.Alias~="" then
		local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
		sc:SetData(mapWindow.Map.HoverWindow.Waypoint.Alias);
		mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
	end
end
mapWindow.Map.HoverWindow.Coord=Turbine.UI.Label();
mapWindow.Map.HoverWindow.Coord:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Coord:SetSize(100,16);
mapWindow.Map.HoverWindow.Coord:SetPosition(5,18);
mapWindow.Map.HoverWindow.Coord:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.HoverWindow.Coord:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.HoverWindow.Coord:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.HoverWindow.Coord:SetForeColor(Turbine.UI.Color(.8,.8,.9));
mapWindow.Map.HoverWindow.Coord:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.Map.HoverWindow.Coord:SetText("");
mapWindow.Map.HoverWindow.Coord:SetMouseVisible(false);
mapWindow.Map.HoverWindow.Edit=Turbine.UI.Label();
mapWindow.Map.HoverWindow.Edit:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.Edit:SetSize(100,16);
mapWindow.Map.HoverWindow.Edit:SetPosition(5,36);
mapWindow.Map.HoverWindow.Edit:SetOutlineColor(Turbine.UI.Color(0,0,0));
mapWindow.Map.HoverWindow.Edit:SetFontStyle(Turbine.UI.FontStyle.Outline);
mapWindow.Map.HoverWindow.Edit:SetFont(Turbine.UI.Lotro.Font.Verdana14);
mapWindow.Map.HoverWindow.Edit:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
mapWindow.Map.HoverWindow.Edit:SetText("Edit");
mapWindow.Map.HoverWindow.Edit.MouseClick=function()
	annotWindow:SetVisible(true);
	mapWindow.Map.HoverWindow:SetVisible(false);
end
mapWindow.Map.HoverWindow.XY=Turbine.UI.Label();
mapWindow.Map.HoverWindow.XY:SetParent(mapWindow.Map.HoverWindow);
mapWindow.Map.HoverWindow.XY:SetMouseVisible(false);
mapWindow.Map.HoverWindow.HideCount=0;
if debug then
	mapWindow.Map.HoverWindow.XY=Turbine.UI.Label();
	mapWindow.Map.HoverWindow.XY:SetParent(mapWindow.Map.HoverWindow);
	mapWindow.Map.HoverWindow.XY:SetSize(100,16);
	mapWindow.Map.HoverWindow.XY:SetPosition(5,54);
	mapWindow.Map.HoverWindow.XY:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	mapWindow.Map.HoverWindow.XY:SetText("X:Y");
	mapWindow.Map.HoverWindow.XY:SetVisible(true);
	mapWindow.Map.HoverWindow:SetSize(100,72);
else
	mapWindow.Map.HoverWindow.XY:SetVisible(false);
	mapWindow.Map.HoverWindow:SetSize(100,56);
end
mapWindow.Map.HoverWindow.SizeChanged=function(sender,args)
	local newWidth=mapWindow.Map.HoverWindow:GetWidth();
	mapWindow.Map.HoverWindow.Name:SetWidth(newWidth);
	mapWindow.Map.HoverWindow.Waypoint:SetWidth(newWidth-10);
	mapWindow.Map.HoverWindow.Coord:SetWidth(newWidth-10);
	mapWindow.Map.HoverWindow.Edit:SetWidth(newWidth-10);
	mapWindow.Map.HoverWindow.XY:SetWidth(newWidth-10);
end
mapWindow.Map.HoverWindow.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Name.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.Name.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Edit.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.Edit.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Waypoint.MouseLeave=function()
	mapWindow.Map.HoverWindow.Hide=true;
end
mapWindow.Map.HoverWindow.Waypoint.MouseEnter=function()
	mapWindow.Map.HoverWindow.Hide=false;
	mapWindow.Map.HoverWindow.HideCount=0;
end
mapWindow.Map.HoverWindow.Update=function()
	if mapWindow.Map.HoverWindow.Hide then
		mapWindow.Map.HoverWindow.HideCount=mapWindow.Map.HoverWindow.HideCount+1;
	end
	if mapWindow.Map.HoverWindow.HideCount>5 then
		mapWindow.Map.HoverWindow:SetWantsUpdates(false);
		mapWindow.Map.HoverWindow:SetVisible(false);
	end
end

mapWindow:SetText(Resource[language][2]);

mapWindow.SetPluginUnloading = function(value)
	mapWindow.PluginUnloading=value;
end
mapWindow.VisibleChanged=function()
	if quickWindow:GetTop()+32>Turbine.UI.Display:GetHeight() then quickWindow:SetTop(Turbine.UI.Display:GetHeight()-32) end
	if quickWindow:GetLeft()+32>Turbine.UI.Display:GetWidth() then quickWindow:SetLeft(Turbine.UI.Display:GetWidth()-32) end
	if minWindow:GetTop()+32>Turbine.UI.Display:GetHeight() then minWindow:SetTop(Turbine.UI.Display:GetHeight()-32) end
	if minWindow:GetLeft()+32>Turbine.UI.Display:GetWidth() then minWindow:SetLeft(Turbine.UI.Display:GetWidth()-32) end
	if mapWindow:GetHeight()>Turbine.UI.Display:GetHeight() then mapWindow:SetHeight(Turbine.UI.Display:GetHeight()) end
	if mapWindow:GetWidth()>Turbine.UI.Display:GetWidth() then mapWindow:SetWidth(Turbine.UI.Display:GetWidth()) end
	if mapWindow:GetTop()+mapWindow:GetHeight()>Turbine.UI.Display:GetHeight() then mapWindow:SetTop(Turbine.UI.Display:GetHeight()-mapWindow:GetHeight()) end
	if mapWindow:GetLeft()+mapWindow:GetWidth()>Turbine.UI.Display:GetWidth() then mapWindow:SetLeft(Turbine.UI.Display:GetWidth()-mapWindow:GetWidth()) end

	if (not mapWindow.PluginUnloading) then
		if not mapWindow:IsVisible() then
			minWindow:SetVisible(true);
			quickWindow:SetVisible(quickWindow.Displayed);
			if optWindow~=nil then optWindow:SetVisible(false) end;
			if annotWindow~=nil then annotWindow:SetVisible(false) end;
		else
			-- refresh anything that needs refreshing when map is visible
			RefreshMap();
			if mapWindow.LocationIcon~=nil then
				if mapWindow.PlayerIconVisible==true then
					mapWindow.LocationIcon:SetVisible(true);
					mapWindow.LocationIcon:SetRotation({x=0,y=0,z=0-(mapWindow.Heading-90)});
				end
			end
		end
	end
end

mapWindow.AddAnnotationMenu=Turbine.UI.ContextMenu();
if mapWindow.CurrentMapID~=2 then
	mapWindow.AddAnnotationMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][82]));
	mapWindow.AddAnnotationMenu:GetItems():Get(1).Click=function()
		annotWindow.AnnotationList:SetSelectedIndex(1);
		annotWindow:EditAnnotation(0);
		annotWindow.TypeList:SetSelectedIndex(1);
		annotWindow.NameText:SetText("");
		annotWindow.DescriptionText:SetText("");
		annotWindow:SetVisible(true);
	end
	mapWindow.AddAnnotationMenu:GetItems():Add(Turbine.UI.MenuItem(Resource[language][148]));
	mapWindow.AddAnnotationMenu:GetItems():Get(2).Click=function()
		RefreshMap(mapInfo[mapWindow.CurrentMapID][10]);
	end
end

mapWindow.MovingIcon=Turbine.UI.Control();
mapWindow.MovingIcon:SetParent(mapWindow);
mapWindow.MovingIcon:SetSize(32,32);
mapWindow.MovingIcon:SetStretchMode(1); -- allows it to display past the parent's bounds
mapWindow.MovingIcon:SetBackground(0x410081c0)
-- for some reason, when StretchMode=1, setting the control's position or size AFTER loading the resource background makes it appear... WEIRD
mapWindow.MovingIcon:SetPosition(mapWindow:GetWidth()/2-15,mapWindow:GetHeight()-21);
mapWindow.MovingIcon:SetVisible(false);

mapWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		mapWindow:SetVisible(false);
		minWindow:SetVisible(true);
		quickWindow:SetVisible(quickWindow.Displayed);
		if defAnnWindow~=nil then
			defAnnWindow:SetVisible(false);
		end
		mapWindow.Map.HoverWindow:SetVisible(false);
		overlayWindow:SetVisible(false);
		optionsWindow:SetVisible(false);
		breadcrumbWindow:SetVisible(false);
		searchWindow:SetVisible(false);
		if BDDLegend~=nil then
			BDDLegend:SetVisible(false);
		end
		if mapWindow.PopUp~=nil and not mapWindow.PopUp:IsPinned() then
			mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
			mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
			mapWindow.PopUp:SetVisible(false);
			mapWindow.PopUp=nil; -- dismiss the dialog
		end
	end
	if ( args.Action == 268435635 ) then -- toggle HUD
		HUDVisible=not HUDVisible;
		if HUDVisible then
			mapWindow:SetVisible(MapVis);
			minWindow:SetVisible(MinVis);
			quickWindow:SetVisible(QuickVis);
			overlayWindow:SetVisible(OverlayVis);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(BDDVis);
			end
			breadcrumbWindow:SetVisible(BreadcrumbVis);
			searchWindow:SetVisible(SearchVis);
			if mapWindow.PopUp~=nil then
				mapWindow.PopUp:SetVisible(PopUpVis)
			end
		else
			MapVis=mapWindow:IsVisible();
			MinVis=minWindow:IsVisible();
			QuickVis=quickWindow:IsVisible();
			OverlayVis=overlayWindow:IsVisible();
			BreadcrumbVis=breadcrumbWindow:IsVisible();
			SearchVis=searchWindow:IsVisible();
			if BDDLegend~=nil then
				BDDVis=BDDLegend:IsVisible();
				BDDLegend:SetVisible(false);
			end
			if mapWindow.PopUp~=nil then
				PopUpVis=mapWindow.PopUp:IsVisible()
				mapWindow.PopUp:SetVisible(false)
			else
				PopUpVis=false
			end
			mapWindow:SetVisible( false );
			minWindow:SetVisible( false ); -- this is harmless if the "ShowIconWhenMinimized" option is turned off
			quickWindow:SetVisible(false);
			-- if turbine ever exposes the UI state, we can force the minimized icon not to display when the HUD is off
			if defAnnWindow~=nil then
				defAnnWindow:SetVisible(false);
			end
			mapWindow.Map.HoverWindow:SetVisible(false);
			overlayWindow:SetVisible(false);
			optionsWindow:SetVisible(false);
			breadcrumbWindow:SetVisible(false);
			searchWindow:SetVisible(false)
		end
	end
end

mapWindow.GetMinimumWidth=function()
	return mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth()+24;
end
mapWindow.GetMinimumHeight=function()
	return 297;
end
if mapWindow:GetHeight()<mapWindow:GetMinimumHeight() then mapWindow:SetHeight(mapWindow:GetMinimumHeight()) end
if mapWindow:GetWidth()<mapWindow:GetMinimumWidth() then mapWindow:SetWidth(mapWindow:GetMinimumWidth()) end

mapWindow.SizeChanged=function(sender)
	height=mapWindow:GetHeight()
	width=mapWindow:GetWidth()

	if debug then
		Turbine.Shell.WriteLine("setting size ("..tostring(width)..","..tostring(height)..")");
	end
--	if width<mapWindow.GetMinimumWidth() then width=mapWindow.GetMinimumWidth() end;
--	if height<mapWindow.GetMinimumHeight() then height=mapWindow.GetMinimumHeight() end;
	if width<mapWindow:GetMinimumWidth() then width=mapWindow:GetMinimumWidth() end;
	if height<mapWindow:GetMinimumHeight() then height=mapWindow:GetMinimumHeight() end;

	Turbine.UI.Window.SetSize(mapWindow,width,height);

	mapWindow.MovingIcon:SetPosition(width-21,height-21);
	mapWindow.SearchPanel:SetLeft(width-400);
	mapWindow.SearchPanel:SetHeight(height-50)
	mapWindow.FilterPanel:SetHeight(height-50);
	mapWindow.FilterPanel.ViewPane:SetHeight(mapWindow.FilterPanel:GetHeight()-mapWindow.FilterPanel.Separator1:GetTop()-3);
	mapWindow.FilterPanel.VScroll:SetMaximum(mapWindow.FilterPanel.ScrollPanel:GetHeight()-mapWindow.FilterPanel.ViewPane:GetHeight());
	mapWindow.FilterPanel.VScroll:SetHeight(mapWindow.FilterPanel.ViewPane:GetHeight());
	mapWindow.FilterPanel.VScroll:SetVisible(mapWindow.FilterPanel.ViewPane:GetHeight()<mapWindow.FilterPanel.ScrollPanel:GetHeight());
	mapWindow.ControlPanel:SetWidth(width);
	mapWindow.Map.IconList:SetHeight(mapWindow.SearchPanel:GetHeight()-46);
	mapWindow.Map.IconList.VScroll:SetHeight(mapWindow.Map.IconList:GetHeight());

	mapWindow.CloseButton:SetLeft(width-20);
	if mapWindow.Map ~=nil then
		mapWindow.Map:SetSize(width,height);
	end
	if mapWindow.LocationIcon~=nil then
		mapWindow.LocationIcon:SetPosition(mapWindow.LocationIcon.X*width/mapInfo[mapWindow.CurrentMapID][4]-14,mapWindow.LocationIcon.Y*height/mapInfo[mapWindow.CurrentMapID][5]-14)
	end

	if width<mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth()+mapWindow.OverlaySelect:GetWidth() then
		mapWindow.OverlaySelect:SetPosition(mapWindow.ControlPanel:GetLeft(),mapWindow.ControlPanel:GetTop()+mapWindow.ControlPanel:GetHeight()+2)
	else
		mapWindow.OverlaySelect:SetPosition(mapWindow.MapSelect:GetLeft()+mapWindow.MapSelect:GetWidth(),mapWindow.MapSelect:GetTop())
	end
	-- need to resize overlays to map ACTUAL size, the client will then scale it to fit it's parent
	for k,v in ipairs(mapWindow.Map.Overlays) do
		v:SetSize(mapInfo[mapWindow.CurrentMapID][4],mapInfo[mapWindow.CurrentMapID][5]);
	end
end

mapWindow.MouseDown=function(sender,args)
	if (args.Y>mapWindow:GetHeight()-15) and (args.X>mapWindow:GetWidth()-15) then
		mapWindow.MoveX=args.X;
		mapWindow.MoveY=args.Y;
		mapWindow.MovingIcon:SetLeft(args.X-12);
		mapWindow.MovingIcon:SetTop(args.Y-12);
		mapWindow.MovingIcon:SetBackground(0x41007e20)
		mapWindow.MovingIcon:SetVisible(true);
	elseif (args.Y>mapWindow:GetHeight()-12) then
		mapWindow.MoveY=args.Y;
		mapWindow.MovingIcon:SetLeft(args.X-22);
		mapWindow.MovingIcon:SetTop(args.Y-12);
		mapWindow.MovingIcon:SetBackground(0x410081c0)
		mapWindow.MovingIcon:SetVisible(true);
	elseif (args.X>mapWindow:GetWidth()-12) then
		mapWindow.MoveX=args.X;
		mapWindow.MovingIcon:SetLeft(args.X-12);
		mapWindow.MovingIcon:SetTop(args.Y-22);
		mapWindow.MovingIcon:SetBackground(0x410081bf)
		mapWindow.MovingIcon:SetVisible(true);
	elseif (args.Y<15) then
		mapWindow.MoveX=args.X;
		mapWindow.MoveY=args.Y;
		mapWindow.MovingIcon:SetLeft(args.X-12);
		mapWindow.MovingIcon:SetTop(args.Y-12);
		mapWindow.MovingIcon:SetSize(32,32);
		mapWindow.MovingIcon:SetBackground(0x410000dd)
		mapWindow.MovingIcon:SetVisible(true);
	else
		mapWindow.MoveX=-1;
		mapWindow.MoveY=-1;
	end
	if mapWindow.PopUp~=nil then
		mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
		mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
		mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
		mapWindow.PopUp:SetVisible(false);
		mapWindow.PopUp=nil; -- dismiss the dialog
	end
end
mapWindow.MouseEnter=function()
	mapWindow.OverlaySelect:SetHeight(20);
	mapWindow.OverlaySelect:SetVerticalScrollBar(nil);
	mapWindow.OverlayVScroll:SetParent(nil);
	mapWindow.OverlayVScroll:SetVisible(false);
	mapWindow.OverlaySelect:SetSelectedIndex(1);
	mapWindow.OverlaySelect:SetBackColor(nil);
end

mapWindow.MouseMove=function(sender,args)
	if (mapWindow.MoveY>-1 and mapWindow.MoveY<15) then
		if (args.X~=mapWindow.MoveX or args.Y~= mapWindow.MoveY) then
			mapWindow.Moving=true;
			local newLeft=mapWindow:GetLeft()-(mapWindow.MoveX-args.X)
			local newTop=mapWindow:GetTop()-(mapWindow.MoveY-args.Y)
			if newLeft<0 then newLeft=0 end;
--			if newLeft>(displayWidth-mapWindow:GetWidth()) then newLeft=displayWidth-mapWindow:GetWidth() end;
			if newLeft>(displayWidth-10) then newLeft=displayWidth-10 end;
			if newTop<0 then newTop=0 end;
--			if newTop>(displayHeight-mapWindow:GetHeight()) then newTop=displayHeight-mapWindow:GetHeight() end;
			if newTop>(displayHeight-10) then newTop=displayHeight-10 end;
			mapWindow:SetPosition(newLeft,newTop);
			optionsCanvas.MapLeftValue:SetText(tostring(mapWindow:GetLeft()))
			optionsCanvas.MapTopValue:SetText(tostring(mapWindow:GetTop()))
		end
	else		
		if (mapWindow.MoveY>-1) then
			if args.Y~= mapWindow.MoveY then
				mapWindow.Resizing=true;
				local newHeight=mapWindow:GetHeight()-(mapWindow.MoveY-args.Y);
--				if newHeight<215 then newHeight=215 end;
				if newHeight<mapWindow.GetMinimumHeight() then newHeight=mapWindow.GetMinimumHeight() end;
				if newHeight>(displayHeight-mapWindow:GetTop()) then newHeight=displayHeight-mapWindow:GetTop() end;
				local newX=args.X-22;
				if newX<-13 then newX=-13 end
				if newX>(mapWindow:GetWidth()-18) then newX=mapWindow:GetWidth()-18 end
				mapWindow.MovingIcon:SetLeft(newX);
				mapWindow:SetHeight(newHeight);
				mapWindow.MoveY=args.Y;
				optionsCanvas.MapHeightValue:SetText(tostring(mapWindow:GetHeight()))
			end
		end
		if (mapWindow.MoveX>-1) then
			if args.X~= mapWindow.MoveX then
				mapWindow.Resizing=true;
				local newWidth=mapWindow:GetWidth()-(mapWindow.MoveX-args.X);
--				if newWidth<414 then newWidth=414 end;
				if newWidth<mapWindow.GetMinimumWidth() then newWidth=mapWindow.GetMinimumWidth() end;
				if newWidth>(displayWidth-mapWindow:GetLeft()) then newWidth=displayWidth-mapWindow:GetLeft() end;
				local newY=args.Y-22;
				if newY<-13 then newY=-13 end
				if newY>(mapWindow:GetHeight()-18) then newY=mapWindow:GetHeight()-18 end
				mapWindow.MovingIcon:SetTop(newY);
				mapWindow:SetWidth(newWidth);
				mapWindow.MoveX=args.X;
				optionsCanvas.MapWidthValue:SetText(tostring(mapWindow:GetWidth()))
			end
		end
	end
	if not mapWindow.Moving and not mapWindow.Resizing then
		-- update location display
		if mapWindow.CurrentMapID==nil then
			if debug then
				Turbine.Shell.WriteLine("CurrentMapID is NULL in mapWindow.MouseMove()!");
			end
		else
			if mapInfo[mapWindow.CurrentMapID]==nil then
				if debug then
					Turbine.Shell.WriteLine("CurrentMapID="..tostring(mapWindow.CurrentMapID).." but mapInfo[mapWindow.CurrentMapID] is NULL in .MouseMove()!");
				end
			else
				if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
					--looks like we need to scale here
					local XScale=mapInfo[mapWindow.CurrentMapID][4]/mapWindow:GetWidth();
					local YScale=mapInfo[mapWindow.CurrentMapID][5]/mapWindow:GetHeight();
					local EW;
					local NS;
						if debug then
						EW=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*100)/100;
						NS=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*100)/100;
					else
						EW=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*10)/10;
						NS=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*10)/10;
					end
					if EW<0 then
						mapWindow.EWCoord:SetText(tostring(0-EW)..Resource[language][153]);
					else
						mapWindow.EWCoord:SetText(tostring(EW)..Resource[language][152]);
					end
					if NS<0 then
						mapWindow.NSCoord:SetText(tostring(0-NS)..Resource[language][151]);
					else
						mapWindow.NSCoord:SetText(tostring(NS)..Resource[language][150]);
					end
					mapWindow.XCoord:SetText(tostring(args.X))
					mapWindow.YCoord:SetText(tostring(args.Y))
				end
			end
		end
	end
end

mapWindow.MouseUp=function(sender,args)
	mapWindow.MovingIcon:SetVisible(false);
	mapWindow.MoveX=-1;
	mapWindow.MoveY=-1;
	mapWindow.Moving=false;
	mapWindow.Resizing=false;
end

mapWindow.MouseClick=function(sender,args)
	mapWindow.SearchPanel:SetVisible(false);
	mapWindow.FilterPanel:SetVisible(false);
	mapWindow.Map.IconSearch:SetWantsUpdates(false);
	if not mapWindow.Moving and not mapWindow.Resizing and args.Button==2 then
		-- user right clicked on map, popup the "Add Annotation" option
		local XScale=mapInfo[mapWindow.CurrentMapID][4]/mapWindow:GetWidth();
		local YScale=mapInfo[mapWindow.CurrentMapID][5]/mapWindow:GetHeight();
		local NSCoord=math.floor((args.Y*YScale-mapInfo[mapWindow.CurrentMapID][9])/mapInfo[mapWindow.CurrentMapID][8]*10)/10;
		local EWCoord=math.floor((args.X*XScale-mapInfo[mapWindow.CurrentMapID][7])/mapInfo[mapWindow.CurrentMapID][6]*10)/10;
		if EWCoord<0 then
			annotWindow.EWCoordText:SetText(tostring(0-EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(2)
		else
			annotWindow.EWCoordText:SetText(tostring(EWCoord));
			annotWindow.EWButtons:SetSelectedChoice(1)
		end
		if NSCoord<0 then
			annotWindow.NSCoordText:SetText(tostring(0-NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(2)
		else
			annotWindow.NSCoordText:SetText(tostring(NSCoord));
			annotWindow.NSButtons:SetSelectedChoice(1)
		end
		mapWindow.AddAnnotationMenu:ShowMenu();
	end
end
mapWindow.flashIndex=1;
mapWindow.flashTime=Turbine.Engine:GetGameTime()+.2;
-- set ZOrder so that the drop downs can cover other items, etc
mapWindow.Map:SetZOrder(1);
mapWindow.ControlPanel:SetZOrder(2);
if mapWindow.ControlPanel.OptionsButton~=nil then
	mapWindow.ControlPanel.OptionsButton:SetZOrder(5);
end
mapWindow.ControlPanel.AnnotationsButton:SetZOrder(7);
mapWindow.SearchButton:SetZOrder(8);
mapWindow.SearchButton2:SetZOrder(8);
if mapWindow.LocationButton ~=nil then
	mapWindow.LocationContainer:SetZOrder(9);
	mapWindow.LocationButton:SetZOrder(10);
end
mapWindow.FilterButton:SetZOrder(12);
mapWindow.MovingIcon:SetZOrder(15);
mapWindow.NSCoord:SetZOrder(17);
mapWindow.EWCoord:SetZOrder(20);
mapWindow.MapSelect:SetZOrder(23);
mapWindow.OverlaySelect:SetZOrder(23);
mapWindow.OverlayVScroll:SetZOrder(23);
mapWindow.CloseButton:SetZOrder(23);
mapWindow.SearchPanel:SetZOrder(mapWindow.Map:GetZOrder()+1);
mapWindow.FilterPanel:SetZOrder(mapWindow.Map:GetZOrder()+1);
mapWindow.FilterPanel.VScroll:SetZOrder(mapWindow.Map:GetZOrder()+1);

mapWindow:SetWantsKeyEvents(true);
mapWindow:SetWantsUpdates(true)

mapWindow.RemoveShellCommands=function(sender,args)
	Turbine.Shell.RemoveCommand(mapWindow.shellCmd)
end

mapWindow.shellCmd=Turbine.ShellCommand();
local numberOfCommandsRegistered = Turbine.Shell.AddCommand("MoorMap",mapWindow.shellCmd);

mapWindow.shellCmd.Execute = function(sender, cmd, args)
	if debug then
		Turbine.Shell.WriteLine("cmd:"..tostring(cmd).." args:"..tostring(args))
	end
	if (string.lower(cmd) == "moormap") then
		local pos1=string.find(args," ",0,true);
		local command;
		if pos1~=nil and pos1>0 then
			command=string.lower(string.sub(args,1,pos1-1));
		else
			command=string.lower(args);
		end
		if (command=="show") then
			minWindow:SetVisible(false);
			quickWindow:SetVisible(quickWindow.Displayed);
			mapWindow:SetVisible(true);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(BDDVis)
			end
		elseif (command=="hide") then
			mapWindow:SetVisible(false);
			minWindow:SetVisible(true);
			quickWindow:SetVisible(quickWindow.Displayed);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(false)
			end
		elseif (command=="toggle") then
			mapWindow:SetVisible(not mapWindow:IsVisible());
			minWindow:SetVisible(not mapWindow:IsVisible());
			quickWindow:SetVisible(quickWindow.Displayed);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(BDDVis and mapWindow:IsVisible())
			end

		elseif (command=="debug") then
			if string.lower(args)=="debug on" then
				debug=true;
				debugWindow:SetVisible(true);
			elseif string.lower(args)=="debug off" then
				debug=false;
				debugWindow:SetVisible(false);
			elseif string.lower(args)=="debug toggle" then
				debug=not debug;
				debugWindow:SetVisible(debug);
			else
				Turbine.Shell.WriteLine("debug is currently "..tostring(debug));
			end
		elseif (command=="adm") then
			if defAnnWindow==nil then
				import "GaranStuff.MoorMap.DefaultAnnotationMaker";
				defAnnWindow=DefaultAnnotationsMaker();
			end
			defAnnWindow:SetVisible(true);
		elseif pos1~=nil and pos1>0 and command=="target" and defAnnWindow~=nil then
			-- args are"region: area: NSCoord, EWCoord:Target"
			-- where "region: area: NSCoord, EWCoord" is generated by ;loc
			-- -- region Eregion=region1, Rhovanion=region2
			-- "Target" any non blank value other than ";target" is valid
			-- split up the args following "target"
			local argArray=string.split(string.sub(args,pos1+1),":");
			local region;
			local NSCoord;
			local EWCoord;
			local iconType=5;
			local target=";target";
			local tier=0;
			if argArray[1]~=nil then
				if string.lower(argArray[1])=="eriador" then
					region=1;
				elseif string.lower(argArray[1])=="rhovanion" then
					region=2;
				elseif string.lower(argArray[1])=="gondor" then
					region=3;
				end
			end
			if region==nil then
				Turbine.Shell.WriteLine(Resource[1][165].." \""..argArray[1].."\". "..Resource[1][164]);
			else
				if argArray[3]~=nil then
					NSCoord=string.lower(string.trim(string.gsub(argArray[3], "^(.-),(.*)","%1")));
					EWCoord=string.lower(string.trim(string.gsub(argArray[3], "(.*),(.-)$", "%2")));
					if argArray[4]~=nil then
						target=string.trim(argArray[4]);
					end
					-- if target~=nil, look it up in nodeTier[#nodeTier+1] to see if we get a match on a crafting node
					if target~=nil then
						local tmpIndex;
						for tmpIndex=1,#nodeTier do
							if nodeTier[tmpIndex][1]==target then
								iconType=nodeTier[tmpIndex][2];
								tier=nodeTier[tmpIndex][3];
								break;
							end
						end
					end

					if string.sub(NSCoord,-1)=="n" then
						NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
					elseif string.sub(NSCoord,-1)=="s" then
						NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
					else
						NSCoord=nil;
					end
					if locale == "en" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					elseif locale == "fr" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="o" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					else
						if string.sub(EWCoord,-1)=="o" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					end

					if NSCoord~=nil and EWCoord~=nil then
						NSCoord=euroNormalize(NSCoord)
						EWCoord=euroNormalize(EWCoord)
					end
				end

				if NSCoord==nil or EWCoord==nil then
					Turbine.Shell.WriteLine(Resource[1][167].." \""..argArray[3].."\". "..Resource[1][164]);
				else
					if iconType==nil then
						Turbine.Shell.WriteLine(Resource[1][168].." \""..argArray[4].."\". "..Resource[1][164]);
					else
						if target==";target" then
							Turbine.Shell.WriteLine(Resource[1][169]..Resource[1][164]);
						else
							-- now send all of the data to the DefaultAnnotationMaker dialog
							defAnnWindow:SetTargetInfo(NSCoord,EWCoord,iconType,tier,target);
						end
					end
				end
			end

		elseif pos1~=nil and pos1>0 and command=="add" then
			-- args are"region: area: NSCoord, EWCoord:IconType:Language:Target"
			-- where "region: area: NSCoord, EWCoord" is generated by ;loc
			-- -- region Eregion=region1, Rhovanion=region2
			-- "IconType" is one of the predefined icon values, 5=POI, 11=NPC, 43=Ore Node, 44=Wood Node, 45=Scholar Node : null default=5
			-- "Language" is no longer used and can be null
			-- "Target" any non blank value other than ";target" is valid
			-- split up the args following "add"
			local argArray=string.split(string.sub(args,pos1+1),":");
			local region;
			local NSCoord;
			local EWCoord;
			local iconType=5;
			local lang="EN";
			local target=";target";
			local tier=0;
			if argArray[1]~=nil then
				if string.lower(argArray[1])=="eriador" then
					region=1;
				elseif string.lower(argArray[1])=="rhovanion" then
					region=2;
				elseif string.lower(argArray[1])=="gondor" then
					region=3;
				end
			end
			if region==nil then
				Turbine.Shell.WriteLine(Resource[language][165].." \""..argArray[1].."\". "..Resource[language][164]);
			else
				if argArray[3]~=nil then
					NSCoord=string.lower(string.trim(string.gsub(argArray[3], "^(.-),(.*)","%1")));
					EWCoord=string.lower(string.trim(string.gsub(argArray[3], "(.*),(.-)$", "%2")));
					if argArray[4]~=nil and argArray[4]~="" then
						iconType=tonumber(argArray[4]);
					end
					if argArray[5]~=nil and argArray[5]~="" then
						lang=string.trim(argArray[5]);
					end
					if argArray[6]~=nil then
						target=string.trim(argArray[6]);
					end
					-- if target~=nil, look it up in nodeTier[#nodeTier+1] to see if we get a match on a crafting node
					if target~=nil then
						local tmpIndex;
						for tmpIndex=1,#nodeTier do
							if nodeTier[tmpIndex][1]==target and nodeTier[tmpIndex][4]==0 then
								iconType=nodeTier[tmpIndex][2];
								tier=nodeTier[tmpIndex][3];
								break;
							end
						end
					end
					if debug then
						Turbine.Shell.WriteLine("locale="..tostring(locale))
						Turbine.Shell.WriteLine("NSCoord:"..tostring(NSCoord)..", EWCoord:"..tostring(EWCoord))
					end

					if string.sub(NSCoord,-1)=="n" then
						NSCoord=string.sub(NSCoord,1,string.len(NSCoord)-1)
					elseif string.sub(NSCoord,-1)=="s" then
						NSCoord="-"..string.sub(NSCoord,1,string.len(NSCoord)-1)
					else
						NSCoord=nil;
					end

					if locale=="en" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					elseif locale=="fr" then
						if string.sub(EWCoord,-1)=="e" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="o" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					elseif locale=="de" then
						if string.sub(EWCoord,-1)=="o" then
							EWCoord=string.sub(EWCoord,1,string.len(EWCoord)-1)
						elseif string.sub(EWCoord,-1)=="w" then
							EWCoord="-"..string.sub(EWCoord,1,string.len(EWCoord)-1)
						else
							EWCoord=nil;
						end
					else
						EWCoord=nil;
					end
					if NSCoord~=nil and EWCoord~=nil then
						NSCoord=euroNormalize(NSCoord)
						EWCoord=euroNormalize(EWCoord)
					end
				end
				if NSCoord==nil or EWCoord==nil then
					Turbine.Shell.WriteLine(Resource[language][167].." \""..argArray[3].."\". "..Resource[language][164]);
				else
					if iconType==nil then
						Turbine.Shell.WriteLine(Resource[language][168].." \""..argArray[4].."\". "..Resource[language][164]);
					else
						if target==";target" then
							Turbine.Shell.WriteLine(Resource[language][169]..Resource[language][164]);
						else
							-- ok. we have proof of concept. now we just need to resolve the correct map and then follow the same routine as the "ping" function below without "ExternalPing=true"
							if debug then
								Turbine.Shell.WriteLine("add annotation:"..target.." ("..tostring(iconType)..") at:");
								Turbine.Shell.WriteLine("region:"..region.." NS:"..NSCoord.." EW:"..EWCoord);
								Turbine.Shell.WriteLine("tier:"..tostring(tier));
							end
							local mapList=ResolveMap(region,NSCoord,EWCoord);
							if mapList==nil or #mapList==0 then
								Turbine.Shell.WriteLine(Resource[language][170]..Resource[language][164]);
							else
								local tmpIndex;
								local dupIndex;
								local dupFound;
								NSCoord=tonumber(NSCoord);
								EWCoord=tonumber(EWCoord);
								for tmpIndex=1,#mapList do
								-- check for preexisting duplicate at same map, same name, same coordinates
									dupFound=false;
									for dupIndex=1,#annotations do
										if annotations[dupIndex][1]==mapList[tmpIndex] and annotations[dupIndex][2]==NSCoord and annotations[dupIndex][3]==EWCoord and annotations[dupIndex][7]==target..": "..target then
											dupFound=true;
											break;
										end
									end
									if dupFound then
										Turbine.Shell.WriteLine(target..Resource[language][171]..tostring(Resource[language][mapInfo[mapList[tmpIndex]][2]])..".");
									else
										annotations[#annotations+1]={mapList[tmpIndex],NSCoord,EWCoord,iconType,0,nil,target..": "..target,tier,0,0,0};
										Turbine.Shell.WriteLine(target..Resource[language][172]..tostring(Resource[language][mapInfo[mapList[tmpIndex]][2]]));
									end
								end
								annotWindow.LoadAnnotationList(); -- refresh the maintenance window in case we modified an annotation on the current map
							end
						end
					end
				end
			end
		elseif pos1~=nil and pos1>0 and command=="ping" then
			-- split up the args following "ping"
			local argArray=string.split(string.sub(args,pos1+1),":");
			if argArray[2]~=nil then
				argArray[2]=euroNormalize(argArray[2]);
			end
			if argArray[3]~=nil then
				argArray[3]=euroNormalize(argArray[3]);
			end
			if tonumber(argArray[1])==nil then
				Turbine.Shell.WriteLine(Resource[language][174]..tostring(argArray[1]).."). "..Resource[language][173]);
			elseif tonumber(argArray[2])==nil then
				Turbine.Shell.WriteLine(Resource[language][175]..tostring(argArray[2]).."). "..Resource[language][173]);
			elseif tonumber(argArray[3])==nil then
				Turbine.Shell.WriteLine(Resource[language][176]..tostring(argArray[3]).."). "..Resource[language][173]);
			elseif argArray[4]==nil then
				Turbine.Shell.WriteLine(Resource[language][177]..Resource[language][173]);
			elseif argArray[5]==nil then
				Turbine.Shell.WriteLine(Resource[language][178]..Resource[language][173]);
			else
				argArray[1]=math.floor(tonumber(argArray[1]));
				argArray[2]=tonumber(argArray[2]);
				argArray[3]=tonumber(argArray[3]);
				if argArray[1]>0 and argArray[1]<=#mapInfo then
					-- calculate x,y coordinates and verify they fall on the target map
					local X=math.floor(argArray[3]*mapInfo[argArray[1]][6]+mapInfo[argArray[1]][7]);
					local Y=math.floor(argArray[2]*mapInfo[argArray[1]][8]+mapInfo[argArray[1]][9]);
					if X<0 or X>mapInfo[argArray[1]][4] then
						Turbine.Shell.WriteLine(Resource[language][180]..tostring(argArray[3]).."). "..Resource[language][173]);
					elseif Y<0 or Y>mapInfo[argArray[1]][5] then
						Turbine.Shell.WriteLine(Resource[language][181]..tostring(argArray[2]).."). "..Resource[language][173]);
					else
						if argArray[1]==mapWindow.CurrentMapID then
							AddPing(argArray[2],argArray[3],argArray[4],argArray[5]);
						else

							mapWindow.PingNS=argArray[2];
							mapWindow.PingEW=argArray[3];
							mapWindow.PingName=argArray[4];
							mapWindow.PingDesc=argArray[5];
							mapWindow.ExternalPing=true;
							mapWindow.PreserveMapID=true;
							RefreshMap(argArray[1]);
						end
					end
				else
					-- invalid map specified
					Turbine.Shell.WriteLine(Resource[language][179]..Resource[language][173]);
				end
			end
		else
			Turbine.Shell.WriteLine("usage:");
			Turbine.Shell.WriteLine("  /MoorMap show");
			Turbine.Shell.WriteLine("       Displays the MoorMap map.");
			Turbine.Shell.WriteLine("  /MoorMap hide");
			Turbine.Shell.WriteLine("       Hides the MoorMap map.");
			Turbine.Shell.WriteLine("  /MoorMap toggle");
			Turbine.Shell.WriteLine("       Toggles the MoorMap map (shows it if it was hidden, hides it if it was showing).");
			Turbine.Shell.WriteLine("  /MoorMap ping MapID:NSCoord:EWCoord:Name:Description");
			Turbine.Shell.WriteLine("       Locates the named annotation on the indicated map and if it doesn't exist adds it then opens that map and puts a flashing Ping at the location.");
			Turbine.Shell.WriteLine("       This command enables external applications to add annotations and indicate them on the map. For more details on how to implement this, please");
			Turbine.Shell.WriteLine("       view the Readme.txt file that was in the original zip file and should now be located in your Plugins\GaranStuff\MoorMap folder.");
		end
	end
end
mapWindow.shellCmd.GetHelp = function(sender, cmd)
	return("usage:\n  /MoorMap show\n       Displays the MoorMap map.\n  /MoorMap hide\n       Hides the MoorMap map.\n  /MoorMap toggle\n       Toggles the MoorMap map (shows it if it was hidden, hides it if it was showing).");
end

mapWindow.shellCmd.GetShortHelp = function(sender, cmd)
	return("MoorMap - usage: /MoorMap show | hide | toggle");
end
mapWindow.Closing=function()
end

mapWindow.GetShowIconWhenMinimized=function()
	return mapWindow.ShowIconWhenMinimized;
end
mapWindow.SetShowIconWhenMinimized=function(sender,value)
	mapWindow.ShowIconWhenMinimized=value;
	if value then
		if minWindow:GetUseMiniIcon() then
			minWindow:SetSize(16,16);
		else
			minWindow:SetSize(32,32);
		end
	else
		minWindow:SetSize(0,0);
	end
end

mapWindow.SetTrimColor=function()
end
mapWindow.SetBackColor=function()
	mapWindow.NSCoord:SetBackColor(backColor);
	mapWindow.EWCoord:SetBackColor(backColor);
end
mapWindow.SetListTextColor=function()
end
mapWindow.SetFontColor=function()
	mapWindow.NSCoord:SetForeColor(fontColor);
	mapWindow.EWCoord:SetForeColor(fontColor);
end
mapWindow.SetHeadingsColor=function()
end
mapWindow.SetLanguage=function()
	if mapStrings[language]==nil or type(mapStrings[language])~="table" then
		mapStrings[language]={};
	end
	mapWindow:SetText(Resource[language][2]);
	mapWindow.AddAnnotationMenu:GetItems():Get(1):SetText(Resource[language][82]);
	-- quickWindow.Quickslot:SetVisible(true);

	mapWindow.FilterPanel.Title:SetText(Resource[language][66]);
	mapWindow.FilterPanel.AllegianceCaption:SetText(Resource[language][67]..":");
	mapWindow.FilterPanel.AllegianceCreep:SetText(Resource[language][68]);
	mapWindow.FilterPanel.AllegianceFreep:SetText(Resource[language][69]);
	mapWindow.FilterPanel.AllegianceDelving:SetText(Resource[language][70]);
	mapWindow.FilterPanel.TypeCaption:SetText(Resource[language][74]..":");
	mapWindow.FilterPanel.TypeMain:SetText(Resource[language][106]);
	mapWindow.FilterPanel.TypeSecondary:SetText(Resource[language][107]);
	mapWindow.FilterPanel.TypeBase:SetText(Resource[language][108]);
	mapWindow.FilterPanel.TypeOutpost:SetText(Resource[language][109]);
	mapWindow.FilterPanel.TypePOI:SetText(Resource[language][110]);
	mapWindow.FilterPanel.TypeFort:SetText(Resource[language][111]);
	mapWindow.FilterPanel.TypeRez:SetText(Resource[language][112]);
	mapWindow.FilterPanel.TypeMap:SetText(Resource[language][119]);
	mapWindow.FilterPanel.TypeNPC:SetText(Resource[language][116]);

	mapWindow.Map.SearchFilterCaption:SetText(Resource[language][65]..":");
	mapWindow.Map.IconCreepCB:SetText(Resource[language][68]);
	mapWindow.Map.IconFreepCB:SetText(Resource[language][69]);
	mapWindow.Map.IconDelvingCB:SetText(Resource[language][70]);

	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(1):SetText(Resource[language][158]);
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(2):SetText(Resource[language][159].." 1");
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(3):SetText(Resource[language][159].." 2");
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(4):SetText(Resource[language][159].." 3");
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(5):SetText(Resource[language][159].." 4");
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(6):SetText(Resource[language][159].." 5");
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(7):SetText(Resource[language][159].." 6");
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(8):SetText(Resource[language][159].." 7");
	mapWindow.FilterPanel.TypeOreNodeTier.ListData:GetItem(9):SetText(Resource[language][159].." 8");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(1):SetText(Resource[language][158]);
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(2):SetText(Resource[language][159].." 1");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(3):SetText(Resource[language][159].." 2");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(4):SetText(Resource[language][159].." 3");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(5):SetText(Resource[language][159].." 4");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(6):SetText(Resource[language][159].." 5");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(7):SetText(Resource[language][159].." 6");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(8):SetText(Resource[language][159].." 7");
	mapWindow.FilterPanel.TypeWoodNodeTier.ListData:GetItem(9):SetText(Resource[language][159].." 8");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(1):SetText(Resource[language][158]);
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(2):SetText(Resource[language][159].." 1");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(3):SetText(Resource[language][159].." 2");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(4):SetText(Resource[language][159].." 3");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(5):SetText(Resource[language][159].." 4");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(6):SetText(Resource[language][159].." 5");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(7):SetText(Resource[language][159].." 6");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(8):SetText(Resource[language][159].." 7");
	mapWindow.FilterPanel.TypeScholarNodeTier.ListData:GetItem(9):SetText(Resource[language][159].." 8");
	breadcrumbWindow:SetText(Resource[language][238]);
	breadcrumbWindow.ColorLabel:SetText(Resource[language][239]..":");

	local tmpMap=mapInfo[mapWindow.CurrentMapID][3]
	if language==2 and mapInfo[mapWindow.CurrentMapID][19]~=nil then
		tmpMap=mapInfo[mapWindow.CurrentMapID][19]
	elseif language==3 and mapInfo[mapWindow.CurrentMapID][18] ~= nil then
		tmpMap=mapInfo[mapWindow.CurrentMapID][18]
	elseif language==4 and mapInfo[mapWindow.CurrentMapID][20] ~= nil then
		tmpMap=mapInfo[mapWindow.CurrentMapID][20]
	end
	pcall(Turbine.UI.Control.SetBackground,mapWindow.Map,tmpMap);
	RefreshMap();
end
if debug then
	Turbine.Shell.WriteLine("in constructor, just prior to setting size mapWindow.CurrentMapID="..tostring(mapWindow.CurrentMapID))
end
if mapWindow.CurrentMapID==nil or mapInfo[mapWindow.CurrentMapID]==nil then
	-- this should never happen unless there was an error, such as the client crashed prior to an update or other unlikely and invalid condition
	mapWindow.CurrentMapID=1;
end
mapWindow.Map:SetSize(mapInfo[mapWindow.CurrentMapID][4],mapInfo[mapWindow.CurrentMapID][5]);
local tmpMap=mapInfo[mapWindow.CurrentMapID][3]
if language==2 and mapInfo[mapWindow.CurrentMapID][19]~=nil then
	tmpMap=mapInfo[mapWindow.CurrentMapID][19]
elseif language==3 and mapInfo[mapWindow.CurrentMapID][18] ~= nil then
	tmpMap=mapInfo[mapWindow.CurrentMapID][18]
elseif language==4 and mapInfo[mapWindow.CurrentMapID][20] ~= nil then
	tmpMap=mapInfo[mapWindow.CurrentMapID][20]
end
pcall(Turbine.UI.Control.SetBackground,mapWindow.Map,tmpMap);
mapWindow.Map:SetStretchMode(1);
mapWindow.Map:SetSize(mapWindow:GetSize());
mapWindow.CloseButton:SetLeft(mapWindow:GetWidth()-20);
mapWindow.Map.IconList:SetHeight(mapWindow.SearchPanel:GetHeight()-45);
mapWindow.Map.IconList.VScroll:SetHeight(mapWindow.Map.IconList:GetHeight());
mapWindow.Map.IconSearch:SetWantsUpdates(false);

-- overlay map info
overlayWindow.Name:SetText(Resource[language][mapInfo[mapWindow.CurrentMapID][2]]);
overlayWindow.MapW:SetText(mapInfo[mapWindow.CurrentMapID][4]);
overlayWindow.MapH:SetText(mapInfo[mapWindow.CurrentMapID][5]);

function AddPing(EWCoord,NSCoord,Name,Description)
	local tmpAnnotIndex;
	local tmpIndex;
	local tmpName=string.lower(tostring(Name));
	local tmpAnnotName;
	local pos;
	local found=false;
	for tmpIndex=1,#annotations do
		if annotations[tmpIndex][1]==mapWindow.CurrentMapID then
			if annotations[tmpIndex][6]~=nil then
				tmpAnnotName=mapStrings[language][annotations[tmpIndex][6]];
			else
				tmpAnnotName=annotations[tmpIndex][7];
			end
			if tmpAnnotName~=nil then
				pos=string.find(tmpAnnotName,":",1,true);
				if pos~=nil then
					tmpAnnotName=string.lower(string.sub(tmpAnnotName,1,pos-1));
				else
					tmpAnnotName=string.lower(tmpAnnotName);
				end
				if tmpName==tmpAnnotName then
					if math.abs(EWCoord-annotations[tmpIndex][2])<1 and math.abs(NSCoord-annotations[tmpIndex][3])<1 then
						-- same name and same basic area, treat as same annotation
						found=true;
						tmpAnnotIndex=tmpIndex;
						break;
					end
				end
			end
		end
	end
	if not found then
		-- need to insert criteria as a new annotation
		tmpAnnotIndex=#annotations+1
		annotations[tmpAnnotIndex]={mapWindow.CurrentMapID,EWCoord,NSCoord,5,1,nil,Name..": "..Description,0,0,0,0}
		RefreshMap();
		annotWindow.LoadAnnotationList();
	end
	if not mapWindow:IsVisible() then
		mapWindow:SetVisible(true);
		minWindow:SetVisible(false);
		quickWindow:SetVisible(quickWindow.Displayed);
		if BDDLegend~=nil then
			BDDLegend:SetVisible(BDDVis)
		end
	end
	-- and activate a "ping" for it
	mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
	mapWindow.Map.Ping:SetPosition(math.floor((annotations[tmpAnnotIndex][3]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((annotations[tmpAnnotIndex][2]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
	mapWindow.Map.Ping.State=1;
	mapWindow.Map.Ping:SetVisible(true);
	mapWindow.Map.Ping:SetWantsUpdates(true);
end
function RefreshBreadcrumbs()
	if Turbine.Engine:GetGameTime()>mapWindow.flashTime then
		mapWindow.flashTime=Turbine.Engine:GetGameTime()+.2;

		local tmpIndex;
		local tmpFlashIndex=mapWindow.flashIndex;
		for tmpIndex,icon in ipairs(mapWindow.Map.breadcrumbImage) do
			pcall(Turbine.UI.Control.SetBackground,icon,"GaranStuff/MoorMap/Resources/Breadcrumb"..tostring(tmpFlashIndex)..".tga");
			tmpFlashIndex=tmpFlashIndex-1;
			if tmpFlashIndex<1 then tmpFlashIndex=5 end;
		end
		mapWindow.flashIndex=mapWindow.flashIndex+1;
		if mapWindow.flashIndex>5 then mapWindow.flashIndex=1 end;
	end
end

function RefreshMap(MapID)
	local tmpIndex;
	if MapID==nil then MapID=mapWindow.CurrentMapID end
	if debug then Turbine.Shell.WriteLine("mapWindow.CurrentMapID="..tostring(mapWindow.CurrentMapID)) end
	if mapWindow.Map.breadcrumbImage~=nil then
		local imageCount=#mapWindow.Map.breadcrumbImage
		if imageCount>0 then
			mapWindow.Map.breadcrumbImage[1]:SetWantsUpdates(false);
			mapWindow.Map.breadcrumbImage[1].Update=nil;
		end
		local tmpIndex;
		for tmpIndex=imageCount,1,-1 do
			mapWindow.Map.breadcrumbImage[tmpIndex]:SetVisible(false);
			mapWindow.Map.breadcrumbImage[tmpIndex]=nil;
		end
	end
	if MapID~=mapWindow.CurrentMapID then
		if MapID~=0 then
			-- we use MapID=0 to force a reload of the annotations
			mapWindow.CurrentMapID=MapID;
		end
		mapWindow.PreserveMapID=true;
		-- load the plugin that will unload and reload this plugin (we can only read the annotation files without a 15 second delay while we are "loading")
		Turbine.PluginManager.LoadPlugin("MoorMapLoader");
	else

		-- clear out the existing search list
		while mapWindow.Map.IconList:GetItemCount()>0 do
			-- clear the event handler
			mapWindow.Map.IconList:GetItem(1).MouseClick=nil;
			mapWindow.Map.IconList:RemoveItemAt(1);
		end
		LoadMapsIns(); -- we load these first so that we can check them for annotations of type=8
		local XScale=mapWindow:GetWidth()/mapInfo[mapWindow.CurrentMapID][4];
		local YScale=mapWindow:GetHeight()/mapInfo[mapWindow.CurrentMapID][5];

		XScale=1; -- turns out, the parent in Stretchmode=1 automatically takes care of it's children :)
		YScale=1; -- I'm leaving the scaling variables in just in case I ever decide to display icons using the plugin window instead of the map control as parent

		local HFactor=mapInfo[mapWindow.CurrentMapID][6];
		local HOffset=mapInfo[mapWindow.CurrentMapID][7];
		local VFactor=mapInfo[mapWindow.CurrentMapID][8];
		local VOffset=mapInfo[mapWindow.CurrentMapID][9];
		local tmpIconIndex=0;
		local tmpDescription;
		local tmpShortDescription;
		local pos1;
		local tmpList={};
		local tmpVisible;

		for tmpIndex=1,#annotations do
			if annotations[tmpIndex][1]==mapWindow.CurrentMapID then
				tmpIconIndex=tmpIconIndex+1;
				-- check if we need a new control
				if tmpIconIndex>#mapWindow.Map.Icons then
					mapWindow.Map.Icons[tmpIconIndex]=Turbine.UI.Control();
					mapWindow.Map.Icons[tmpIconIndex]:SetParent(mapWindow.Map)
					mapWindow.Map.Icons[tmpIconIndex]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
				end
				mapWindow.Map.Icons[tmpIconIndex]:SetBackColor(Turbine.UI.Color(0,0,0,0));
				mapWindow.Map.Icons[tmpIconIndex]:SetBackColorBlendMode(8);
				mapWindow.Map.Icons[tmpIconIndex]:SetZOrder(100);

				mapWindow.Map.Icons[tmpIconIndex]:SetSize(iconInfo[annotations[tmpIndex][4]][2],iconInfo[annotations[tmpIndex][4]][3]);
				mapWindow.Map.Icons[tmpIconIndex]:SetBackground(iconInfo[annotations[tmpIndex][4]][4]);
				mapWindow.Map.Icons[tmpIconIndex]:SetPosition(math.floor((annotations[tmpIndex][3]*HFactor+HOffset)*XScale)-iconInfo[annotations[tmpIndex][4]][2]/2,math.floor((annotations[tmpIndex][2]*VFactor+VOffset)*YScale)-iconInfo[annotations[tmpIndex][4]][3]/2);

				-- need to test filters
				tmpVisible=true;
				if annotations[tmpIndex][5]==2 then
					if not mapWindow.FilterPanel.AllegianceCreep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][5]==3 then
					if not mapWindow.FilterPanel.AllegianceFreep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][5]==4 then
					if not mapWindow.FilterPanel.AllegianceDelving:IsChecked() then tmpVisible=false end
				end

				if annotations[tmpIndex][4]==1 then
					if not mapWindow.FilterPanel.TypeMain:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==2 then
					if not mapWindow.FilterPanel.TypeSecondary:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==3 then
					if not mapWindow.FilterPanel.TypeBase:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==4 then
					if not mapWindow.FilterPanel.TypeOutpost:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==5 then
					if not mapWindow.FilterPanel.TypePOI:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==6 then
					if not mapWindow.FilterPanel.TypeFort:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==7 then
					if not mapWindow.FilterPanel.TypeRez:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==8 or annotations[tmpIndex][4]==9 or annotations[tmpIndex][4]==10 or annotations[tmpIndex][4]==12 then
					if not mapWindow.FilterPanel.TypeMap:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==11 then
					if not mapWindow.FilterPanel.TypeNPC:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==46 then
					if not mapWindow.FilterPanel.TypeCook:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==48 then
					if not mapWindow.FilterPanel.TypeScholarIngredient:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==14 then
					if not mapWindow.FilterPanel.TypeAuctioneer:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==15 then
					if not mapWindow.FilterPanel.TypeBarber:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==16 then
					if not mapWindow.FilterPanel.TypeBard:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==17 then
					if not mapWindow.FilterPanel.TypeCampSite:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==18 then
					if not mapWindow.FilterPanel.TypeCraftSite:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==20 then
					if not mapWindow.FilterPanel.TypeCraftVendor:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==49 then
					if not mapWindow.FilterPanel.TypeDungeon:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==21 then
					if not mapWindow.FilterPanel.TypeFactionRep:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==25 then
					if not mapWindow.FilterPanel.TypeItemMaster:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==26 then
					if not mapWindow.FilterPanel.TypeMailbox:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==27 then
					if not mapWindow.FilterPanel.TypeMilestone:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==47 then
					if not mapWindow.FilterPanel.TypeMusteringHorn:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==32 then
					if not mapWindow.FilterPanel.TypeReflectingPool:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==33 then
					if not mapWindow.FilterPanel.TypeSettlement:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==34 then
					if not mapWindow.FilterPanel.TypeStableMaster:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==50 then
					if not mapWindow.FilterPanel.TypeTaskboard:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==35 then
					if not mapWindow.FilterPanel.TypeTownCrier:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==37 then
					if not mapWindow.FilterPanel.TypeTrader:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==38 then
					if not mapWindow.FilterPanel.TypeTrainer:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==39 then
					if not mapWindow.FilterPanel.TypeVaultKeeper:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==40 then
					if not mapWindow.FilterPanel.TypeVendor:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==42 then
					if not mapWindow.FilterPanel.TypeSkirmishCamp:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==43 then
					if not (mapWindow.FilterPanel.TypeOreNode:IsChecked() and (mapWindow.FilterPanel.TypeOreNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeOreNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==44 then
					if not (mapWindow.FilterPanel.TypeWoodNode:IsChecked() and (mapWindow.FilterPanel.TypeWoodNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeWoodNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==45 then
					if not (mapWindow.FilterPanel.TypeScholarNode:IsChecked() and (mapWindow.FilterPanel.TypeScholarNodeTier:GetValue()==0 or mapWindow.FilterPanel.TypeScholarNodeTier:GetValue()==annotations[tmpIndex][8])) then tmpVisible=false end
				elseif annotations[tmpIndex][4]==51 or annotations[tmpIndex][4]==52 then
					if not mapWindow.FilterPanel.TypeStair:IsChecked() then tmpVisible=false end
				elseif annotations[tmpIndex][4]==53 then
					if not mapWindow.FilterPanel.TypeQuest:IsChecked() then tmpVisible=false end
				end
				mapWindow.Map.Icons[tmpIconIndex]:SetVisible(tmpVisible);

				mapWindow.Map.Icons[tmpIconIndex].AnnotationIndex=tmpIndex;
				mapWindow.Map.Icons[tmpIconIndex].IconIndex=annotations[tmpIndex][4];
				tmpDescription=annotations[tmpIndex][7]; -- use custom text by default
				if tmpDescription==nil or tmpDescription=="" then
					if annotations[tmpIndex][6]~=nil then
						if mapStrings[language][annotations[tmpIndex][6]]~=nil then
							tmpDescription=mapStrings[language][annotations[tmpIndex][6]]; -- use translated text if found
						elseif mapStrings[1][annotations[tmpIndex][6]]~=nil then
							tmpDescription=mapStrings[1][annotations[tmpIndex][6]]; -- fall back to english if translated text not found
						end
					end
				end
				tmpShortDescription="";
				pos1=string.find (tmpDescription,":",0,true);
				if (pos1~=nil)then
					tmpShortDescription=string.sub(tmpDescription,1,pos1-1);
					tmpDescription=string.sub(tmpDescription,pos1+1);
				end
				mapWindow.Map.Icons[tmpIconIndex].Description=tmpDescription;
				mapWindow.Map.Icons[tmpIconIndex].ShortDescription=tmpShortDescription;
				tmpList[#tmpList+1]={tmpIndex,tmpShortDescription,1};
				if annotations[tmpIndex][2]<0 then
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=tostring(0-math.floor(annotations[tmpIndex][2]*10)/10).."S, ";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2].."("..tostring(0-math.floor(annotations[tmpIndex][2]*10)/10).."S, ";
					end
				else
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=tostring(math.floor(annotations[tmpIndex][2]*10)/10).."N, ";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2].."("..tostring(math.floor(annotations[tmpIndex][2]*10)/10).."N, ";
					end
				end
				if annotations[tmpIndex][3]<0 then
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=mapWindow.Map.Icons[tmpIconIndex].MapCoord..tostring(0-math.floor(annotations[tmpIndex][3]*10)/10).."W";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2]..tostring(0-math.floor(annotations[tmpIndex][3]*10)/10).."W)";
					end
				else
					mapWindow.Map.Icons[tmpIconIndex].MapCoord=mapWindow.Map.Icons[tmpIconIndex].MapCoord..tostring(math.floor(annotations[tmpIndex][3]*10)/10).."E";
					if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
						tmpList[#tmpList][2]=tmpList[#tmpList][2]..tostring(math.floor(annotations[tmpIndex][3]*10)/10).."E)";
					end
				end
				mapWindow.Map.Icons[tmpIconIndex].XYCoord=tostring(math.floor((annotations[tmpIndex][3]*HFactor+HOffset)*XScale))..", "..tostring(math.floor((annotations[tmpIndex][2]*VFactor+VOffset)*YScale));
				if annotations[tmpIndex][4]==8 or annotations[tmpIndex][4]==9 or annotations[tmpIndex][4]==10 or annotations[tmpIndex][4]==12 then
					tmpList[#tmpList][3]=2;
					-- check whether there is a MapPoint set for this point (character must have the map in their inventory)
					local mapFound=false;
					local tmpMPIndex;
					for tmpMPIndex=1,#mapWindow.Map.MapPoints.Item do
						if mapWindow.Map.MapPoints.Item[tmpMPIndex].V==annotations[tmpIndex][2] and mapWindow.Map.MapPoints.Item[tmpMPIndex].H==annotations[tmpIndex][3] then
							mapFound=true;
							break;
						end
					end
					if mapFound then
						mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(false)
						mapWindow.Map.Icons[tmpIconIndex].MouseEnter=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=nil;
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=nil;

					else
						-- do we want to use the "unearned" icon?
						mapWindow.Map.Icons[tmpIconIndex].IconIndex=13;
						mapWindow.Map.Icons[tmpIconIndex]:SetBackground(iconInfo[13][4]);

						mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
						mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
							sender:SetBackground(iconInfo[sender.IconIndex][5]);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							sender:SetBackground(iconInfo[sender.IconIndex][4]);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
							if width<100 then width=100 end
							mapWindow.Map.HoverWindow:SetWidth(width+10);							
							mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
							mapWindow.Map.HoverWindow.MapID=nil;
							mapWindow.Map.HoverWindow.Name.MouseClick=nil;
							if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
								mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
								local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
								sc:SetData("/way target "..sender.MapCoord);
								mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
								mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(EnableWaypoint);
							else
								mapWindow.Map.HoverWindow.Coord:SetText("");
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
							end
							mapWindow.Map.HoverWindow.Edit:SetVisible(false);
							mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
							mapWindow.Map.HoverWindow.Hide=false;
							mapWindow.Map.HoverWindow.HideCount=0;
							mapWindow.Map.HoverWindow:SetVisible(true);
							mapWindow.Map.HoverWindow:SetWantsUpdates(true);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
								mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
								mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil; -- dismiss the dialog
							end
							local text="<rgb=#FFFFFF>Location: "..tostring(sender.MapCoord).."</rgb>\n\n"..sender.Description.."\n";
							mapWindow.PopUp=PopUpDialog(sender.ShortDescription,text,4,"OK",nil,nil,true)
							mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
							if mapWindow.PopUpTop~=-1 then
								mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
							end
						end
					end


				elseif annotations[tmpIndex][4]==41 or annotations[tmpIndex][4]==51 or annotations[tmpIndex][4]==52 then
					tmpList[#tmpList][3]=2; -- map connector
					mapWindow.Map.Icons[tmpIconIndex].MapID=annotations[tmpIndex][8];
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][5]);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][4]);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
						-- switch to the indicated map
						RefreshMap(sender.MapID);
					end
				elseif annotations[tmpIndex][4]==49 then
					tmpList[#tmpList][3]=2; -- interior location

					mapWindow.Map.Icons[tmpIconIndex].MapID=annotations[tmpIndex][8];
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][5]);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][4]);
					end
					if mapWindow.Map.Icons[tmpIconIndex].MapID~=nil and mapWindow.Map.Icons[tmpIconIndex].MapID>0 then
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							-- not really sure I like this functionality
							local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
							if width<100 then width=100 end
							mapWindow.Map.HoverWindow:SetWidth(width+10);							
							mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
							mapWindow.Map.HoverWindow.MapID=sender.MapID;
							mapWindow.Map.HoverWindow.Name.MouseClick=function(target)
								if mapWindow.Map.HoverWindow.MapID~=nil then
									RefreshMap(mapWindow.Map.HoverWindow.MapID);
									mapWindow.Map.HoverWindow:SetVisible(false);
								end
							end
							mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
							mapWindow.Map.HoverWindow.Waypoint:SetVisible(EnableWaypoint);
							local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
							sc:SetData("/way target "..sender.MapCoord);
							mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
							mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
							mapWindow.Map.HoverWindow.Edit:SetVisible(false);
							mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
							mapWindow.Map.HoverWindow.Hide=false;
							mapWindow.Map.HoverWindow.HideCount=0;
							mapWindow.Map.HoverWindow:SetVisible(true);
							mapWindow.Map.HoverWindow:SetWantsUpdates(true);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							-- switch to the indicated map
							RefreshMap(sender.MapID);
						end
					else
						mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
							local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
							if width<100 then width=100 end
							mapWindow.Map.HoverWindow:SetWidth(width+10);
							mapWindow.Map.HoverWindow.MapCoord=sender.MapCoord;
							mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
							mapWindow.Map.HoverWindow.ShortDescription=sender.ShortDescription;
							mapWindow.Map.HoverWindow.Description=sender.Description;
							mapWindow.Map.HoverWindow.Name.MouseClick=function(target)
								if mapWindow.PopUp~=nil then
									mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
									mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
									mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
									mapWindow.PopUp:SetVisible(false);
									mapWindow.PopUp=nil;
								end
								local text="<rgb=#FFFFFF>Location: "..tostring(mapWindow.Map.HoverWindow.MapCoord).."</rgb>\n\n"..mapWindow.Map.HoverWindow.Description.."\n";
								mapWindow.PopUp=PopUpDialog(mapWindow.Map.HoverWindow.ShortDescription,text,4,"OK",nil,nil,true)
								mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
								if mapWindow.PopUpTop~=-1 then
									mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
								end
								mapWindow.Map.HoverWindow:SetVisible(false);
							end
							mapWindow.Map.HoverWindow.MapID=nil;
							if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
								mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
								local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
								sc:SetData("/way target "..sender.MapCoord);
								mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
								mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(EnableWaypoint);
							else
								mapWindow.Map.HoverWindow.Coord:SetText("");
								mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
							end
							annotWindow:SelectAnnotation(sender.AnnotationIndex);
							if annotations[sender.AnnotationIndex][6]==nil then
								mapWindow.Map.HoverWindow.Edit:SetText(Resource[language][83]);
								mapWindow.Map.HoverWindow.Edit:SetVisible(true);
							else
								-- we no longer allow editing default annotations (creates conflicts with updates)
								mapWindow.Map.HoverWindow.Edit:SetVisible(false);
							end
							if debug then
								mapWindow.Map.HoverWindow.XY:SetText(sender.XYCoord);
							end
							mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
							mapWindow.Map.HoverWindow.Hide=false;
							mapWindow.Map.HoverWindow.HideCount=0;
							mapWindow.Map.HoverWindow:SetVisible(true);
							mapWindow.Map.HoverWindow:SetWantsUpdates(true);
						end
						mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
								mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
								mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil; -- dismiss the dialog
							end
							local text="<rgb=#FFFFFF>Location: "..tostring(sender.MapCoord).."</rgb>\n\n"..sender.Description.."\n";
							mapWindow.PopUp=PopUpDialog(sender.ShortDescription,text,4,"OK",nil,nil,true)
							mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
							if mapWindow.PopUpTop~=-1 then
								mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
							end
						end
					end
				else
					if annotations[tmpIndex][4]==11 or annotations[tmpIndex][4]==14 or annotations[tmpIndex][4]==15 or annotations[tmpIndex][4]==16 or annotations[tmpIndex][4]==20 or annotations[tmpIndex][4]==21 or annotations[tmpIndex][4]==25 or annotations[tmpIndex][4]==34 or annotations[tmpIndex][4]==35 or annotations[tmpIndex][4]==37 or annotations[tmpIndex][4]==38 or annotations[tmpIndex][4]==39 or annotations[tmpIndex][4]==40 then
						tmpList[#tmpList][3]=3; -- npc
					end
					mapWindow.Map.Icons[tmpIconIndex]:SetMouseVisible(true)
					mapWindow.Map.Icons[tmpIconIndex].MouseEnter=function(sender,args)
						sender:SetBackground(iconInfo[sender.IconIndex][5]);
					end
					if annotations[tmpIndex][4]==11 then
						-- can't use the backcolor mechanism because there is no way to reset the back color to undefined state for reuse
						-- color npc icons based on allegiance
						if annotations[tmpIndex][5]==2 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_red.tga"
						elseif annotations[tmpIndex][5]==3 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_blue.tga"
						elseif annotations[tmpIndex][5]==1 then -- netral
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_yellow.tga"
						elseif annotations[tmpIndex][5]==4 then
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC_violet.tga"
						else
							mapWindow.Map.Icons[tmpIconIndex].Icon="GaranStuff/MoorMap/Resources/NPC.tga"
							mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
								sender:SetBackground(iconInfo[sender.IconIndex][4]);
							end
						end
						mapWindow.Map.Icons[tmpIconIndex]:SetBackground(mapWindow.Map.Icons[tmpIconIndex].Icon);
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							sender:SetBackground(sender.Icon);
						end

					else
						mapWindow.Map.Icons[tmpIconIndex].MouseLeave=function(sender,args)
							sender:SetBackground(iconInfo[sender.IconIndex][4]);
						end
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseHover=function(sender,args)
						local width=mapWindow.FontMetric:GetTextWidth(sender.ShortDescription,14);
						if width<100 then width=100 end
						mapWindow.Map.HoverWindow:SetWidth(width+10);							
						mapWindow.Map.HoverWindow.Name:SetText(sender.ShortDescription);
						mapWindow.Map.HoverWindow.ShortDescription=sender.ShortDescription;
						mapWindow.Map.HoverWindow.Description=sender.Description;
						mapWindow.Map.HoverWindow.MapCoord=sender.MapCoord;
						mapWindow.Map.HoverWindow.Name.MouseClick=function(target)
							if mapWindow.PopUp~=nil then
								mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
								mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
								mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
								mapWindow.PopUp:SetVisible(false);
								mapWindow.PopUp=nil;
							end
							local text="<rgb=#FFFFFF>Location: "..tostring(mapWindow.Map.HoverWindow.MapCoord).."</rgb>\n\n"..mapWindow.Map.HoverWindow.Description.."\n";
							mapWindow.PopUp=PopUpDialog(mapWindow.Map.HoverWindow.ShortDescription,text,4,"OK",nil,nil,true)
							mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
							if mapWindow.PopUpTop~=-1 then
								mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
							end
							mapWindow.Map.HoverWindow:SetVisible(false);
						end
						mapWindow.Map.HoverWindow.MapID=nil;
						if debug or mapInfo[mapWindow.CurrentMapID][11]~=2 then
							mapWindow.Map.HoverWindow.Coord:SetText(sender.MapCoord);
							local sc=Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias,"")
							sc:SetData("/way target "..sender.MapCoord);
							mapWindow.Map.HoverWindow.Waypoint.Alias="/way target "..sender.MapCoord;
							mapWindow.Map.HoverWindow.Waypoint:SetShortcut(sc);
							mapWindow.Map.HoverWindow.Waypoint:SetVisible(EnableWaypoint);
						else
							mapWindow.Map.HoverWindow.Coord:SetText("");
							mapWindow.Map.HoverWindow.Waypoint:SetVisible(false);
						end
						annotWindow:SelectAnnotation(sender.AnnotationIndex);
						if annotations[sender.AnnotationIndex][6]==nil then
							mapWindow.Map.HoverWindow.Edit:SetText(Resource[language][83]);
							mapWindow.Map.HoverWindow.Edit:SetVisible(true);
						else
							-- we no longer allow editing default annotations (creates conflicts with updates)
							mapWindow.Map.HoverWindow.Edit:SetVisible(false);
						end
						if debug then
							mapWindow.Map.HoverWindow.XY:SetText(sender.XYCoord);
						end
						mapWindow.Map.HoverWindow:SetPosition(Turbine.UI.Display:GetMouseX()-5,Turbine.UI.Display:GetMouseY()-5);
						mapWindow.Map.HoverWindow.Hide=false;
						mapWindow.Map.HoverWindow.HideCount=0;
						mapWindow.Map.HoverWindow:SetVisible(true);
						mapWindow.Map.HoverWindow:SetWantsUpdates(true);
					end
					mapWindow.Map.Icons[tmpIconIndex].MouseClick=function(sender,args)
						if mapWindow.PopUp~=nil then
							mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
							mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
							mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
							mapWindow.PopUp:SetVisible(false);
							mapWindow.PopUp=nil; -- dismiss the dialog
						end
						local text="<rgb=#FFFFFF>Location: "..tostring(sender.MapCoord).."</rgb>\n\n"..sender.Description.."\n";
						mapWindow.PopUp=PopUpDialog(sender.ShortDescription,text,4,"OK",nil,nil,true)
						mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
						if mapWindow.PopUpTop~=-1 then
							mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
						end
					end
				end
			end
		end	
		local tmpLabel;
		mapWindow.MapSelect:SetZOrder(101+tmpIconIndex);
		-- sort list by col3 (type 1-3), then col2 (name)
		table.sort(tmpList,function(arg1,arg2) if arg1[3]<arg2[3] then return(true) else if arg1[3]==arg2[3] and arg1[2]<arg2[2] then return(true) end end end);
		local tmpType=0;
		for tmpIndex=1,#tmpList do
			if tmpList[tmpIndex][3]~=tmpType then
				-- insert headers
				tmpType=tmpList[tmpIndex][3];
				tmpLabel=Turbine.UI.Label()
				tmpLabel:SetSize(mapWindow.Map.IconList:GetWidth()-12,20);
				tmpLabel:SetBackColor(Turbine.UI.Color(.1,.1,.05));
				tmpLabel:SetForeColor(headingsColor);
				tmpLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
				tmpLabel:SetFont(Turbine.UI.Lotro.Font.TrajanProBold16);
				tmpLabel:SetMultiline(false);
				tmpLabel.AnnotationIndex=0;
				tmpLabel.NormalHeight=20;
				tmpLabel:SetText(Resource[language][73]);
				if tmpType==1 then
					tmpLabel:SetText(Resource[language][86])
				elseif tmpType==2 then
					tmpLabel:SetText(Resource[language][119])
				elseif tmpType==3 then
					tmpLabel:SetText(Resource[language][116])
				end
				mapWindow.Map.IconList:AddItem(tmpLabel);
			end
			tmpLabel=Turbine.UI.Label()
			tmpLabel:SetSize(mapWindow.Map.IconList:GetWidth()-12,18);
			tmpLabel:SetBackColor(mapWindow.Map.IconList:GetBackColor());
			tmpLabel:SetForeColor(listTextColor);
			tmpLabel:SetMultiline(false);
			tmpLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter);
			tmpLabel:SetFont(fontFace);
			tmpLabel.NormalHeight=18;
			tmpLabel:SetText(tmpList[tmpIndex][2])
			tmpLabel.AnnotationIndex=tmpList[tmpIndex][1];
			if annotations[tmpLabel.AnnotationIndex][5]==2 then
				tmpLabel:SetForeColor(Turbine.UI.Color(1,0,0));
			elseif annotations[tmpLabel.AnnotationIndex][5]==3 then
				tmpLabel:SetForeColor(Turbine.UI.Color(.35,.35,1));
			elseif annotations[tmpLabel.AnnotationIndex][5]==4 then
				tmpLabel:SetForeColor(Turbine.UI.Color(.5,.35,.7));
			end
			local tmpDescription=annotations[tmpList[tmpIndex][1]][7]; -- use custom text by default
			if tmpDescription==nil or tmpDescription=="" then
				if annotations[tmpList[tmpIndex][1]][6]~=nil then
					if mapStrings[language][annotations[tmpList[tmpIndex][1]][6]]~=nil then
						tmpDescription=mapStrings[language][annotations[tmpList[tmpIndex][1]][6]]; -- use translated text if found
					elseif Resource[1][annotations[tmpList[tmpIndex][1]][6]]~=nil then
						tmpDescription=Resource[1][annotations[tmpList[tmpIndex][1]][6]]; -- fall back to english if translated text not found
					end
				end
			end
			local tmpShortDescription="";
			local pos1=string.find (tmpDescription,":",1,true);
			if (pos1~=nil)then
				tmpShortDescription=string.sub(tmpDescription,1,pos1-1);
				tmpDescription=string.sub(tmpDescription,pos1+1);
			end
			tmpLabel.Description=tmpDescription;
			tmpLabel.ShortDescription=tmpShortDescription;
			tmpLabel.MouseClick=function(sender,args)
				if args.Button==1 then
					mapWindow.SearchPanel:SetVisible(false);
					mapWindow.Map.IconSearch:SetWantsUpdates(false);
					mapWindow.Map.Ping:SetZOrder(101+#mapWindow.Map.Icons);
					mapWindow.Map.Ping:SetPosition(math.floor((annotations[sender.AnnotationIndex][3]*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7])-11.5),math.floor((annotations[sender.AnnotationIndex][2]*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9])-11.5));
					mapWindow.Map.Ping.State=1;
					mapWindow.Map.Ping:SetVisible(true);
					mapWindow.Map.Ping:SetWantsUpdates(true);
				else
					if mapWindow.PopUp~=nil then
						mapWindow.PopUpPinned=mapWindow.PopUp:IsPinned()
						mapWindow.PopUpTop=mapWindow.PopUp:GetTop();
						mapWindow.PopUpLeft=mapWindow.PopUp:GetLeft();
						mapWindow.PopUp:SetVisible(false);
						mapWindow.PopUp=nil;
					end
					mapWindow.PopUp=PopUpDialog(sender.ShortDescription,sender.Description,4,"OK",nil,nil,true)
					mapWindow.PopUp:SetPinned(mapWindow.PopUpPinned)
					if mapWindow.PopUpTop~=-1 then
						mapWindow.PopUp:SetPosition(mapWindow.PopUpLeft,mapWindow.PopUpTop);
					end
				end
			end
			mapWindow.Map.IconList:AddItem(tmpLabel);
		end

		-- for a refresh of the list
		mapWindow.Map.IconSearch.OldAllegianceDelving=not mapWindow.Map.IconDelvingCB:IsChecked();
		mapWindow.Map.IconSearch.Update();

		while #mapWindow.Map.Icons>tmpIconIndex do
			-- dispose of any unused controls that we already created
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseEnter=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseLeave=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseHover=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons].MouseClick=nil;
			mapWindow.Map.Icons[#mapWindow.Map.Icons]:SetVisible(false);-- need to invalidated the area where this control was draw to force a refresh
			table.remove(mapWindow.Map.Icons,#mapWindow.Map.Icons);
		end
		if mapWindow.Breadcrumbs~=nil and #mapWindow.Breadcrumbs>0 then
			mapWindow.Map.breadcrumbImage={};
			for tmpIconIndex=1,#mapWindow.Breadcrumbs do
				-- create array of small controls that can "pulse" to show the path followed
				mapWindow.Map.breadcrumbImage[tmpIconIndex]=Turbine.UI.Control();
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetParent(mapWindow.Map);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetSize(5,5);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetPosition(math.floor((mapWindow.Breadcrumbs[tmpIconIndex][1]*HFactor+HOffset)*XScale-2.5),math.floor((mapWindow.Breadcrumbs[tmpIconIndex][2]*VFactor+VOffset)*YScale-2.5));
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColor(breadcrumbColor);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetBackColorBlendMode(Turbine.UI.BlendMode.Color);
				mapWindow.Map.breadcrumbImage[tmpIconIndex]:SetZOrder(1000)
			end
			mapWindow.Map.breadcrumbImage[1].Update=function()
				RefreshBreadcrumbs();
			end
			mapWindow.Map.breadcrumbImage[1]:SetWantsUpdates(true);
		end
	end
end

AddMapItem=function(mapItem, V, H)
	local HFactor=mapInfo[mapWindow.CurrentMapID][6];
	local HOffset=mapInfo[mapWindow.CurrentMapID][7];
	local VFactor=mapInfo[mapWindow.CurrentMapID][8];
	local VOffset=mapInfo[mapWindow.CurrentMapID][9];

	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints+1]=Turbine.UI.Control();
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetPosition(math.floor(H*HFactor+HOffset)-9,math.floor(V*VFactor+VOffset)-9);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetSize(18,18);

	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]=Turbine.UI.Lotro.ItemControl();
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].V=V;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].H=H;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetPosition(-34,-34);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetSize(64,64);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetItem(mapItem);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetVisible(true);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=function(sender, args)
		if args.Button==2 then
			mapWindow:SetVisible(false);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(false)
			end
		end
	end
end
AddMapSkill=function(mapSkill, V, H)
	local HFactor=mapInfo[mapWindow.CurrentMapID][6];
	local HOffset=mapInfo[mapWindow.CurrentMapID][7];
	local VFactor=mapInfo[mapWindow.CurrentMapID][8];
	local VOffset=mapInfo[mapWindow.CurrentMapID][9];

	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints+1]=Turbine.UI.Control();
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetPosition(math.floor(H*HFactor+HOffset)-9,math.floor(V*VFactor+VOffset)-9);
	mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]:SetSize(18,18);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]=Turbine.UI.Lotro.Quickslot();
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].V=V;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].H=H;
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetParent(mapWindow.Map.MapPoints[#mapWindow.Map.MapPoints]);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetPosition(-34,-34);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetSize(64,64);
	local sc=Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Skill, string.format("0x%x",mapSkill));
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetShortcut(sc);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints]:SetVisible(true);
	mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=function(sender, args)
		if args.Button==2 then
			mapWindow:SetVisible(false);
			if BDDLegend~=nil then
				BDDLegend:SetVisible(false)
			end
		end
	end
end
LoadMapsIns=function()
	if mapWindow.CurrentMapID==1 then
		-- replace the old Map items with the skills
		if localPlayer:GetAlignment()== Turbine.Gameplay.Alignment.MonsterPlayer then
-- currently no way to determine whether players have a specific skill...
--			AddMapSkill(0x70028BBC,-12.3,-20.9); -- crude Grams
			AddMapSkill(0x70028BC1,-12.3,-20.9); -- grams
			AddMapSkill(0x70028BB7,-16.1,-20.9); -- crude lugz
			AddMapSkill(0x70028BB6,-17.1,-18.6); -- crude ta
			AddMapSkill(0x70028BBE,-14.63,-15.78); -- crude tr
			AddMapSkill(0x70028BB3,-13.4,-12.8); -- crude isen
			AddMapSkill(0x70028BBF,-18.3,-18.6); -- crude grimwood
			AddMapSkill(0x70028BB2,-14.2,-21.0); -- poor lugz
			AddMapSkill(0x70028BB1,-16.0,-17.0); -- poor ta
--			AddMapSkill(0x70028BB4,-17.8,-15.3); -- poor tr
			AddMapSkill(0x70028BB4,-15.7,-14.22); -- poor tr changed with Ettens revamp
			AddMapSkill(0x70028BAF,-14.7,-14.5); -- poor isen
			AddMapSkill(0x70028BB9,-18.9,-17.9); -- poor grimwood
			AddMapSkill(0x70028BB5,-14.54,-19.07); -- good lugz
			AddMapSkill(0x70028BC2,-17.9,-18.1); -- good ta
--			AddMapSkill(0x70028BB0,-15.7,-14.2); -- good tr
			AddMapSkill(0x70028BB0,-17.85,-15.33); -- good tr changed with Ettens revamp
			AddMapSkill(0x70028BC0,-11.5,-19.1); -- good isen
			AddMapSkill(0x70028BBD,-20.3,-16.8); -- good grimwood
		end

		-- search through bags looking for matches to the map names
		local tmpBackpack=localPlayer:GetBackpack();
		local tmpBPIndex;
		local tmpItem;
		local tmpCrudeGV;
		local addCrudeGV=false;
		for tmpBPIndex=1,tmpBackpack:GetSize() do
			tmpItem=tmpBackpack:GetItem(tmpBPIndex);
			if tmpItem~=nil then
				if tmpItem:GetName()==Resource[language][104] then
					tmpCrudeGV=tmpItem;
				elseif tmpItem:GetName()==Resource[language][105] then
					addCrudeGV=false;
					AddMapItem(tmpItem,-20.9,-13.4);
				end
			end
		end
		if addCrudeGV and tmpCrudeGV~=nil then
			AddMapItem(tmpCrudeGV,-20.9,-13.4);
		end
	else
	-- remove the map points
		while #mapWindow.Map.MapPoints>0 do
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseClick=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseHover=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseEnter=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseLeave=nil;
			mapWindow.Map.MapPoints.Item[#mapWindow.Map.MapPoints].MouseDown=nil;
			table.remove(mapWindow.Map.MapPoints.Item,#mapWindow.Map.MapPoints);
			table.remove(mapWindow.Map.MapPoints,#mapWindow.Map.MapPoints);

		end
	end
end

function mapWindow:SetLoadMinimized(value)
	if value==nil then value=false end;
	mapWindow.LoadMinimized=(value==true);
end
function mapWindow:GetLoadMinimized()
	return (mapWindow.LoadMinimized);
end

function mapWindow:SetEnabled(state)
	if mapWindow.ControlPanel.OptionsButton~=nil then
		mapWindow.ControlPanel.OptionsButton:SetMouseVisible(state);
	end
	mapWindow.ControlPanel.AnnotationsButton:SetMouseVisible(state);
end

function mapWindow:SetVisible(value)
	Turbine.UI.Lotro.Window.SetVisible( mapWindow, value );
	if BDDLegend~=nil then
		BDDLegend:SetVisible(BDDVis and value)
	end
end

function mapWindow:Update( sender, args )
	local tmpIndex;
	if loadingDefaults==1 then
		-- track the status of the Defaults plug
		for tmpIndex=1,#Turbine.PluginManager:GetLoadedPlugins() do
			if Turbine.PluginManager:GetLoadedPlugins()[tmpIndex].Name=="MoorMapDefaults" then
				loadingDefaults=2;
				break;
			end
		end
		saveOverlays=false;
	elseif loadingDefaults==2 then
		local found=false;
		for tmpIndex=1,#Turbine.PluginManager:GetLoadedPlugins() do
			if Turbine.PluginManager:GetLoadedPlugins()[tmpIndex].Name=="MoorMapDefaults" then
				found=true;
				break;
			end
		end
		if not found then
			mapWindow:SetWantsUpdates(false);
			loadingDefaults=0;
			Turbine.PluginManager.UnloadScriptState("MoorMapTerminator");
			-- at this point, we know that the default data has been written to disk, so it is safe to refresh the map
			-- reload the map list incase new maps were loaded
			mapWindow.MapSelect:ClearList();
			CreateMapList();
			RefreshMap(0); -- this will reload the current map, but force a reload of the annotations
			annotWindow:LoadAnnotationList();
		end
		saveOverlays=false;
	else
		if (Plugins["MoorMap"] ~= nil) and (not mapWindow.Loaded) then
			mapWindow.Loaded=true;
			Turbine.PluginManager.UnloadScriptState("MoorMapLoader");
			if not mapWindow.Refreshing then
				Turbine.Shell.WriteLine("MoorMap "..Plugins["MoorMap"]:GetVersion()..Resource[language][13]);
			end
			Plugins["MoorMap"].Unload = function(mapWindow,sender,args)
				UnloadPlugin();
			end
			-- check for defaults
			if loadingDefaults==3 then
				mapWindow.CurrentMapID=nil;
				AddDefaultOverlays();
				loadingDefaults=1;
			end
			-- check for Waypoint
			local tmpPlugins=Turbine.PluginManager.GetAvailablePlugins();
			local pluginIndex;
			for pluginIndex=1,#tmpPlugins do
				if tmpPlugins[pluginIndex].Name=="Waypoint" then
					WaypointInstalled=true;
					break;
				end
			end
			if WaypointInstalled then
				tmpPlugins=Turbine.PluginManager.GetLoadedPlugins();
				for pluginIndex=1,#tmpPlugins do
					if tmpPlugins[pluginIndex].Name=="Waypoint" then
						WaypointRunning=true;
						break;
					end
				end
				if (not WaypointRunning) and EnableWaypoint then
					Turbine.PluginManager.LoadPlugin("Waypoint");
					WaypointRunning=true;
				end
				optionsCanvas.WaypointCB:SetVisible(true);
				optionsCanvas.WaypointMsg:SetVisible(false);
			else
				optionsCanvas.WaypointCB:SetVisible(false);
				optionsCanvas.WaypointMsg:SetVisible(true);
			end
			if EnableWaypoint and WaypointRunning then
				mapWindow.Map.HoverWindow.Coord:SetForeColor(Turbine.UI.Color(.85,.75,.2));
			end

		elseif mapWindow.showPlayerLoc~=nil and mapWindow.showPlayerLoc==true then
			mapWindow.showPlayerLoc=nil
			mapWindow.PlayerIconVisible=true;
			-- show the player icon at mapWindow.playerNS, mapWindow.playerEW
			local X=math.floor(mapWindow.playerEW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
			local Y=math.floor(mapWindow.playerNS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
			if debug then
				Turbine.Shell.WriteLine("X:"..tostring(X).." Y:"..tostring(Y))
			end
			mapWindow.LocationIcon.X=X;
			mapWindow.LocationIcon.Y=Y;
			-- need to adjust for the stretching
			X=X*mapWindow:GetWidth()/mapInfo[mapWindow.CurrentMapID][4]-14
			Y=Y*mapWindow:GetHeight()/mapInfo[mapWindow.CurrentMapID][5]-14
			mapWindow.LocationIcon:SetPosition(X,Y);
			if mapWindow:IsVisible() then
				mapWindow.LocationIcon:SetVisible(true);
				mapWindow.LocationIcon:SetRotation({x=0,y=0,z=0-(mapWindow.Heading-90)});
			end
			mapWindow.LocationIcon:SetZOrder(101+#mapWindow.Map.Icons);

		elseif mapWindow.ExternalPing then
			mapWindow.ExternalPing=false;
			AddPing(mapWindow.PingNS,mapWindow.PingEW,mapWindow.PingName,mapWindow.PingDesc);
		else
			-- we've satisfied all update needs, turn off the updates
			mapWindow:SetWantsUpdates(false);
			if mapWindow.NeedsRefresh then
				mapWindow.NeedsRefresh=false;
				RefreshMap();
			end
		end
	end
end
mapWindow:LoadBreadcrumbs();
mapWindow:SetZOrder(mapWindow:GetZOrder()+1);
minWindow=MinimizedWindow();
if mapWindow:GetShowIconWhenMinimized() then
	if minWindow:GetUseMiniIcon() then
		minWindow:SetSize(16,16);
	else
		minWindow:SetSize(32,32);
	end
else
	minWindow:SetSize(0,0);
end

if priorDataVersion~=tostring(Plugins["MoorMap"]:GetVersion()) then
	-- need to read the "default data" and merge with existing data
	loadingDefaults=3;
	mapWindow:SetWantsUpdates(true);
	Turbine.PluginManager.LoadPlugin("MoorMapDefaults");
else
	CreateMapList();
	RefreshMap();
end

if mapWindow.LoadMinimized and (not mapWindow.Refreshing) then
	minWindow:SetVisible(true);
else
	mapWindow:SetVisible(true);
end
quickWindow:SetVisible(quickWindow.Displayed);

mapWindow:LoadOverlays();

breadcrumbWindow=Turbine.UI.Lotro.Window();
breadcrumbWindow:SetSize(440,200);
breadcrumbWindow:SetPosition((Turbine.UI.Display:GetWidth()-breadcrumbWindow:GetWidth())/2,(Turbine.UI.Display:GetHeight()-breadcrumbWindow:GetHeight())/2);
breadcrumbWindow:SetText(Resource[language][238]);
breadcrumbWindow.ColorLabel=Turbine.UI.Label();
breadcrumbWindow.ColorLabel:SetParent(breadcrumbWindow);
breadcrumbWindow.ColorLabel:SetSize(140,20);
breadcrumbWindow.ColorLabel:SetPosition(5,50);
breadcrumbWindow.ColorLabel:SetText(Resource[language][239]..":");
breadcrumbWindow.Color=ColorPicker();
breadcrumbWindow.Color:SetParent(breadcrumbWindow);
breadcrumbWindow.Color:SetPosition(breadcrumbWindow.ColorLabel:GetLeft()+breadcrumbWindow.ColorLabel:GetWidth()+5,breadcrumbWindow.ColorLabel:GetTop()-5);
breadcrumbWindow.Color:SetTrimColor(trimColor);
breadcrumbWindow.Color:SetColor(breadcrumbColor);
breadcrumbWindow.Color.ColorChanged=function()
	breadcrumbColor=breadcrumbWindow.Color:GetColor();
	if mapWindow~=nil and mapWindow.Map.breadcrumbImage~=nil then
		for index,image in ipairs(mapWindow.Map.breadcrumbImage) do
			image:SetBackColor(breadcrumbColor);
		end
	end
end
breadcrumbWindow.ClearLabel=Turbine.UI.Label();
breadcrumbWindow.ClearLabel:SetParent(breadcrumbWindow);
breadcrumbWindow.ClearLabel:SetSize(140,20);
breadcrumbWindow.ClearLabel:SetPosition(5,75);
breadcrumbWindow.ClearLabel:SetText(Resource[language][240]..":");
breadcrumbWindow.ClearButton=Turbine.UI.Lotro.Button();
breadcrumbWindow.ClearButton:SetParent(breadcrumbWindow);
breadcrumbWindow.ClearButton:SetSize(100,20);
breadcrumbWindow.ClearButton:SetPosition(breadcrumbWindow.ClearLabel:GetLeft()+breadcrumbWindow.ClearLabel:GetWidth()+5,breadcrumbWindow.ClearLabel:GetTop());
breadcrumbWindow.ClearButton:SetText(Resource[language][241]);
breadcrumbWindow.ClearButton.Click=function()
	if mapWindow.Map.breadcrumbImage~=nil then
		local imageCount=#mapWindow.Map.breadcrumbImage
		if imageCount>0 then
			mapWindow.Map.breadcrumbImage[1]:SetWantsUpdates(false);
			mapWindow.Map.breadcrumbImage[1].Update=nil;
		end
		local tmpIndex;
		for tmpIndex=imageCount,1,-1 do
			mapWindow.Map.breadcrumbImage[tmpIndex]:SetVisible(false);
			mapWindow.Map.breadcrumbImage[tmpIndex]=nil;
			mapWindow.Breadcrumbs[tmpIndex]=nil;
		end
	end
end

annotWindow=AnnotationsWindow();
debugWindow=DebugWindow();
import "GaranStuff.MoorMap.OptionsPanel"

annotWindow:SetZOrder(mapWindow:GetZOrder()+1);
overlayWindow:SetZOrder(annotWindow:GetZOrder()+1);
breadcrumbWindow:SetZOrder(overlayWindow:GetZOrder()+1);
debugWindow:SetZOrder(breadcrumbWindow:GetZOrder()+1);
if debug then debugWindow:SetVisible(true) end
popOL();
refreshOLList();
overlayWindow:SetLanguage();

if dataLoadError then
	-- warn the user and give them the opportunity to exit without saving
end

--GaranStuff.MoorMap.Table.Dump(_G)
--testdialog=PopUpDialog("test1","just testing with a really long message to see how multiple lines are handled. let's see how it handles 3 lines. and now, the coup-de-gras, let's give it 4 lines :)",3,"abcdefghi","just testing","hmmmm")
--testdialog=PopUpDialog("test1","just testing",3,"abcdefghi","just testing","hmmmm")
--testdialog.Buttons[2].Click=function(sender)
--	Turbine.Shell.WriteLine("button 2 pressed");
--	sender:GetParent():SetVisible(false);
--end

drawGrid=function()
	-- this function is currently only for debugging purposes to determine how sectional maps line up
	if GridLine==nil then
		GridLine={}
		GridLabel={}
	else
		-- remove the prior grid
		for k,v in GridLine do
			v:SetVisible(false);
			GridLine[k]=nil;
			GridLabel[k]:SetVisible(false);
			GridLabel[k]=nil;
		end
	end
	if mapWindow.CurrentMapID~=nil then
		local north=mapInfo[mapWindow.CurrentMapID][13]
		local south=mapInfo[mapWindow.CurrentMapID][15]
		local west=mapInfo[mapWindow.CurrentMapID][14]
		local east=mapInfo[mapWindow.CurrentMapID][16]
		-- determine the most suitable scale
		local delta=north-south;
		if delta>=50 then
			delta=10
		elseif delta>=20 then
			delta=5
		elseif delta>=5 then
			delta=1
		elseif delta>=2 then
			delta=.5
		else
			delta=.1
		end
		-- now find the min ns coord that falls on the map
		NS=math.floor(south/delta)*delta-delta
		EW=math.floor(west/delta)*delta-delta
		-- now generate grid lines for NS
		local gridIndex=1;

		while NS<=north+delta and gridIndex<100 do
			local Y=math.floor(NS*mapInfo[mapWindow.CurrentMapID][8]+mapInfo[mapWindow.CurrentMapID][9]);
			--get the y coordinate for this NS value
			-- draw a line from (0,y) to (displayWidth,y)
			GridLine[gridIndex]=Turbine.UI.Control();
			GridLine[gridIndex]:SetParent(mapWindow.Map);
			GridLine[gridIndex]:SetSize(mapWindow.Map:GetHeight()-100,1);
			GridLine[gridIndex]:SetPosition(100,Y);
			GridLine[gridIndex]:SetBackColor(Turbine.UI.Color.White);
			GridLabel[gridIndex]=Turbine.UI.Label();
			GridLabel[gridIndex]:SetParent(mapWindow.Map);
			GridLabel[gridIndex]:SetSize(100,20);
			GridLabel[gridIndex]:SetPosition(0,Y-10)
			GridLine[gridIndex]:SetMouseVisible(false);
			GridLabel[gridIndex]:SetMouseVisible(false);
			if NS>=0 then
				GridLabel[gridIndex]:SetText(tostring(NS).." N")
			else
				GridLabel[gridIndex]:SetText(tostring(0-NS).." S")
			end
			gridIndex=gridIndex+1;
			NS=NS+delta
		end

		-- now generate grid lines for EW
		while EW<=east+delta and gridIndex<200 do
			local X=math.floor(EW*mapInfo[mapWindow.CurrentMapID][6]+mapInfo[mapWindow.CurrentMapID][7]);
			GridLine[gridIndex]=Turbine.UI.Control();
			GridLine[gridIndex]:SetParent(mapWindow.Map);
			GridLine[gridIndex]:SetSize(1,mapWindow.Map:GetHeight()-80);
			GridLine[gridIndex]:SetPosition(X,80);
			GridLine[gridIndex]:SetBackColor(Turbine.UI.Color.White);
			GridLabel[gridIndex]=Turbine.UI.Label();
			GridLabel[gridIndex]:SetParent(mapWindow.Map);
			GridLabel[gridIndex]:SetSize(80,20);
			GridLabel[gridIndex]:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
			GridLabel[gridIndex]:SetPosition(X-40,40)
			GridLine[gridIndex]:SetMouseVisible(false);
			GridLabel[gridIndex]:SetMouseVisible(false);
			if EW>=0 then
				GridLabel[gridIndex]:SetText(tostring(EW).." E")
			else
				GridLabel[gridIndex]:SetText(tostring(0-EW).." W")
			end
			gridIndex=gridIndex+1;
			EW=EW+delta
		end
	end
end
